
#include <string>

static const std::string RADIISTRING = "# This is a comment line\n"
"H 12.0      # This is also a comment\n"
"C 12.0\n"
"N 12.0\n"
"O 12.0\n";

static const std::string PDBSTRING = "HEADER    RIBONUCLEASE INHIBITOR                  09-MAY-94   1BTA              \n"
"TITLE     THREE-DIMENSIONAL SOLUTION STRUCTURE AND 13C ASSIGNMENTS OF           \n"
"TITLE    2 BARSTAR USING NUCLEAR MAGNETIC RESONANCE SPECTROSCOPY                \n"
"COMPND    MOL_ID: 1;                                                            \n"
"COMPND   2 MOLECULE: BARSTAR;                                                   \n"
"COMPND   3 CHAIN: A;                                                            \n"
"COMPND   4 ENGINEERED: YES                                                      \n"
"SOURCE    MOL_ID: 1;                                                            \n"
"SOURCE   2 ORGANISM_SCIENTIFIC: BACILLUS AMYLOLIQUEFACIENS;                     \n"
"SOURCE   3 ORGANISM_TAXID: 1390                                                 \n"
"KEYWDS    RIBONUCLEASE INHIBITOR                                                \n"
"EXPDTA    SOLUTION NMR                                                          \n"
"AUTHOR    M.J.LUBIENSKI,M.BYCROFT,S.M.V.FREUND,A.R.FERSHT                       \n"
"REVDAT   2   24-FEB-09 1BTA    1       VERSN                                    \n"
"REVDAT   1   31-JUL-94 1BTA    0                                                \n"
"JRNL        AUTH   M.J.LUBIENSKI,M.BYCROFT,S.M.FREUND,A.R.FERSHT                \n"
"JRNL        TITL   THREE-DIMENSIONAL SOLUTION STRUCTURE AND 13C                 \n"
"JRNL        TITL 2 ASSIGNMENTS OF BARSTAR USING NUCLEAR MAGNETIC                \n"
"JRNL        TITL 3 RESONANCE SPECTROSCOPY.                                      \n"
"JRNL        REF    BIOCHEMISTRY                  V.  33  8866 1994              \n"
"JRNL        REFN                   ISSN 0006-2960                               \n"
"JRNL        PMID   8043574                                                      \n"
"JRNL        DOI    10.1021/BI00196A003                                          \n"
"REMARK   1                                                                      \n"
"REMARK   1 REFERENCE 1                                                          \n"
"REMARK   1  AUTH   R.W.HARTLEY                                                  \n"
"REMARK   1  TITL   BARNASE AND BARSTAR: TWO SMALL PROTEINS TO FOLD              \n"
"REMARK   1  TITL 2 AND FIT TOGETHER                                             \n"
"REMARK   1  REF    TRENDS BIOCHEM.SCI.           V.  14   450 1989              \n"
"REMARK   1  REFN                   ISSN 0968-0004                               \n"
"REMARK   2                                                                      \n"
"REMARK   2 RESOLUTION. NOT APPLICABLE.                                          \n"
"REMARK   3                                                                      \n"
"REMARK   3 REFINEMENT.                                                          \n"
"REMARK   3   PROGRAM     : X-PLOR                                               \n"
"REMARK   3   AUTHORS     : BRUNGER                                              \n"
"REMARK   3                                                                      \n"
"REMARK   3  OTHER REFINEMENT REMARKS: NULL                                      \n"
"REMARK   4                                                                      \n"
"REMARK   4 1BTA COMPLIES WITH FORMAT V. 3.15, 01-DEC-08                         \n"
"REMARK 100                                                                      \n"
"REMARK 100 THIS ENTRY HAS BEEN PROCESSED BY BNL.                                \n"
"REMARK 210                                                                      \n"
"REMARK 210 EXPERIMENTAL DETAILS                                                 \n"
"REMARK 210  EXPERIMENT TYPE                : NMR                                \n"
"REMARK 210  TEMPERATURE           (KELVIN) : NULL                               \n"
"REMARK 210  PH                             : NULL                               \n"
"REMARK 210  IONIC STRENGTH                 : NULL                               \n"
"REMARK 210  PRESSURE                       : NULL                               \n"
"REMARK 210  SAMPLE CONTENTS                : NULL                               \n"
"REMARK 210                                                                      \n"
"REMARK 210  NMR EXPERIMENTS CONDUCTED      : NULL                               \n"
"REMARK 210  SPECTROMETER FIELD STRENGTH    : NULL                               \n"
"REMARK 210  SPECTROMETER MODEL             : NULL                               \n"
"REMARK 210  SPECTROMETER MANUFACTURER      : NULL                               \n"
"REMARK 210                                                                      \n"
"REMARK 210  STRUCTURE DETERMINATION.                                            \n"
"REMARK 210   SOFTWARE USED                 : NULL                               \n"
"REMARK 210   METHOD USED                   : NULL                               \n"
"REMARK 210                                                                      \n"
"REMARK 210 CONFORMERS, NUMBER CALCULATED   : NULL                               \n"
"REMARK 210 CONFORMERS, NUMBER SUBMITTED    : 1                                  \n"
"REMARK 210 CONFORMERS, SELECTION CRITERIA  : NULL                               \n"
"REMARK 210                                                                      \n"
"REMARK 210 BEST REPRESENTATIVE CONFORMER IN THIS ENSEMBLE : NULL                \n"
"REMARK 210                                                                      \n"
"REMARK 210 REMARK: NULL                                                         \n"
"REMARK 215                                                                      \n"
"REMARK 215 NMR STUDY                                                            \n"
"REMARK 215 THE COORDINATES IN THIS ENTRY WERE GENERATED FROM SOLUTION           \n"
"REMARK 215 NMR DATA.  PROTEIN DATA BANK CONVENTIONS REQUIRE THAT                \n"
"REMARK 215 CRYST1 AND SCALE RECORDS BE INCLUDED, BUT THE VALUES ON              \n"
"REMARK 215 THESE RECORDS ARE MEANINGLESS.                                       \n"
"REMARK 500                                                                      \n"
"REMARK 500 GEOMETRY AND STEREOCHEMISTRY                                         \n"
"REMARK 500 SUBTOPIC: TORSION ANGLES                                             \n"
"REMARK 500                                                                      \n"
"REMARK 500 TORSION ANGLES OUTSIDE THE EXPECTED RAMACHANDRAN REGIONS:            \n"
"REMARK 500 (M=MODEL NUMBER; RES=RESIDUE NAME; C=CHAIN IDENTIFIER;               \n"
"REMARK 500 SSEQ=SEQUENCE NUMBER; I=INSERTION CODE).                             \n"
"REMARK 500                                                                      \n"
"REMARK 500 STANDARD TABLE:                                                      \n"
"REMARK 500 FORMAT:(10X,I3,1X,A3,1X,A1,I4,A1,4X,F7.2,3X,F7.2)                    \n"
"REMARK 500                                                                      \n"
"REMARK 500 EXPECTED VALUES: GJ KLEYWEGT AND TA JONES (1996). PHI/PSI-           \n"
"REMARK 500 CHOLOGY: RAMACHANDRAN REVISITED. STRUCTURE 4, 1395 - 1400            \n"
"REMARK 500                                                                      \n"
"REMARK 500  M RES CSSEQI        PSI       PHI                                   \n"
"REMARK 500    PRO A  27     -179.66    -57.36                                   \n"
"REMARK 500    TYR A  30      105.85    -38.41                                   \n"
"REMARK 500    GLU A  32        3.60     50.07                                   \n"
"REMARK 500    TRP A  44      -66.63    177.13                                   \n"
"REMARK 500    LEU A  62      -32.03    -33.51                                   \n"
"REMARK 500    GLU A  64      106.99    -12.37                                   \n"
"REMARK 500    ASN A  65       32.13     73.69                                   \n"
"REMARK 500    ASP A  83       65.33   -109.29                                   \n"
"REMARK 500    THR A  85       98.90    -52.92                                   \n"
"REMARK 500                                                                      \n"
"REMARK 500 REMARK: NULL                                                         \n"
"REMARK 500                                                                      \n"
"REMARK 500 GEOMETRY AND STEREOCHEMISTRY                                         \n"
"REMARK 500 SUBTOPIC: PLANAR GROUPS                                              \n"
"REMARK 500                                                                      \n"
"REMARK 500 PLANAR GROUPS IN THE FOLLOWING RESIDUES HAVE A TOTAL                 \n"
"REMARK 500 RMS DISTANCE OF ALL ATOMS FROM THE BEST-FIT PLANE                    \n"
"REMARK 500 BY MORE THAN AN EXPECTED VALUE OF 6*RMSD, WITH AN                    \n"
"REMARK 500 RMSD 0.02 ANGSTROMS, OR AT LEAST ONE ATOM HAS                        \n"
"REMARK 500 AN RMSD GREATER THAN THIS VALUE                                      \n"
"REMARK 500 (M=MODEL NUMBER; RES=RESIDUE NAME; C=CHAIN IDENTIFIER;               \n"
"REMARK 500 SSEQ=SEQUENCE NUMBER; I=INSERTION CODE).                             \n"
"REMARK 500                                                                      \n"
"REMARK 500  M RES CSSEQI        RMS     TYPE                                    \n"
"REMARK 500    ARG A  11         0.17    SIDE_CHAIN                              \n"
"REMARK 500    ARG A  54         0.31    SIDE_CHAIN                              \n"
"REMARK 500    ARG A  75         0.11    SIDE_CHAIN                              \n"
"REMARK 500                                                                      \n"
"REMARK 500 REMARK: NULL                                                         \n"
"REMARK 900                                                                      \n"
"REMARK 900 RELATED ENTRIES                                                      \n"
"REMARK 900 RELATED ID: 1BTB   RELATED DB: PDB                                   \n"
"DBREF  1BTA A    1    89  UNP    P11540   BARS_BACAM       1     89             \n"
"SEQRES   1 A   89  LYS LYS ALA VAL ILE ASN GLY GLU GLN ILE ARG SER ILE          \n"
"SEQRES   2 A   89  SER ASP LEU HIS GLN THR LEU LYS LYS GLU LEU ALA LEU          \n"
"SEQRES   3 A   89  PRO GLU TYR TYR GLY GLU ASN LEU ASP ALA LEU TRP ASP          \n"
"SEQRES   4 A   89  CYS LEU THR GLY TRP VAL GLU TYR PRO LEU VAL LEU GLU          \n"
"SEQRES   5 A   89  TRP ARG GLN PHE GLU GLN SER LYS GLN LEU THR GLU ASN          \n"
"SEQRES   6 A   89  GLY ALA GLU SER VAL LEU GLN VAL PHE ARG GLU ALA LYS          \n"
"SEQRES   7 A   89  ALA GLU GLY CYS ASP ILE THR ILE ILE LEU SER                  \n"
"HELIX    1  H1 SER A   14  ALA A   25  1                                  12    \n"
"HELIX    2  H2 ASN A   33  GLY A   43  1                                  11    \n"
"HELIX    3  H3 PHE A   56  THR A   63  1                                   8    \n"
"HELIX    4  H4 GLU A   68  GLY A   81  1                                  14    \n"
"SHEET    1 SH1 3 LYS A   1  ASN A   6  0                                        \n"
"SHEET    2 SH1 3 LEU A  49  ARG A  54  1                                        \n"
"SHEET    3 SH1 3 ASP A  83  SER A  89  1                                        \n"
"CISPEP   1 TYR A   47    PRO A   48          0         0.92                     \n"
"CRYST1    1.000    1.000    1.000  90.00  90.00  90.00 P 1           1          \n"
"ORIGX1      1.000000  0.000000  0.000000        0.00000                         \n"
"ORIGX2      0.000000  1.000000  0.000000        0.00000                         \n"
"ORIGX3      0.000000  0.000000  1.000000        0.00000                         \n"
"SCALE1      1.000000  0.000000  0.000000        0.00000                         \n"
"SCALE2      0.000000  1.000000  0.000000        0.00000                         \n"
"SCALE3      0.000000  0.000000  1.000000        0.00000                         \n"
"ATOM      1  N   LYS A   1      -8.655   5.770   8.371  1.00  1.40           N  \n"
"ATOM      2  CA  LYS A   1      -7.542   5.187   9.163  1.00  0.52           C  \n"
"ATOM      3  C   LYS A   1      -6.210   5.619   8.561  1.00  0.39           C  \n"
"ATOM      4  O   LYS A   1      -6.156   6.468   7.693  1.00  0.33           O  \n"
"ATOM      5  CB  LYS A   1      -7.641   3.666   9.159  1.00  1.53           C  \n"
"ATOM      6  CG  LYS A   1      -7.750   3.179  10.602  1.00  2.38           C  \n"
"ATOM      7  CD  LYS A   1      -9.158   3.466  11.126  1.00  3.11           C  \n"
"ATOM      8  CE  LYS A   1      -9.145   4.744  11.965  1.00  3.58           C  \n"
"ATOM      9  NZ  LYS A   1      -9.497   4.416  13.375  1.00  4.21           N  \n"
"ATOM     10  H1  LYS A   1      -8.409   6.745   8.105  1.00  1.94           H  \n"
"ATOM     11  H2  LYS A   1      -8.809   5.202   7.514  1.00  2.04           H  \n"
"ATOM     12  H3  LYS A   1      -9.523   5.775   8.942  1.00  1.89           H  \n"
"ATOM     13  HA  LYS A   1      -7.604   5.545  10.180  1.00  1.19           H  \n"
"ATOM     14  HB2 LYS A   1      -8.516   3.361   8.603  1.00  1.84           H  \n"
"ATOM     15  HB3 LYS A   1      -6.756   3.246   8.705  1.00  2.02           H  \n"
"ATOM     16  HG2 LYS A   1      -7.558   2.117  10.640  1.00  2.57           H  \n"
"ATOM     17  HG3 LYS A   1      -7.025   3.703  11.212  1.00  2.64           H  \n"
"ATOM     18  HD2 LYS A   1      -9.833   3.592  10.290  1.00  3.38           H  \n"
"ATOM     19  HD3 LYS A   1      -9.491   2.640  11.735  1.00  3.41           H  \n"
"ATOM     20  HE2 LYS A   1      -8.160   5.186  11.934  1.00  3.84           H  \n"
"ATOM     21  HE3 LYS A   1      -9.866   5.442  11.568  1.00  3.71           H  \n"
"ATOM     22  HZ1 LYS A   1      -9.394   3.393  13.530  1.00  4.40           H  \n"
"ATOM     23  HZ2 LYS A   1      -8.864   4.932  14.019  1.00  4.64           H  \n"
"ATOM     24  HZ3 LYS A   1     -10.481   4.694  13.559  1.00  4.45           H  \n"
"ATOM     25  N   LYS A   2      -5.128   5.066   9.028  1.00  0.51           N  \n"
"ATOM     26  CA  LYS A   2      -3.813   5.485   8.490  1.00  0.44           C  \n"
"ATOM     27  C   LYS A   2      -2.931   4.277   8.172  1.00  0.41           C  \n"
"ATOM     28  O   LYS A   2      -3.040   3.218   8.757  1.00  0.58           O  \n"
"ATOM     29  CB  LYS A   2      -3.138   6.383   9.534  1.00  0.63           C  \n"
"ATOM     30  CG  LYS A   2      -1.624   6.134   9.604  1.00  1.04           C  \n"
"ATOM     31  CD  LYS A   2      -0.967   7.224  10.453  1.00  0.93           C  \n"
"ATOM     32  CE  LYS A   2       0.116   7.929   9.634  1.00  0.63           C  \n"
"ATOM     33  NZ  LYS A   2       1.057   8.630  10.551  1.00  1.43           N  \n"
"ATOM     34  H   LYS A   2      -5.180   4.399   9.744  1.00  0.70           H  \n"
"ATOM     35  HA  LYS A   2      -3.967   6.055   7.587  1.00  0.38           H  \n"
"ATOM     36  HB2 LYS A   2      -3.311   7.411   9.268  1.00  1.42           H  \n"
"ATOM     37  HB3 LYS A   2      -3.580   6.180  10.499  1.00  1.18           H  \n"
"ATOM     38  HG2 LYS A   2      -1.438   5.168  10.051  1.00  1.70           H  \n"
"ATOM     39  HG3 LYS A   2      -1.208   6.157   8.608  1.00  1.84           H  \n"
"ATOM     40  HD2 LYS A   2      -1.716   7.942  10.757  1.00  1.28           H  \n"
"ATOM     41  HD3 LYS A   2      -0.521   6.777  11.329  1.00  1.30           H  \n"
"ATOM     42  HE2 LYS A   2       0.660   7.199   9.052  1.00  1.03           H  \n"
"ATOM     43  HE3 LYS A   2      -0.343   8.648   8.971  1.00  0.93           H  \n"
"ATOM     44  HZ1 LYS A   2       0.538   8.961  11.391  1.00  1.83           H  \n"
"ATOM     45  HZ2 LYS A   2       1.809   7.974  10.844  1.00  1.98           H  \n"
"ATOM     46  HZ3 LYS A   2       1.480   9.442  10.061  1.00  1.99           H  \n"
"ATOM     47  N   ALA A   3      -2.040   4.474   7.250  1.00  0.27           N  \n"
"ATOM     48  CA  ALA A   3      -1.086   3.403   6.848  1.00  0.30           C  \n"
"ATOM     49  C   ALA A   3       0.316   4.013   6.751  1.00  0.30           C  \n"
"ATOM     50  O   ALA A   3       0.469   5.207   6.586  1.00  0.54           O  \n"
"ATOM     51  CB  ALA A   3      -1.491   2.834   5.486  1.00  0.34           C  \n"
"ATOM     52  H   ALA A   3      -1.991   5.353   6.827  1.00  0.25           H  \n"
"ATOM     53  HA  ALA A   3      -1.088   2.618   7.589  1.00  0.34           H  \n"
"ATOM     54  HB1 ALA A   3      -2.257   3.457   5.050  1.00  1.08           H  \n"
"ATOM     55  HB2 ALA A   3      -0.630   2.813   4.834  1.00  1.05           H  \n"
"ATOM     56  HB3 ALA A   3      -1.871   1.831   5.612  1.00  1.07           H  \n"
"ATOM     57  N   VAL A   4       1.342   3.214   6.860  1.00  0.30           N  \n"
"ATOM     58  CA  VAL A   4       2.725   3.769   6.780  1.00  0.27           C  \n"
"ATOM     59  C   VAL A   4       3.643   2.773   6.074  1.00  0.26           C  \n"
"ATOM     60  O   VAL A   4       3.842   1.667   6.535  1.00  0.33           O  \n"
"ATOM     61  CB  VAL A   4       3.250   4.021   8.194  1.00  0.30           C  \n"
"ATOM     62  CG1 VAL A   4       4.617   4.709   8.122  1.00  0.35           C  \n"
"ATOM     63  CG2 VAL A   4       2.262   4.915   8.946  1.00  0.35           C  \n"
"ATOM     64  H   VAL A   4       1.206   2.255   6.999  1.00  0.50           H  \n"
"ATOM     65  HA  VAL A   4       2.710   4.699   6.231  1.00  0.27           H  \n"
"ATOM     66  HB  VAL A   4       3.351   3.078   8.712  1.00  0.32           H  \n"
"ATOM     67 HG11 VAL A   4       4.554   5.568   7.472  1.00  1.08           H  \n"
"ATOM     68 HG12 VAL A   4       4.912   5.026   9.111  1.00  1.02           H  \n"
"ATOM     69 HG13 VAL A   4       5.350   4.015   7.733  1.00  1.13           H  \n"
"ATOM     70 HG21 VAL A   4       1.782   5.587   8.250  1.00  1.05           H  \n"
"ATOM     71 HG22 VAL A   4       1.514   4.300   9.425  1.00  0.98           H  \n"
"ATOM     72 HG23 VAL A   4       2.791   5.488   9.694  1.00  1.11           H  \n"
"ATOM     73  N   ILE A   5       4.210   3.153   4.961  1.00  0.23           N  \n"
"ATOM     74  CA  ILE A   5       5.117   2.213   4.245  1.00  0.23           C  \n"
"ATOM     75  C   ILE A   5       6.570   2.567   4.552  1.00  0.25           C  \n"
"ATOM     76  O   ILE A   5       7.176   3.388   3.893  1.00  0.27           O  \n"
"ATOM     77  CB  ILE A   5       4.879   2.300   2.742  1.00  0.23           C  \n"
"ATOM     78  CG1 ILE A   5       3.360   2.231   2.478  1.00  0.23           C  \n"
"ATOM     79  CG2 ILE A   5       5.620   1.142   2.061  1.00  0.24           C  \n"
"ATOM     80  CD1 ILE A   5       3.034   1.246   1.346  1.00  0.22           C  \n"
"ATOM     81  H   ILE A   5       4.044   4.052   4.602  1.00  0.24           H  \n"
"ATOM     82  HA  ILE A   5       4.920   1.205   4.580  1.00  0.23           H  \n"
"ATOM     83  HB  ILE A   5       5.268   3.239   2.372  1.00  0.25           H  \n"
"ATOM     84 HG12 ILE A   5       2.860   1.912   3.380  1.00  0.25           H  \n"
"ATOM     85 HG13 ILE A   5       3.005   3.214   2.207  1.00  0.27           H  \n"
"ATOM     86 HG21 ILE A   5       6.584   1.008   2.531  1.00  1.02           H  \n"
"ATOM     87 HG22 ILE A   5       5.042   0.236   2.162  1.00  1.06           H  \n"
"ATOM     88 HG23 ILE A   5       5.758   1.366   1.015  1.00  1.03           H  \n"
"ATOM     89 HD11 ILE A   5       3.776   1.335   0.567  1.00  1.05           H  \n"
"ATOM     90 HD12 ILE A   5       3.039   0.238   1.736  1.00  1.01           H  \n"
"ATOM     91 HD13 ILE A   5       2.058   1.473   0.942  1.00  1.05           H  \n"
"ATOM     92  N   ASN A   6       7.134   1.947   5.547  1.00  0.27           N  \n"
"ATOM     93  CA  ASN A   6       8.545   2.232   5.905  1.00  0.31           C  \n"
"ATOM     94  C   ASN A   6       9.466   1.399   5.009  1.00  0.31           C  \n"
"ATOM     95  O   ASN A   6       9.611   0.207   5.189  1.00  0.35           O  \n"
"ATOM     96  CB  ASN A   6       8.759   1.859   7.370  1.00  0.37           C  \n"
"ATOM     97  CG  ASN A   6       8.067   2.890   8.264  1.00  0.65           C  \n"
"ATOM     98  OD1 ASN A   6       7.534   3.869   7.782  1.00  1.48           O  \n"
"ATOM     99  ND2 ASN A   6       8.054   2.711   9.557  1.00  1.13           N  \n"
"ATOM    100  H   ASN A   6       6.628   1.287   6.062  1.00  0.28           H  \n"
"ATOM    101  HA  ASN A   6       8.751   3.283   5.764  1.00  0.32           H  \n"
"ATOM    102  HB2 ASN A   6       8.338   0.881   7.556  1.00  0.46           H  \n"
"ATOM    103  HB3 ASN A   6       9.810   1.847   7.587  1.00  0.35           H  \n"
"ATOM    104 HD21 ASN A   6       8.484   1.922   9.947  1.00  1.84           H  \n"
"ATOM    105 HD22 ASN A   6       7.613   3.366  10.138  1.00  1.23           H  \n"
"ATOM    106  N   GLY A   7      10.078   2.017   4.035  1.00  0.33           N  \n"
"ATOM    107  CA  GLY A   7      10.976   1.261   3.114  1.00  0.36           C  \n"
"ATOM    108  C   GLY A   7      12.182   0.718   3.879  1.00  0.35           C  \n"
"ATOM    109  O   GLY A   7      12.583  -0.414   3.694  1.00  0.46           O  \n"
"ATOM    110  H   GLY A   7       9.938   2.978   3.900  1.00  0.36           H  \n"
"ATOM    111  HA2 GLY A   7      10.428   0.436   2.685  1.00  0.39           H  \n"
"ATOM    112  HA3 GLY A   7      11.318   1.915   2.327  1.00  0.41           H  \n"
"ATOM    113  N   GLU A   8      12.767   1.509   4.735  1.00  0.38           N  \n"
"ATOM    114  CA  GLU A   8      13.946   1.022   5.505  1.00  0.43           C  \n"
"ATOM    115  C   GLU A   8      13.659  -0.390   6.019  1.00  0.39           C  \n"
"ATOM    116  O   GLU A   8      14.559  -1.170   6.260  1.00  0.45           O  \n"
"ATOM    117  CB  GLU A   8      14.207   1.950   6.696  1.00  0.53           C  \n"
"ATOM    118  CG  GLU A   8      14.064   3.409   6.256  1.00  1.39           C  \n"
"ATOM    119  CD  GLU A   8      14.660   4.324   7.328  1.00  1.74           C  \n"
"ATOM    120  OE1 GLU A   8      14.225   4.232   8.464  1.00  2.30           O  \n"
"ATOM    121  OE2 GLU A   8      15.540   5.100   6.994  1.00  2.19           O  \n"
"ATOM    122  H   GLU A   8      12.430   2.419   4.873  1.00  0.47           H  \n"
"ATOM    123  HA  GLU A   8      14.814   1.003   4.863  1.00  0.46           H  \n"
"ATOM    124  HB2 GLU A   8      13.494   1.739   7.479  1.00  1.12           H  \n"
"ATOM    125  HB3 GLU A   8      15.208   1.785   7.067  1.00  1.14           H  \n"
"ATOM    126  HG2 GLU A   8      14.587   3.557   5.322  1.00  2.04           H  \n"
"ATOM    127  HG3 GLU A   8      13.019   3.645   6.127  1.00  2.01           H  \n"
"ATOM    128  N   GLN A   9      12.408  -0.720   6.195  1.00  0.35           N  \n"
"ATOM    129  CA  GLN A   9      12.051  -2.069   6.699  1.00  0.38           C  \n"
"ATOM    130  C   GLN A   9      11.745  -3.001   5.523  1.00  0.35           C  \n"
"ATOM    131  O   GLN A   9      12.213  -4.121   5.468  1.00  0.40           O  \n"
"ATOM    132  CB  GLN A   9      10.811  -1.937   7.578  1.00  0.43           C  \n"
"ATOM    133  CG  GLN A   9      11.027  -0.819   8.600  1.00  0.50           C  \n"
"ATOM    134  CD  GLN A   9      11.790  -1.365   9.805  1.00  1.06           C  \n"
"ATOM    135  OE1 GLN A   9      12.979  -1.155   9.931  1.00  1.97           O  \n"
"ATOM    136  NE2 GLN A   9      11.151  -2.059  10.705  1.00  1.49           N  \n"
"ATOM    137  H   GLN A   9      11.697  -0.075   6.004  1.00  0.34           H  \n"
"ATOM    138  HA  GLN A   9      12.865  -2.469   7.278  1.00  0.42           H  \n"
"ATOM    139  HB2 GLN A   9       9.964  -1.691   6.955  1.00  0.41           H  \n"
"ATOM    140  HB3 GLN A   9      10.628  -2.868   8.092  1.00  0.49           H  \n"
"ATOM    141  HG2 GLN A   9      11.597  -0.022   8.145  1.00  0.88           H  \n"
"ATOM    142  HG3 GLN A   9      10.071  -0.437   8.923  1.00  0.84           H  \n"
"ATOM    143 HE21 GLN A   9      10.190  -2.227  10.605  1.00  1.89           H  \n"
"ATOM    144 HE22 GLN A   9      11.631  -2.412  11.483  1.00  1.96           H  \n"
"ATOM    145  N   ILE A  10      10.952  -2.550   4.591  1.00  0.32           N  \n"
"ATOM    146  CA  ILE A  10      10.597  -3.408   3.424  1.00  0.34           C  \n"
"ATOM    147  C   ILE A  10      11.825  -4.171   2.934  1.00  0.31           C  \n"
"ATOM    148  O   ILE A  10      12.893  -3.617   2.765  1.00  0.35           O  \n"
"ATOM    149  CB  ILE A  10      10.059  -2.546   2.281  1.00  0.37           C  \n"
"ATOM    150  CG1 ILE A  10       8.683  -2.005   2.655  1.00  0.51           C  \n"
"ATOM    151  CG2 ILE A  10       9.933  -3.402   1.018  1.00  0.35           C  \n"
"ATOM    152  CD1 ILE A  10       7.689  -3.158   2.715  1.00  0.78           C  \n"
"ATOM    153  H   ILE A  10      10.579  -1.650   4.664  1.00  0.32           H  \n"
"ATOM    154  HA  ILE A  10       9.838  -4.114   3.723  1.00  0.41           H  \n"
"ATOM    155  HB  ILE A  10      10.735  -1.725   2.095  1.00  0.39           H  \n"
"ATOM    156 HG12 ILE A  10       8.735  -1.522   3.618  1.00  1.17           H  \n"
"ATOM    157 HG13 ILE A  10       8.360  -1.296   1.909  1.00  1.20           H  \n"
"ATOM    158 HG21 ILE A  10       9.793  -4.438   1.298  1.00  1.04           H  \n"
"ATOM    159 HG22 ILE A  10       9.083  -3.068   0.441  1.00  1.05           H  \n"
"ATOM    160 HG23 ILE A  10      10.831  -3.305   0.428  1.00  1.04           H  \n"
"ATOM    161 HD11 ILE A  10       7.647  -3.649   1.751  1.00  1.35           H  \n"
"ATOM    162 HD12 ILE A  10       8.005  -3.863   3.468  1.00  1.43           H  \n"
"ATOM    163 HD13 ILE A  10       6.713  -2.774   2.970  1.00  1.54           H  \n"
"ATOM    164  N   ARG A  11      11.668  -5.440   2.692  1.00  0.33           N  \n"
"ATOM    165  CA  ARG A  11      12.794  -6.261   2.200  1.00  0.37           C  \n"
"ATOM    166  C   ARG A  11      12.423  -6.834   0.830  1.00  0.39           C  \n"
"ATOM    167  O   ARG A  11      13.251  -7.368   0.120  1.00  0.48           O  \n"
"ATOM    168  CB  ARG A  11      13.035  -7.400   3.184  1.00  0.50           C  \n"
"ATOM    169  CG  ARG A  11      13.677  -6.844   4.458  1.00  0.57           C  \n"
"ATOM    170  CD  ARG A  11      15.105  -7.376   4.589  1.00  1.27           C  \n"
"ATOM    171  NE  ARG A  11      15.489  -7.404   6.030  1.00  1.87           N  \n"
"ATOM    172  CZ  ARG A  11      16.544  -8.065   6.417  1.00  2.53           C  \n"
"ATOM    173  NH1 ARG A  11      16.881  -9.170   5.815  1.00  3.26           N  \n"
"ATOM    174  NH2 ARG A  11      17.261  -7.620   7.412  1.00  2.99           N  \n"
"ATOM    175  H   ARG A  11      10.797  -5.858   2.830  1.00  0.36           H  \n"
"ATOM    176  HA  ARG A  11      13.684  -5.654   2.117  1.00  0.37           H  \n"
"ATOM    177  HB2 ARG A  11      12.092  -7.867   3.429  1.00  0.56           H  \n"
"ATOM    178  HB3 ARG A  11      13.687  -8.122   2.738  1.00  0.55           H  \n"
"ATOM    179  HG2 ARG A  11      13.698  -5.765   4.408  1.00  0.94           H  \n"
"ATOM    180  HG3 ARG A  11      13.100  -7.153   5.317  1.00  0.87           H  \n"
"ATOM    181  HD2 ARG A  11      15.156  -8.374   4.183  1.00  1.84           H  \n"
"ATOM    182  HD3 ARG A  11      15.781  -6.731   4.046  1.00  1.87           H  \n"
"ATOM    183  HE  ARG A  11      14.946  -6.924   6.690  1.00  2.29           H  \n"
"ATOM    184 HH11 ARG A  11      16.331  -9.515   5.056  1.00  3.46           H  \n"
"ATOM    185 HH12 ARG A  11      17.690  -9.677   6.115  1.00  3.88           H  \n"
"ATOM    186 HH21 ARG A  11      17.000  -6.773   7.874  1.00  3.03           H  \n"
"ATOM    187 HH22 ARG A  11      18.069  -8.126   7.711  1.00  3.64           H  \n"
"ATOM    188  N   SER A  12      11.174  -6.725   0.458  1.00  0.37           N  \n"
"ATOM    189  CA  SER A  12      10.732  -7.258  -0.860  1.00  0.45           C  \n"
"ATOM    190  C   SER A  12       9.270  -6.869  -1.096  1.00  0.42           C  \n"
"ATOM    191  O   SER A  12       8.619  -6.289  -0.242  1.00  0.37           O  \n"
"ATOM    192  CB  SER A  12      10.862  -8.781  -0.865  1.00  0.56           C  \n"
"ATOM    193  OG  SER A  12      11.282  -9.221   0.419  1.00  1.44           O  \n"
"ATOM    194  H   SER A  12      10.524  -6.290   1.047  1.00  0.35           H  \n"
"ATOM    195  HA  SER A  12      11.348  -6.840  -1.643  1.00  0.48           H  \n"
"ATOM    196  HB2 SER A  12       9.908  -9.225  -1.097  1.00  1.21           H  \n"
"ATOM    197  HB3 SER A  12      11.585  -9.077  -1.613  1.00  1.13           H  \n"
"ATOM    198  HG  SER A  12      11.282 -10.182   0.418  1.00  1.77           H  \n"
"ATOM    199  N   ILE A  13       8.741  -7.185  -2.245  1.00  0.47           N  \n"
"ATOM    200  CA  ILE A  13       7.324  -6.831  -2.520  1.00  0.46           C  \n"
"ATOM    201  C   ILE A  13       6.445  -7.446  -1.435  1.00  0.41           C  \n"
"ATOM    202  O   ILE A  13       5.579  -6.799  -0.887  1.00  0.36           O  \n"
"ATOM    203  CB  ILE A  13       6.908  -7.370  -3.892  1.00  0.56           C  \n"
"ATOM    204  CG1 ILE A  13       5.570  -6.749  -4.313  1.00  0.63           C  \n"
"ATOM    205  CG2 ILE A  13       6.753  -8.888  -3.812  1.00  0.64           C  \n"
"ATOM    206  CD1 ILE A  13       5.564  -5.246  -4.010  1.00  0.57           C  \n"
"ATOM    207  H   ILE A  13       9.272  -7.656  -2.921  1.00  0.52           H  \n"
"ATOM    208  HA  ILE A  13       7.218  -5.757  -2.502  1.00  0.43           H  \n"
"ATOM    209  HB  ILE A  13       7.666  -7.126  -4.620  1.00  0.56           H  \n"
"ATOM    210 HG12 ILE A  13       5.423  -6.902  -5.372  1.00  0.75           H  \n"
"ATOM    211 HG13 ILE A  13       4.772  -7.226  -3.768  1.00  0.66           H  \n"
"ATOM    212 HG21 ILE A  13       7.675  -9.325  -3.457  1.00  1.21           H  \n"
"ATOM    213 HG22 ILE A  13       5.953  -9.131  -3.129  1.00  1.28           H  \n"
"ATOM    214 HG23 ILE A  13       6.522  -9.279  -4.792  1.00  1.15           H  \n"
"ATOM    215 HD11 ILE A  13       6.577  -4.869  -4.027  1.00  1.10           H  \n"
"ATOM    216 HD12 ILE A  13       4.976  -4.730  -4.755  1.00  1.16           H  \n"
"ATOM    217 HD13 ILE A  13       5.135  -5.077  -3.032  1.00  1.10           H  \n"
"ATOM    218  N   SER A  14       6.669  -8.690  -1.109  1.00  0.46           N  \n"
"ATOM    219  CA  SER A  14       5.851  -9.332  -0.047  1.00  0.44           C  \n"
"ATOM    220  C   SER A  14       5.859  -8.424   1.179  1.00  0.37           C  \n"
"ATOM    221  O   SER A  14       4.837  -8.162   1.781  1.00  0.35           O  \n"
"ATOM    222  CB  SER A  14       6.453 -10.689   0.312  1.00  0.50           C  \n"
"ATOM    223  OG  SER A  14       5.481 -11.469   0.996  1.00  1.07           O  \n"
"ATOM    224  H   SER A  14       7.381  -9.195  -1.556  1.00  0.51           H  \n"
"ATOM    225  HA  SER A  14       4.837  -9.463  -0.397  1.00  0.44           H  \n"
"ATOM    226  HB2 SER A  14       6.749 -11.201  -0.588  1.00  0.80           H  \n"
"ATOM    227  HB3 SER A  14       7.320 -10.541   0.942  1.00  0.85           H  \n"
"ATOM    228  HG  SER A  14       5.314 -12.257   0.474  1.00  1.49           H  \n"
"ATOM    229  N   ASP A  15       7.009  -7.928   1.541  1.00  0.34           N  \n"
"ATOM    230  CA  ASP A  15       7.097  -7.021   2.709  1.00  0.30           C  \n"
"ATOM    231  C   ASP A  15       6.187  -5.819   2.475  1.00  0.24           C  \n"
"ATOM    232  O   ASP A  15       5.470  -5.386   3.353  1.00  0.23           O  \n"
"ATOM    233  CB  ASP A  15       8.536  -6.538   2.871  1.00  0.30           C  \n"
"ATOM    234  CG  ASP A  15       9.056  -6.939   4.254  1.00  0.33           C  \n"
"ATOM    235  OD1 ASP A  15       8.483  -7.843   4.840  1.00  1.17           O  \n"
"ATOM    236  OD2 ASP A  15      10.015  -6.335   4.705  1.00  1.08           O  \n"
"ATOM    237  H   ASP A  15       7.814  -8.144   1.036  1.00  0.37           H  \n"
"ATOM    238  HA  ASP A  15       6.789  -7.548   3.594  1.00  0.31           H  \n"
"ATOM    239  HB2 ASP A  15       9.154  -6.988   2.107  1.00  0.33           H  \n"
"ATOM    240  HB3 ASP A  15       8.564  -5.466   2.769  1.00  0.27           H  \n"
"ATOM    241  N   LEU A  16       6.211  -5.283   1.288  1.00  0.25           N  \n"
"ATOM    242  CA  LEU A  16       5.347  -4.111   0.980  1.00  0.23           C  \n"
"ATOM    243  C   LEU A  16       3.898  -4.464   1.298  1.00  0.22           C  \n"
"ATOM    244  O   LEU A  16       3.233  -3.804   2.073  1.00  0.21           O  \n"
"ATOM    245  CB  LEU A  16       5.470  -3.779  -0.505  1.00  0.28           C  \n"
"ATOM    246  CG  LEU A  16       4.802  -2.436  -0.784  1.00  0.31           C  \n"
"ATOM    247  CD1 LEU A  16       5.341  -1.386   0.188  1.00  0.31           C  \n"
"ATOM    248  CD2 LEU A  16       5.110  -2.013  -2.219  1.00  0.39           C  \n"
"ATOM    249  H   LEU A  16       6.795  -5.657   0.594  1.00  0.29           H  \n"
"ATOM    250  HA  LEU A  16       5.653  -3.262   1.569  1.00  0.22           H  \n"
"ATOM    251  HB2 LEU A  16       6.513  -3.728  -0.776  1.00  0.30           H  \n"
"ATOM    252  HB3 LEU A  16       4.984  -4.548  -1.086  1.00  0.33           H  \n"
"ATOM    253  HG  LEU A  16       3.733  -2.532  -0.656  1.00  0.39           H  \n"
"ATOM    254 HD11 LEU A  16       6.331  -1.669   0.511  1.00  0.98           H  \n"
"ATOM    255 HD12 LEU A  16       5.383  -0.427  -0.306  1.00  1.09           H  \n"
"ATOM    256 HD13 LEU A  16       4.687  -1.320   1.045  1.00  1.09           H  \n"
"ATOM    257 HD21 LEU A  16       5.742  -2.755  -2.684  1.00  1.05           H  \n"
"ATOM    258 HD22 LEU A  16       4.189  -1.926  -2.775  1.00  1.10           H  \n"
"ATOM    259 HD23 LEU A  16       5.619  -1.061  -2.212  1.00  0.97           H  \n"
"ATOM    260  N   HIS A  17       3.413  -5.509   0.701  1.00  0.22           N  \n"
"ATOM    261  CA  HIS A  17       2.018  -5.941   0.944  1.00  0.22           C  \n"
"ATOM    262  C   HIS A  17       1.874  -6.363   2.405  1.00  0.19           C  \n"
"ATOM    263  O   HIS A  17       0.786  -6.432   2.941  1.00  0.19           O  \n"
"ATOM    264  CB  HIS A  17       1.715  -7.120   0.024  1.00  0.26           C  \n"
"ATOM    265  CG  HIS A  17       1.994  -6.716  -1.397  1.00  0.32           C  \n"
"ATOM    266  ND1 HIS A  17       1.294  -5.699  -2.026  1.00  0.38           N  \n"
"ATOM    267  CD2 HIS A  17       2.895  -7.181  -2.324  1.00  0.40           C  \n"
"ATOM    268  CE1 HIS A  17       1.779  -5.586  -3.276  1.00  0.44           C  \n"
"ATOM    269  NE2 HIS A  17       2.756  -6.465  -3.510  1.00  0.45           N  \n"
"ATOM    270  H   HIS A  17       3.974  -6.019   0.089  1.00  0.24           H  \n"
"ATOM    271  HA  HIS A  17       1.341  -5.128   0.729  1.00  0.23           H  \n"
"ATOM    272  HB2 HIS A  17       2.344  -7.958   0.291  1.00  0.27           H  \n"
"ATOM    273  HB3 HIS A  17       0.683  -7.400   0.121  1.00  0.27           H  \n"
"ATOM    274  HD1 HIS A  17       0.576  -5.161  -1.632  1.00  0.43           H  \n"
"ATOM    275  HD2 HIS A  17       3.605  -7.980  -2.157  1.00  0.48           H  \n"
"ATOM    276  HE1 HIS A  17       1.419  -4.874  -4.003  1.00  0.53           H  \n"
"ATOM    277  N   GLN A  18       2.969  -6.639   3.055  1.00  0.19           N  \n"
"ATOM    278  CA  GLN A  18       2.905  -7.047   4.475  1.00  0.19           C  \n"
"ATOM    279  C   GLN A  18       2.501  -5.844   5.322  1.00  0.17           C  \n"
"ATOM    280  O   GLN A  18       1.541  -5.888   6.067  1.00  0.18           O  \n"
"ATOM    281  CB  GLN A  18       4.275  -7.553   4.927  1.00  0.21           C  \n"
"ATOM    282  CG  GLN A  18       4.092  -8.654   5.975  1.00  0.55           C  \n"
"ATOM    283  CD  GLN A  18       5.461  -9.139   6.452  1.00  1.31           C  \n"
"ATOM    284  OE1 GLN A  18       6.390  -8.363   6.557  1.00  2.11           O  \n"
"ATOM    285  NE2 GLN A  18       5.626 -10.399   6.749  1.00  2.02           N  \n"
"ATOM    286  H   GLN A  18       3.831  -6.574   2.611  1.00  0.21           H  \n"
"ATOM    287  HA  GLN A  18       2.178  -7.830   4.584  1.00  0.20           H  \n"
"ATOM    288  HB2 GLN A  18       4.811  -7.948   4.076  1.00  0.40           H  \n"
"ATOM    289  HB3 GLN A  18       4.835  -6.737   5.359  1.00  0.45           H  \n"
"ATOM    290  HG2 GLN A  18       3.535  -8.262   6.814  1.00  1.27           H  \n"
"ATOM    291  HG3 GLN A  18       3.552  -9.480   5.538  1.00  1.06           H  \n"
"ATOM    292 HE21 GLN A  18       4.876 -11.024   6.665  1.00  2.32           H  \n"
"ATOM    293 HE22 GLN A  18       6.499 -10.719   7.056  1.00  2.67           H  \n"
"ATOM    294  N   THR A  19       3.229  -4.764   5.217  1.00  0.17           N  \n"
"ATOM    295  CA  THR A  19       2.882  -3.573   6.019  1.00  0.17           C  \n"
"ATOM    296  C   THR A  19       1.519  -3.063   5.542  1.00  0.17           C  \n"
"ATOM    297  O   THR A  19       0.682  -2.691   6.328  1.00  0.18           O  \n"
"ATOM    298  CB  THR A  19       3.976  -2.492   5.860  1.00  0.20           C  \n"
"ATOM    299  OG1 THR A  19       4.593  -2.276   7.121  1.00  0.22           O  \n"
"ATOM    300  CG2 THR A  19       3.371  -1.165   5.396  1.00  0.21           C  \n"
"ATOM    301  H   THR A  19       3.996  -4.744   4.620  1.00  0.18           H  \n"
"ATOM    302  HA  THR A  19       2.812  -3.861   7.050  1.00  0.18           H  \n"
"ATOM    303  HB  THR A  19       4.713  -2.820   5.143  1.00  0.20           H  \n"
"ATOM    304  HG1 THR A  19       5.007  -1.410   7.104  1.00  0.99           H  \n"
"ATOM    305 HG21 THR A  19       2.472  -0.968   5.968  1.00  1.04           H  \n"
"ATOM    306 HG22 THR A  19       4.082  -0.368   5.556  1.00  1.01           H  \n"
"ATOM    307 HG23 THR A  19       3.125  -1.228   4.347  1.00  1.05           H  \n"
"ATOM    308  N   LEU A  20       1.286  -3.056   4.258  1.00  0.16           N  \n"
"ATOM    309  CA  LEU A  20      -0.022  -2.590   3.751  1.00  0.18           C  \n"
"ATOM    310  C   LEU A  20      -1.104  -3.472   4.365  1.00  0.17           C  \n"
"ATOM    311  O   LEU A  20      -2.183  -3.040   4.683  1.00  0.24           O  \n"
"ATOM    312  CB  LEU A  20      -0.050  -2.738   2.232  1.00  0.19           C  \n"
"ATOM    313  CG  LEU A  20       0.878  -1.705   1.588  1.00  0.20           C  \n"
"ATOM    314  CD1 LEU A  20       0.822  -1.851   0.068  1.00  0.23           C  \n"
"ATOM    315  CD2 LEU A  20       0.434  -0.292   1.981  1.00  0.21           C  \n"
"ATOM    316  H   LEU A  20       1.961  -3.368   3.631  1.00  0.17           H  \n"
"ATOM    317  HA  LEU A  20      -0.175  -1.562   4.026  1.00  0.19           H  \n"
"ATOM    318  HB2 LEU A  20       0.280  -3.732   1.964  1.00  0.19           H  \n"
"ATOM    319  HB3 LEU A  20      -1.053  -2.589   1.881  1.00  0.21           H  \n"
"ATOM    320  HG  LEU A  20       1.891  -1.872   1.927  1.00  0.23           H  \n"
"ATOM    321 HD11 LEU A  20       0.850  -2.898  -0.194  1.00  1.02           H  \n"
"ATOM    322 HD12 LEU A  20      -0.092  -1.411  -0.300  1.00  1.06           H  \n"
"ATOM    323 HD13 LEU A  20       1.669  -1.347  -0.374  1.00  1.06           H  \n"
"ATOM    324 HD21 LEU A  20      -0.443  -0.353   2.607  1.00  0.97           H  \n"
"ATOM    325 HD22 LEU A  20       1.230   0.195   2.524  1.00  1.06           H  \n"
"ATOM    326 HD23 LEU A  20       0.204   0.280   1.089  1.00  0.99           H  \n"
"ATOM    327  N   LYS A  21      -0.794  -4.716   4.530  1.00  0.16           N  \n"
"ATOM    328  CA  LYS A  21      -1.760  -5.680   5.122  1.00  0.16           C  \n"
"ATOM    329  C   LYS A  21      -2.011  -5.324   6.586  1.00  0.17           C  \n"
"ATOM    330  O   LYS A  21      -3.123  -5.365   7.059  1.00  0.19           O  \n"
"ATOM    331  CB  LYS A  21      -1.173  -7.088   5.035  1.00  0.17           C  \n"
"ATOM    332  CG  LYS A  21      -2.174  -8.100   5.593  1.00  0.29           C  \n"
"ATOM    333  CD  LYS A  21      -1.414  -9.229   6.292  1.00  0.68           C  \n"
"ATOM    334  CE  LYS A  21      -2.407 -10.255   6.837  1.00  1.26           C  \n"
"ATOM    335  NZ  LYS A  21      -1.733 -11.101   7.860  1.00  1.94           N  \n"
"ATOM    336  H   LYS A  21       0.084  -5.017   4.262  1.00  0.19           H  \n"
"ATOM    337  HA  LYS A  21      -2.690  -5.643   4.575  1.00  0.18           H  \n"
"ATOM    338  HB2 LYS A  21      -0.957  -7.322   4.005  1.00  0.22           H  \n"
"ATOM    339  HB3 LYS A  21      -0.261  -7.131   5.612  1.00  0.24           H  \n"
"ATOM    340  HG2 LYS A  21      -2.827  -7.610   6.300  1.00  0.72           H  \n"
"ATOM    341  HG3 LYS A  21      -2.760  -8.510   4.784  1.00  0.65           H  \n"
"ATOM    342  HD2 LYS A  21      -0.753  -9.708   5.583  1.00  1.27           H  \n"
"ATOM    343  HD3 LYS A  21      -0.834  -8.823   7.107  1.00  1.44           H  \n"
"ATOM    344  HE2 LYS A  21      -3.244  -9.744   7.288  1.00  1.85           H  \n"
"ATOM    345  HE3 LYS A  21      -2.759 -10.880   6.029  1.00  1.79           H  \n"
"ATOM    346  HZ1 LYS A  21      -1.098 -10.512   8.434  1.00  2.47           H  \n"
"ATOM    347  HZ2 LYS A  21      -2.450 -11.541   8.472  1.00  2.37           H  \n"
"ATOM    348  HZ3 LYS A  21      -1.180 -11.843   7.387  1.00  2.30           H  \n"
"ATOM    349  N   LYS A  22      -0.991  -4.980   7.317  1.00  0.18           N  \n"
"ATOM    350  CA  LYS A  22      -1.204  -4.631   8.741  1.00  0.20           C  \n"
"ATOM    351  C   LYS A  22      -2.006  -3.335   8.817  1.00  0.23           C  \n"
"ATOM    352  O   LYS A  22      -3.074  -3.277   9.390  1.00  0.29           O  \n"
"ATOM    353  CB  LYS A  22       0.142  -4.442   9.432  1.00  0.22           C  \n"
"ATOM    354  CG  LYS A  22       0.148  -5.278  10.717  1.00  0.83           C  \n"
"ATOM    355  CD  LYS A  22       1.553  -5.339  11.302  1.00  1.43           C  \n"
"ATOM    356  CE  LYS A  22       1.494  -6.033  12.671  1.00  2.18           C  \n"
"ATOM    357  NZ  LYS A  22       2.827  -6.602  13.001  1.00  2.84           N  \n"
"ATOM    358  H   LYS A  22      -0.095  -4.952   6.936  1.00  0.18           H  \n"
"ATOM    359  HA  LYS A  22      -1.748  -5.423   9.220  1.00  0.22           H  \n"
"ATOM    360  HB2 LYS A  22       0.934  -4.768   8.773  1.00  0.68           H  \n"
"ATOM    361  HB3 LYS A  22       0.280  -3.398   9.674  1.00  0.64           H  \n"
"ATOM    362  HG2 LYS A  22      -0.521  -4.833  11.441  1.00  1.59           H  \n"
"ATOM    363  HG3 LYS A  22      -0.184  -6.279  10.493  1.00  1.50           H  \n"
"ATOM    364  HD2 LYS A  22       2.192  -5.897  10.635  1.00  1.98           H  \n"
"ATOM    365  HD3 LYS A  22       1.939  -4.336  11.421  1.00  2.00           H  \n"
"ATOM    366  HE2 LYS A  22       1.213  -5.318  13.432  1.00  2.61           H  \n"
"ATOM    367  HE3 LYS A  22       0.765  -6.828  12.640  1.00  2.68           H  \n"
"ATOM    368  HZ1 LYS A  22       3.561  -5.886  12.835  1.00  3.14           H  \n"
"ATOM    369  HZ2 LYS A  22       2.841  -6.890  14.002  1.00  3.13           H  \n"
"ATOM    370  HZ3 LYS A  22       3.008  -7.429  12.400  1.00  3.35           H  \n"
"ATOM    371  N   GLU A  23      -1.495  -2.303   8.219  1.00  0.22           N  \n"
"ATOM    372  CA  GLU A  23      -2.195  -1.004   8.212  1.00  0.26           C  \n"
"ATOM    373  C   GLU A  23      -3.621  -1.224   7.716  1.00  0.24           C  \n"
"ATOM    374  O   GLU A  23      -4.587  -1.066   8.436  1.00  0.27           O  \n"
"ATOM    375  CB  GLU A  23      -1.450  -0.080   7.250  1.00  0.29           C  \n"
"ATOM    376  CG  GLU A  23      -0.006   0.098   7.725  1.00  0.35           C  \n"
"ATOM    377  CD  GLU A  23       0.032   1.057   8.914  1.00  1.53           C  \n"
"ATOM    378  OE1 GLU A  23      -1.026   1.364   9.438  1.00  2.29           O  \n"
"ATOM    379  OE2 GLU A  23       1.120   1.471   9.280  1.00  2.27           O  \n"
"ATOM    380  H   GLU A  23      -0.646  -2.387   7.757  1.00  0.21           H  \n"
"ATOM    381  HA  GLU A  23      -2.200  -0.582   9.202  1.00  0.29           H  \n"
"ATOM    382  HB2 GLU A  23      -1.447  -0.527   6.261  1.00  0.29           H  \n"
"ATOM    383  HB3 GLU A  23      -1.940   0.879   7.216  1.00  0.29           H  \n"
"ATOM    384  HG2 GLU A  23       0.394  -0.860   8.022  1.00  0.86           H  \n"
"ATOM    385  HG3 GLU A  23       0.588   0.501   6.920  1.00  0.89           H  \n"
"ATOM    386  N   LEU A  24      -3.737  -1.599   6.480  1.00  0.23           N  \n"
"ATOM    387  CA  LEU A  24      -5.066  -1.859   5.871  1.00  0.23           C  \n"
"ATOM    388  C   LEU A  24      -5.767  -2.996   6.618  1.00  0.22           C  \n"
"ATOM    389  O   LEU A  24      -6.953  -3.209   6.467  1.00  0.24           O  \n"
"ATOM    390  CB  LEU A  24      -4.848  -2.277   4.418  1.00  0.21           C  \n"
"ATOM    391  CG  LEU A  24      -4.150  -1.150   3.658  1.00  0.25           C  \n"
"ATOM    392  CD1 LEU A  24      -3.120  -1.750   2.701  1.00  0.20           C  \n"
"ATOM    393  CD2 LEU A  24      -5.184  -0.352   2.862  1.00  0.40           C  \n"
"ATOM    394  H   LEU A  24      -2.935  -1.716   5.942  1.00  0.24           H  \n"
"ATOM    395  HA  LEU A  24      -5.669  -0.966   5.907  1.00  0.26           H  \n"
"ATOM    396  HB2 LEU A  24      -4.224  -3.163   4.392  1.00  0.19           H  \n"
"ATOM    397  HB3 LEU A  24      -5.799  -2.490   3.955  1.00  0.22           H  \n"
"ATOM    398  HG  LEU A  24      -3.651  -0.499   4.362  1.00  0.33           H  \n"
"ATOM    399 HD11 LEU A  24      -3.097  -2.822   2.826  1.00  1.06           H  \n"
"ATOM    400 HD12 LEU A  24      -3.391  -1.514   1.684  1.00  1.01           H  \n"
"ATOM    401 HD13 LEU A  24      -2.144  -1.341   2.922  1.00  1.04           H  \n"
"ATOM    402 HD21 LEU A  24      -5.924   0.053   3.538  1.00  1.08           H  \n"
"ATOM    403 HD22 LEU A  24      -4.692   0.457   2.342  1.00  1.14           H  \n"
"ATOM    404 HD23 LEU A  24      -5.666  -1.000   2.146  1.00  1.09           H  \n"
"ATOM    405  N   ALA A  25      -5.043  -3.736   7.416  1.00  0.21           N  \n"
"ATOM    406  CA  ALA A  25      -5.667  -4.860   8.158  1.00  0.22           C  \n"
"ATOM    407  C   ALA A  25      -6.369  -5.796   7.170  1.00  0.21           C  \n"
"ATOM    408  O   ALA A  25      -7.501  -6.191   7.366  1.00  0.23           O  \n"
"ATOM    409  CB  ALA A  25      -6.670  -4.292   9.152  1.00  0.26           C  \n"
"ATOM    410  H   ALA A  25      -4.088  -3.557   7.525  1.00  0.22           H  \n"
"ATOM    411  HA  ALA A  25      -4.904  -5.408   8.688  1.00  0.23           H  \n"
"ATOM    412  HB1 ALA A  25      -6.275  -3.373   9.558  1.00  1.01           H  \n"
"ATOM    413  HB2 ALA A  25      -7.603  -4.092   8.649  1.00  1.00           H  \n"
"ATOM    414  HB3 ALA A  25      -6.831  -5.002   9.949  1.00  0.98           H  \n"
"ATOM    415  N   LEU A  26      -5.693  -6.152   6.112  1.00  0.21           N  \n"
"ATOM    416  CA  LEU A  26      -6.293  -7.062   5.095  1.00  0.24           C  \n"
"ATOM    417  C   LEU A  26      -6.438  -8.468   5.690  1.00  0.28           C  \n"
"ATOM    418  O   LEU A  26      -5.795  -8.792   6.669  1.00  0.30           O  \n"
"ATOM    419  CB  LEU A  26      -5.371  -7.117   3.872  1.00  0.23           C  \n"
"ATOM    420  CG  LEU A  26      -4.954  -5.697   3.483  1.00  0.21           C  \n"
"ATOM    421  CD1 LEU A  26      -3.954  -5.751   2.337  1.00  0.26           C  \n"
"ATOM    422  CD2 LEU A  26      -6.187  -4.909   3.043  1.00  0.23           C  \n"
"ATOM    423  H   LEU A  26      -4.782  -5.822   5.985  1.00  0.22           H  \n"
"ATOM    424  HA  LEU A  26      -7.262  -6.690   4.802  1.00  0.29           H  \n"
"ATOM    425  HB2 LEU A  26      -4.492  -7.697   4.111  1.00  0.25           H  \n"
"ATOM    426  HB3 LEU A  26      -5.889  -7.574   3.046  1.00  0.26           H  \n"
"ATOM    427  HG  LEU A  26      -4.491  -5.214   4.323  1.00  0.21           H  \n"
"ATOM    428 HD11 LEU A  26      -4.013  -6.711   1.862  1.00  0.99           H  \n"
"ATOM    429 HD12 LEU A  26      -4.183  -4.977   1.621  1.00  1.07           H  \n"
"ATOM    430 HD13 LEU A  26      -2.958  -5.601   2.726  1.00  1.03           H  \n"
"ATOM    431 HD21 LEU A  26      -6.656  -5.412   2.210  1.00  1.05           H  \n"
"ATOM    432 HD22 LEU A  26      -6.885  -4.845   3.865  1.00  0.98           H  \n"
"ATOM    433 HD23 LEU A  26      -5.891  -3.914   2.744  1.00  1.09           H  \n"
"ATOM    434  N   PRO A  27      -7.280  -9.262   5.077  1.00  0.34           N  \n"
"ATOM    435  CA  PRO A  27      -7.526 -10.643   5.529  1.00  0.41           C  \n"
"ATOM    436  C   PRO A  27      -6.221 -11.438   5.555  1.00  0.39           C  \n"
"ATOM    437  O   PRO A  27      -5.165 -10.932   5.233  1.00  0.31           O  \n"
"ATOM    438  CB  PRO A  27      -8.489 -11.230   4.490  1.00  0.48           C  \n"
"ATOM    439  CG  PRO A  27      -8.880 -10.091   3.514  1.00  0.48           C  \n"
"ATOM    440  CD  PRO A  27      -8.054  -8.852   3.890  1.00  0.38           C  \n"
"ATOM    441  HA  PRO A  27      -7.991 -10.646   6.502  1.00  0.48           H  \n"
"ATOM    442  HB2 PRO A  27      -7.999 -12.028   3.948  1.00  0.46           H  \n"
"ATOM    443  HB3 PRO A  27      -9.371 -11.607   4.977  1.00  0.57           H  \n"
"ATOM    444  HG2 PRO A  27      -8.658 -10.387   2.499  1.00  0.49           H  \n"
"ATOM    445  HG3 PRO A  27      -9.931  -9.869   3.611  1.00  0.57           H  \n"
"ATOM    446  HD2 PRO A  27      -7.393  -8.587   3.079  1.00  0.35           H  \n"
"ATOM    447  HD3 PRO A  27      -8.702  -8.026   4.136  1.00  0.41           H  \n"
"ATOM    448  N   GLU A  28      -6.289 -12.685   5.931  1.00  0.50           N  \n"
"ATOM    449  CA  GLU A  28      -5.058 -13.519   5.972  1.00  0.53           C  \n"
"ATOM    450  C   GLU A  28      -4.729 -13.997   4.558  1.00  0.49           C  \n"
"ATOM    451  O   GLU A  28      -3.622 -14.407   4.273  1.00  0.51           O  \n"
"ATOM    452  CB  GLU A  28      -5.295 -14.732   6.871  1.00  0.67           C  \n"
"ATOM    453  CG  GLU A  28      -5.557 -14.268   8.305  1.00  1.14           C  \n"
"ATOM    454  CD  GLU A  28      -5.237 -15.405   9.276  1.00  1.65           C  \n"
"ATOM    455  OE1 GLU A  28      -4.380 -16.210   8.953  1.00  2.31           O  \n"
"ATOM    456  OE2 GLU A  28      -5.856 -15.452  10.327  1.00  2.20           O  \n"
"ATOM    457  H   GLU A  28      -7.153 -13.074   6.182  1.00  0.59           H  \n"
"ATOM    458  HA  GLU A  28      -4.237 -12.935   6.359  1.00  0.52           H  \n"
"ATOM    459  HB2 GLU A  28      -6.151 -15.284   6.509  1.00  0.81           H  \n"
"ATOM    460  HB3 GLU A  28      -4.423 -15.368   6.854  1.00  0.84           H  \n"
"ATOM    461  HG2 GLU A  28      -4.931 -13.416   8.527  1.00  1.61           H  \n"
"ATOM    462  HG3 GLU A  28      -6.595 -13.989   8.410  1.00  1.59           H  \n"
"ATOM    463  N   TYR A  29      -5.686 -13.952   3.671  1.00  0.47           N  \n"
"ATOM    464  CA  TYR A  29      -5.426 -14.409   2.279  1.00  0.44           C  \n"
"ATOM    465  C   TYR A  29      -5.020 -13.218   1.409  1.00  0.37           C  \n"
"ATOM    466  O   TYR A  29      -4.999 -13.312   0.198  1.00  0.38           O  \n"
"ATOM    467  CB  TYR A  29      -6.686 -15.061   1.704  1.00  0.51           C  \n"
"ATOM    468  CG  TYR A  29      -7.900 -14.250   2.087  1.00  0.66           C  \n"
"ATOM    469  CD1 TYR A  29      -8.300 -13.171   1.290  1.00  1.29           C  \n"
"ATOM    470  CD2 TYR A  29      -8.627 -14.579   3.237  1.00  1.53           C  \n"
"ATOM    471  CE1 TYR A  29      -9.428 -12.421   1.643  1.00  1.43           C  \n"
"ATOM    472  CE2 TYR A  29      -9.756 -13.829   3.590  1.00  1.75           C  \n"
"ATOM    473  CZ  TYR A  29     -10.156 -12.750   2.793  1.00  1.24           C  \n"
"ATOM    474  OH  TYR A  29     -11.268 -12.011   3.140  1.00  1.57           O  \n"
"ATOM    475  H   TYR A  29      -6.574 -13.622   3.922  1.00  0.50           H  \n"
"ATOM    476  HA  TYR A  29      -4.624 -15.133   2.287  1.00  0.48           H  \n"
"ATOM    477  HB2 TYR A  29      -6.608 -15.105   0.628  1.00  0.54           H  \n"
"ATOM    478  HB3 TYR A  29      -6.785 -16.061   2.099  1.00  0.66           H  \n"
"ATOM    479  HD1 TYR A  29      -7.739 -12.917   0.403  1.00  2.09           H  \n"
"ATOM    480  HD2 TYR A  29      -8.318 -15.411   3.852  1.00  2.30           H  \n"
"ATOM    481  HE1 TYR A  29      -9.737 -11.588   1.029  1.00  2.19           H  \n"
"ATOM    482  HE2 TYR A  29     -10.317 -14.083   4.476  1.00  2.61           H  \n"
"ATOM    483  HH  TYR A  29     -11.944 -12.619   3.447  1.00  1.71           H  \n"
"ATOM    484  N   TYR A  30      -4.694 -12.103   2.017  1.00  0.32           N  \n"
"ATOM    485  CA  TYR A  30      -4.275 -10.903   1.222  1.00  0.28           C  \n"
"ATOM    486  C   TYR A  30      -3.419 -11.366   0.035  1.00  0.32           C  \n"
"ATOM    487  O   TYR A  30      -2.281 -11.759   0.193  1.00  0.38           O  \n"
"ATOM    488  CB  TYR A  30      -3.462  -9.958   2.121  1.00  0.29           C  \n"
"ATOM    489  CG  TYR A  30      -3.006  -8.741   1.339  1.00  0.20           C  \n"
"ATOM    490  CD1 TYR A  30      -3.750  -8.286   0.243  1.00  0.47           C  \n"
"ATOM    491  CD2 TYR A  30      -1.832  -8.068   1.715  1.00  0.48           C  \n"
"ATOM    492  CE1 TYR A  30      -3.319  -7.163  -0.477  1.00  0.49           C  \n"
"ATOM    493  CE2 TYR A  30      -1.400  -6.943   0.995  1.00  0.49           C  \n"
"ATOM    494  CZ  TYR A  30      -2.145  -6.493  -0.102  1.00  0.25           C  \n"
"ATOM    495  OH  TYR A  30      -1.724  -5.388  -0.814  1.00  0.36           O  \n"
"ATOM    496  H   TYR A  30      -4.721 -12.056   2.998  1.00  0.33           H  \n"
"ATOM    497  HA  TYR A  30      -5.152 -10.390   0.855  1.00  0.31           H  \n"
"ATOM    498  HB2 TYR A  30      -4.075  -9.639   2.950  1.00  0.37           H  \n"
"ATOM    499  HB3 TYR A  30      -2.597 -10.483   2.499  1.00  0.37           H  \n"
"ATOM    500  HD1 TYR A  30      -4.655  -8.797  -0.044  1.00  0.80           H  \n"
"ATOM    501  HD2 TYR A  30      -1.267  -8.413   2.564  1.00  0.81           H  \n"
"ATOM    502  HE1 TYR A  30      -3.892  -6.812  -1.322  1.00  0.82           H  \n"
"ATOM    503  HE2 TYR A  30      -0.484  -6.425   1.282  1.00  0.82           H  \n"
"ATOM    504  HH  TYR A  30      -0.976  -5.004  -0.351  1.00  0.86           H  \n"
"ATOM    505  N   GLY A  31      -3.974 -11.339  -1.151  1.00  0.39           N  \n"
"ATOM    506  CA  GLY A  31      -3.215 -11.796  -2.357  1.00  0.51           C  \n"
"ATOM    507  C   GLY A  31      -2.004 -10.892  -2.611  1.00  0.58           C  \n"
"ATOM    508  O   GLY A  31      -1.214 -11.146  -3.495  1.00  1.36           O  \n"
"ATOM    509  H   GLY A  31      -4.899 -11.032  -1.247  1.00  0.42           H  \n"
"ATOM    510  HA2 GLY A  31      -2.876 -12.809  -2.201  1.00  0.59           H  \n"
"ATOM    511  HA3 GLY A  31      -3.865 -11.766  -3.219  1.00  0.55           H  \n"
"ATOM    512  N   GLU A  32      -1.870  -9.835  -1.853  1.00  0.56           N  \n"
"ATOM    513  CA  GLU A  32      -0.726  -8.877  -2.011  1.00  0.54           C  \n"
"ATOM    514  C   GLU A  32      -0.533  -8.420  -3.470  1.00  0.54           C  \n"
"ATOM    515  O   GLU A  32       0.377  -7.671  -3.760  1.00  0.59           O  \n"
"ATOM    516  CB  GLU A  32       0.582  -9.491  -1.474  1.00  0.66           C  \n"
"ATOM    517  CG  GLU A  32       0.741 -10.947  -1.915  1.00  1.51           C  \n"
"ATOM    518  CD  GLU A  32       2.052 -11.506  -1.358  1.00  1.87           C  \n"
"ATOM    519  OE1 GLU A  32       3.044 -10.799  -1.410  1.00  2.36           O  \n"
"ATOM    520  OE2 GLU A  32       2.040 -12.632  -0.890  1.00  2.37           O  \n"
"ATOM    521  H   GLU A  32      -2.537  -9.659  -1.164  1.00  1.17           H  \n"
"ATOM    522  HA  GLU A  32      -0.948  -8.001  -1.421  1.00  0.51           H  \n"
"ATOM    523  HB2 GLU A  32       1.419  -8.921  -1.845  1.00  1.18           H  \n"
"ATOM    524  HB3 GLU A  32       0.576  -9.447  -0.394  1.00  1.10           H  \n"
"ATOM    525  HG2 GLU A  32      -0.084 -11.532  -1.539  1.00  2.15           H  \n"
"ATOM    526  HG3 GLU A  32       0.764 -10.998  -2.992  1.00  2.09           H  \n"
"ATOM    527  N   ASN A  33      -1.373  -8.817  -4.389  1.00  0.51           N  \n"
"ATOM    528  CA  ASN A  33      -1.203  -8.335  -5.792  1.00  0.53           C  \n"
"ATOM    529  C   ASN A  33      -1.891  -6.977  -5.927  1.00  0.50           C  \n"
"ATOM    530  O   ASN A  33      -2.423  -6.444  -4.974  1.00  0.56           O  \n"
"ATOM    531  CB  ASN A  33      -1.811  -9.321  -6.806  1.00  0.54           C  \n"
"ATOM    532  CG  ASN A  33      -2.420 -10.533  -6.096  1.00  0.62           C  \n"
"ATOM    533  OD1 ASN A  33      -1.721 -11.465  -5.752  1.00  1.57           O  \n"
"ATOM    534  ND2 ASN A  33      -3.703 -10.559  -5.864  1.00  0.82           N  \n"
"ATOM    535  H   ASN A  33      -2.127  -9.384  -4.159  1.00  0.49           H  \n"
"ATOM    536  HA  ASN A  33      -0.148  -8.216  -5.997  1.00  0.59           H  \n"
"ATOM    537  HB2 ASN A  33      -2.581  -8.817  -7.372  1.00  0.60           H  \n"
"ATOM    538  HB3 ASN A  33      -1.037  -9.657  -7.481  1.00  0.62           H  \n"
"ATOM    539 HD21 ASN A  33      -4.267  -9.808  -6.143  1.00  1.60           H  \n"
"ATOM    540 HD22 ASN A  33      -4.104 -11.330  -5.410  1.00  0.77           H  \n"
"ATOM    541  N   LEU A  34      -1.918  -6.429  -7.107  1.00  0.48           N  \n"
"ATOM    542  CA  LEU A  34      -2.609  -5.125  -7.305  1.00  0.47           C  \n"
"ATOM    543  C   LEU A  34      -4.108  -5.392  -7.331  1.00  0.40           C  \n"
"ATOM    544  O   LEU A  34      -4.911  -4.621  -6.852  1.00  0.37           O  \n"
"ATOM    545  CB  LEU A  34      -2.204  -4.539  -8.650  1.00  0.55           C  \n"
"ATOM    546  CG  LEU A  34      -0.749  -4.072  -8.606  1.00  0.64           C  \n"
"ATOM    547  CD1 LEU A  34      -0.358  -3.503  -9.971  1.00  0.82           C  \n"
"ATOM    548  CD2 LEU A  34      -0.590  -2.986  -7.539  1.00  0.61           C  \n"
"ATOM    549  H   LEU A  34      -1.505  -6.886  -7.869  1.00  0.52           H  \n"
"ATOM    550  HA  LEU A  34      -2.362  -4.443  -6.507  1.00  0.48           H  \n"
"ATOM    551  HB2 LEU A  34      -2.317  -5.300  -9.409  1.00  0.62           H  \n"
"ATOM    552  HB3 LEU A  34      -2.846  -3.706  -8.881  1.00  0.52           H  \n"
"ATOM    553  HG  LEU A  34      -0.109  -4.909  -8.369  1.00  0.72           H  \n"
"ATOM    554 HD11 LEU A  34      -1.059  -3.846 -10.718  1.00  1.23           H  \n"
"ATOM    555 HD12 LEU A  34      -0.375  -2.424  -9.930  1.00  1.45           H  \n"
"ATOM    556 HD13 LEU A  34       0.636  -3.838 -10.229  1.00  1.32           H  \n"
"ATOM    557 HD21 LEU A  34      -1.519  -2.868  -7.003  1.00  1.16           H  \n"
"ATOM    558 HD22 LEU A  34       0.191  -3.271  -6.850  1.00  1.14           H  \n"
"ATOM    559 HD23 LEU A  34      -0.328  -2.052  -8.014  1.00  1.19           H  \n"
"ATOM    560  N   ASP A  35      -4.469  -6.494  -7.911  1.00  0.39           N  \n"
"ATOM    561  CA  ASP A  35      -5.897  -6.886  -8.018  1.00  0.36           C  \n"
"ATOM    562  C   ASP A  35      -6.467  -7.173  -6.632  1.00  0.30           C  \n"
"ATOM    563  O   ASP A  35      -7.614  -6.894  -6.351  1.00  0.28           O  \n"
"ATOM    564  CB  ASP A  35      -5.975  -8.167  -8.833  1.00  0.38           C  \n"
"ATOM    565  CG  ASP A  35      -5.683  -7.865 -10.303  1.00  0.43           C  \n"
"ATOM    566  OD1 ASP A  35      -6.344  -7.000 -10.853  1.00  1.24           O  \n"
"ATOM    567  OD2 ASP A  35      -4.803  -8.506 -10.856  1.00  1.06           O  \n"
"ATOM    568  H   ASP A  35      -3.784  -7.073  -8.292  1.00  0.43           H  \n"
"ATOM    569  HA  ASP A  35      -6.465  -6.108  -8.502  1.00  0.39           H  \n"
"ATOM    570  HB2 ASP A  35      -5.242  -8.865  -8.451  1.00  0.37           H  \n"
"ATOM    571  HB3 ASP A  35      -6.958  -8.593  -8.738  1.00  0.38           H  \n"
"ATOM    572  N   ALA A  36      -5.676  -7.742  -5.769  1.00  0.29           N  \n"
"ATOM    573  CA  ALA A  36      -6.180  -8.058  -4.401  1.00  0.25           C  \n"
"ATOM    574  C   ALA A  36      -6.124  -6.799  -3.563  1.00  0.22           C  \n"
"ATOM    575  O   ALA A  36      -7.111  -6.353  -3.016  1.00  0.22           O  \n"
"ATOM    576  CB  ALA A  36      -5.310  -9.125  -3.749  1.00  0.29           C  \n"
"ATOM    577  H   ALA A  36      -4.751  -7.958  -6.021  1.00  0.32           H  \n"
"ATOM    578  HA  ALA A  36      -7.199  -8.406  -4.462  1.00  0.25           H  \n"
"ATOM    579  HB1 ALA A  36      -4.269  -8.876  -3.891  1.00  1.08           H  \n"
"ATOM    580  HB2 ALA A  36      -5.531  -9.163  -2.692  1.00  1.02           H  \n"
"ATOM    581  HB3 ALA A  36      -5.518 -10.085  -4.196  1.00  1.06           H  \n"
"ATOM    582  N   LEU A  37      -4.967  -6.217  -3.477  1.00  0.21           N  \n"
"ATOM    583  CA  LEU A  37      -4.820  -4.966  -2.697  1.00  0.19           C  \n"
"ATOM    584  C   LEU A  37      -5.987  -4.058  -3.064  1.00  0.16           C  \n"
"ATOM    585  O   LEU A  37      -6.706  -3.539  -2.224  1.00  0.16           O  \n"
"ATOM    586  CB  LEU A  37      -3.502  -4.299  -3.095  1.00  0.21           C  \n"
"ATOM    587  CG  LEU A  37      -3.539  -2.815  -2.724  1.00  0.20           C  \n"
"ATOM    588  CD1 LEU A  37      -3.557  -2.667  -1.201  1.00  0.22           C  \n"
"ATOM    589  CD2 LEU A  37      -2.302  -2.115  -3.290  1.00  0.24           C  \n"
"ATOM    590  H   LEU A  37      -4.197  -6.598  -3.946  1.00  0.23           H  \n"
"ATOM    591  HA  LEU A  37      -4.826  -5.183  -1.642  1.00  0.19           H  \n"
"ATOM    592  HB2 LEU A  37      -2.687  -4.787  -2.585  1.00  0.24           H  \n"
"ATOM    593  HB3 LEU A  37      -3.363  -4.395  -4.161  1.00  0.22           H  \n"
"ATOM    594  HG  LEU A  37      -4.433  -2.369  -3.142  1.00  0.18           H  \n"
"ATOM    595 HD11 LEU A  37      -3.210  -3.582  -0.746  1.00  1.05           H  \n"
"ATOM    596 HD12 LEU A  37      -2.909  -1.852  -0.912  1.00  1.03           H  \n"
"ATOM    597 HD13 LEU A  37      -4.564  -2.460  -0.872  1.00  1.02           H  \n"
"ATOM    598 HD21 LEU A  37      -1.501  -2.832  -3.401  1.00  1.02           H  \n"
"ATOM    599 HD22 LEU A  37      -2.539  -1.689  -4.254  1.00  1.04           H  \n"
"ATOM    600 HD23 LEU A  37      -1.992  -1.330  -2.616  1.00  1.04           H  \n"
"ATOM    601  N   TRP A  38      -6.173  -3.884  -4.333  1.00  0.17           N  \n"
"ATOM    602  CA  TRP A  38      -7.277  -3.046  -4.821  1.00  0.16           C  \n"
"ATOM    603  C   TRP A  38      -8.577  -3.613  -4.303  1.00  0.16           C  \n"
"ATOM    604  O   TRP A  38      -9.345  -2.951  -3.643  1.00  0.16           O  \n"
"ATOM    605  CB  TRP A  38      -7.315  -3.093  -6.341  1.00  0.18           C  \n"
"ATOM    606  CG  TRP A  38      -8.456  -2.267  -6.801  1.00  0.18           C  \n"
"ATOM    607  CD1 TRP A  38      -9.708  -2.718  -6.963  1.00  0.21           C  \n"
"ATOM    608  CD2 TRP A  38      -8.476  -0.860  -7.128  1.00  0.18           C  \n"
"ATOM    609  NE1 TRP A  38     -10.508  -1.672  -7.389  1.00  0.23           N  \n"
"ATOM    610  CE2 TRP A  38      -9.785  -0.502  -7.508  1.00  0.20           C  \n"
"ATOM    611  CE3 TRP A  38      -7.487   0.125  -7.138  1.00  0.17           C  \n"
"ATOM    612  CZ2 TRP A  38     -10.099   0.802  -7.885  1.00  0.22           C  \n"
"ATOM    613  CZ3 TRP A  38      -7.785   1.430  -7.507  1.00  0.19           C  \n"
"ATOM    614  CH2 TRP A  38      -9.093   1.778  -7.885  1.00  0.20           C  \n"
"ATOM    615  H   TRP A  38      -5.584  -4.321  -4.971  1.00  0.19           H  \n"
"ATOM    616  HA  TRP A  38      -7.151  -2.041  -4.479  1.00  0.15           H  \n"
"ATOM    617  HB2 TRP A  38      -6.396  -2.715  -6.747  1.00  0.19           H  \n"
"ATOM    618  HB3 TRP A  38      -7.458  -4.113  -6.665  1.00  0.20           H  \n"
"ATOM    619  HD1 TRP A  38     -10.026  -3.729  -6.788  1.00  0.23           H  \n"
"ATOM    620  HE1 TRP A  38     -11.467  -1.733  -7.585  1.00  0.26           H  \n"
"ATOM    621  HE3 TRP A  38      -6.487  -0.125  -6.858  1.00  0.18           H  \n"
"ATOM    622  HZ2 TRP A  38     -11.106   1.051  -8.177  1.00  0.25           H  \n"
"ATOM    623  HZ3 TRP A  38      -7.000   2.167  -7.492  1.00  0.20           H  \n"
"ATOM    624  HH2 TRP A  38      -9.322   2.794  -8.171  1.00  0.22           H  \n"
"ATOM    625  N   ASP A  39      -8.815  -4.850  -4.599  1.00  0.17           N  \n"
"ATOM    626  CA  ASP A  39     -10.061  -5.500  -4.130  1.00  0.18           C  \n"
"ATOM    627  C   ASP A  39     -10.283  -5.117  -2.672  1.00  0.18           C  \n"
"ATOM    628  O   ASP A  39     -11.394  -5.091  -2.182  1.00  0.21           O  \n"
"ATOM    629  CB  ASP A  39      -9.927  -7.017  -4.254  1.00  0.21           C  \n"
"ATOM    630  CG  ASP A  39     -10.613  -7.488  -5.537  1.00  0.29           C  \n"
"ATOM    631  OD1 ASP A  39     -10.045  -7.286  -6.598  1.00  1.13           O  \n"
"ATOM    632  OD2 ASP A  39     -11.695  -8.044  -5.438  1.00  1.06           O  \n"
"ATOM    633  H   ASP A  39      -8.163  -5.351  -5.126  1.00  0.18           H  \n"
"ATOM    634  HA  ASP A  39     -10.891  -5.158  -4.728  1.00  0.20           H  \n"
"ATOM    635  HB2 ASP A  39      -8.881  -7.285  -4.283  1.00  0.26           H  \n"
"ATOM    636  HB3 ASP A  39     -10.396  -7.486  -3.406  1.00  0.25           H  \n"
"ATOM    637  N   CYS A  40      -9.222  -4.807  -1.977  1.00  0.17           N  \n"
"ATOM    638  CA  CYS A  40      -9.354  -4.412  -0.556  1.00  0.19           C  \n"
"ATOM    639  C   CYS A  40      -9.797  -2.948  -0.466  1.00  0.19           C  \n"
"ATOM    640  O   CYS A  40     -10.745  -2.623   0.218  1.00  0.23           O  \n"
"ATOM    641  CB  CYS A  40      -8.001  -4.580   0.132  1.00  0.21           C  \n"
"ATOM    642  SG  CYS A  40      -7.334  -6.221  -0.239  1.00  0.58           S  \n"
"ATOM    643  H   CYS A  40      -8.332  -4.832  -2.394  1.00  0.16           H  \n"
"ATOM    644  HA  CYS A  40     -10.085  -5.042  -0.071  1.00  0.22           H  \n"
"ATOM    645  HB2 CYS A  40      -7.318  -3.823  -0.226  1.00  0.36           H  \n"
"ATOM    646  HB3 CYS A  40      -8.126  -4.475   1.195  1.00  0.32           H  \n"
"ATOM    647  HG  CYS A  40      -7.716  -6.844   0.383  1.00  1.07           H  \n"
"ATOM    648  N   LEU A  41      -9.117  -2.057  -1.142  1.00  0.17           N  \n"
"ATOM    649  CA  LEU A  41      -9.497  -0.625  -1.076  1.00  0.18           C  \n"
"ATOM    650  C   LEU A  41     -10.943  -0.424  -1.548  1.00  0.21           C  \n"
"ATOM    651  O   LEU A  41     -11.729   0.247  -0.908  1.00  0.45           O  \n"
"ATOM    652  CB  LEU A  41      -8.562   0.173  -1.981  1.00  0.17           C  \n"
"ATOM    653  CG  LEU A  41      -7.117  -0.285  -1.776  1.00  0.19           C  \n"
"ATOM    654  CD1 LEU A  41      -6.189   0.625  -2.567  1.00  0.18           C  \n"
"ATOM    655  CD2 LEU A  41      -6.760  -0.219  -0.289  1.00  0.31           C  \n"
"ATOM    656  H   LEU A  41      -8.350  -2.323  -1.688  1.00  0.16           H  \n"
"ATOM    657  HA  LEU A  41      -9.394  -0.278  -0.063  1.00  0.20           H  \n"
"ATOM    658  HB2 LEU A  41      -8.845   0.016  -3.011  1.00  0.18           H  \n"
"ATOM    659  HB3 LEU A  41      -8.641   1.221  -1.742  1.00  0.18           H  \n"
"ATOM    660  HG  LEU A  41      -6.999  -1.295  -2.133  1.00  0.27           H  \n"
"ATOM    661 HD11 LEU A  41      -6.767   1.412  -3.025  1.00  1.02           H  \n"
"ATOM    662 HD12 LEU A  41      -5.453   1.053  -1.904  1.00  1.02           H  \n"
"ATOM    663 HD13 LEU A  41      -5.695   0.046  -3.333  1.00  1.04           H  \n"
"ATOM    664 HD21 LEU A  41      -7.576   0.229   0.257  1.00  1.07           H  \n"
"ATOM    665 HD22 LEU A  41      -6.585  -1.218   0.083  1.00  1.04           H  \n"
"ATOM    666 HD23 LEU A  41      -5.869   0.376  -0.159  1.00  1.05           H  \n"
"ATOM    667  N   THR A  42     -11.284  -0.971  -2.679  1.00  0.26           N  \n"
"ATOM    668  CA  THR A  42     -12.650  -0.794  -3.226  1.00  0.28           C  \n"
"ATOM    669  C   THR A  42     -13.665  -1.664  -2.479  1.00  0.32           C  \n"
"ATOM    670  O   THR A  42     -14.826  -1.704  -2.836  1.00  0.55           O  \n"
"ATOM    671  CB  THR A  42     -12.649  -1.174  -4.708  1.00  0.26           C  \n"
"ATOM    672  OG1 THR A  42     -11.870  -2.347  -4.894  1.00  0.29           O  \n"
"ATOM    673  CG2 THR A  42     -12.054  -0.026  -5.525  1.00  0.40           C  \n"
"ATOM    674  H   THR A  42     -10.634  -1.478  -3.183  1.00  0.45           H  \n"
"ATOM    675  HA  THR A  42     -12.926   0.237  -3.135  1.00  0.36           H  \n"
"ATOM    676  HB  THR A  42     -13.661  -1.357  -5.035  1.00  0.29           H  \n"
"ATOM    677  HG1 THR A  42     -12.408  -2.989  -5.363  1.00  0.88           H  \n"
"ATOM    678 HG21 THR A  42     -12.646   0.865  -5.377  1.00  1.17           H  \n"
"ATOM    679 HG22 THR A  42     -11.040   0.158  -5.202  1.00  1.08           H  \n"
"ATOM    680 HG23 THR A  42     -12.056  -0.290  -6.572  1.00  1.02           H  \n"
"ATOM    681  N   GLY A  43     -13.262  -2.363  -1.452  1.00  0.27           N  \n"
"ATOM    682  CA  GLY A  43     -14.258  -3.210  -0.729  1.00  0.31           C  \n"
"ATOM    683  C   GLY A  43     -13.627  -3.900   0.484  1.00  0.27           C  \n"
"ATOM    684  O   GLY A  43     -13.610  -5.112   0.574  1.00  0.32           O  \n"
"ATOM    685  H   GLY A  43     -12.322  -2.332  -1.164  1.00  0.37           H  \n"
"ATOM    686  HA2 GLY A  43     -15.075  -2.588  -0.396  1.00  0.39           H  \n"
"ATOM    687  HA3 GLY A  43     -14.638  -3.963  -1.404  1.00  0.37           H  \n"
"ATOM    688  N   TRP A  44     -13.125  -3.148   1.425  1.00  0.25           N  \n"
"ATOM    689  CA  TRP A  44     -12.519  -3.775   2.630  1.00  0.23           C  \n"
"ATOM    690  C   TRP A  44     -11.944  -2.689   3.540  1.00  0.23           C  \n"
"ATOM    691  O   TRP A  44     -12.415  -2.466   4.637  1.00  0.27           O  \n"
"ATOM    692  CB  TRP A  44     -11.402  -4.721   2.201  1.00  0.24           C  \n"
"ATOM    693  CG  TRP A  44     -10.808  -5.362   3.411  1.00  0.26           C  \n"
"ATOM    694  CD1 TRP A  44      -9.735  -4.894   4.085  1.00  0.27           C  \n"
"ATOM    695  CD2 TRP A  44     -11.233  -6.571   4.106  1.00  0.30           C  \n"
"ATOM    696  NE1 TRP A  44      -9.470  -5.739   5.146  1.00  0.31           N  \n"
"ATOM    697  CE2 TRP A  44     -10.366  -6.788   5.202  1.00  0.34           C  \n"
"ATOM    698  CE3 TRP A  44     -12.274  -7.493   3.891  1.00  0.35           C  \n"
"ATOM    699  CZ2 TRP A  44     -10.527  -7.879   6.058  1.00  0.41           C  \n"
"ATOM    700  CZ3 TRP A  44     -12.439  -8.592   4.750  1.00  0.43           C  \n"
"ATOM    701  CH2 TRP A  44     -11.567  -8.785   5.831  1.00  0.45           C  \n"
"ATOM    702  H   TRP A  44     -13.153  -2.176   1.345  1.00  0.29           H  \n"
"ATOM    703  HA  TRP A  44     -13.275  -4.330   3.166  1.00  0.24           H  \n"
"ATOM    704  HB2 TRP A  44     -11.804  -5.478   1.549  1.00  0.26           H  \n"
"ATOM    705  HB3 TRP A  44     -10.639  -4.164   1.678  1.00  0.25           H  \n"
"ATOM    706  HD1 TRP A  44      -9.176  -4.005   3.832  1.00  0.29           H  \n"
"ATOM    707  HE1 TRP A  44      -8.741  -5.624   5.790  1.00  0.34           H  \n"
"ATOM    708  HE3 TRP A  44     -12.952  -7.353   3.062  1.00  0.34           H  \n"
"ATOM    709  HZ2 TRP A  44      -9.852  -8.022   6.888  1.00  0.44           H  \n"
"ATOM    710  HZ3 TRP A  44     -13.242  -9.293   4.577  1.00  0.48           H  \n"
"ATOM    711  HH2 TRP A  44     -11.698  -9.632   6.488  1.00  0.52           H  \n"
"ATOM    712  N   VAL A  45     -10.925  -2.016   3.089  1.00  0.25           N  \n"
"ATOM    713  CA  VAL A  45     -10.304  -0.949   3.912  1.00  0.26           C  \n"
"ATOM    714  C   VAL A  45     -11.350   0.112   4.253  1.00  0.25           C  \n"
"ATOM    715  O   VAL A  45     -12.264   0.362   3.493  1.00  0.37           O  \n"
"ATOM    716  CB  VAL A  45      -9.165  -0.300   3.125  1.00  0.30           C  \n"
"ATOM    717  CG1 VAL A  45      -8.436   0.706   4.017  1.00  0.42           C  \n"
"ATOM    718  CG2 VAL A  45      -8.181  -1.377   2.661  1.00  0.28           C  \n"
"ATOM    719  H   VAL A  45     -10.564  -2.217   2.209  1.00  0.30           H  \n"
"ATOM    720  HA  VAL A  45      -9.915  -1.380   4.817  1.00  0.30           H  \n"
"ATOM    721  HB  VAL A  45      -9.571   0.213   2.264  1.00  0.32           H  \n"
"ATOM    722 HG11 VAL A  45      -8.204   0.244   4.965  1.00  1.04           H  \n"
"ATOM    723 HG12 VAL A  45      -7.522   1.019   3.534  1.00  1.09           H  \n"
"ATOM    724 HG13 VAL A  45      -9.069   1.566   4.180  1.00  1.20           H  \n"
"ATOM    725 HG21 VAL A  45      -8.727  -2.205   2.234  1.00  1.04           H  \n"
"ATOM    726 HG22 VAL A  45      -7.519  -0.962   1.917  1.00  1.05           H  \n"
"ATOM    727 HG23 VAL A  45      -7.603  -1.724   3.505  1.00  1.06           H  \n"
"ATOM    728  N   GLU A  46     -11.215   0.751   5.382  1.00  0.21           N  \n"
"ATOM    729  CA  GLU A  46     -12.197   1.808   5.755  1.00  0.23           C  \n"
"ATOM    730  C   GLU A  46     -11.566   3.177   5.505  1.00  0.22           C  \n"
"ATOM    731  O   GLU A  46     -10.440   3.435   5.880  1.00  0.22           O  \n"
"ATOM    732  CB  GLU A  46     -12.600   1.688   7.231  1.00  0.30           C  \n"
"ATOM    733  CG  GLU A  46     -11.576   0.848   7.993  1.00  1.31           C  \n"
"ATOM    734  CD  GLU A  46     -12.107   0.545   9.395  1.00  1.80           C  \n"
"ATOM    735  OE1 GLU A  46     -13.089  -0.173   9.493  1.00  2.43           O  \n"
"ATOM    736  OE2 GLU A  46     -11.524   1.036  10.347  1.00  2.28           O  \n"
"ATOM    737  H   GLU A  46     -10.463   0.544   5.976  1.00  0.26           H  \n"
"ATOM    738  HA  GLU A  46     -13.077   1.706   5.136  1.00  0.25           H  \n"
"ATOM    739  HB2 GLU A  46     -12.650   2.674   7.668  1.00  0.94           H  \n"
"ATOM    740  HB3 GLU A  46     -13.570   1.217   7.300  1.00  0.93           H  \n"
"ATOM    741  HG2 GLU A  46     -11.404  -0.077   7.463  1.00  1.86           H  \n"
"ATOM    742  HG3 GLU A  46     -10.651   1.397   8.071  1.00  1.97           H  \n"
"ATOM    743  N   TYR A  47     -12.285   4.047   4.861  1.00  0.22           N  \n"
"ATOM    744  CA  TYR A  47     -11.744   5.402   4.559  1.00  0.22           C  \n"
"ATOM    745  C   TYR A  47     -12.564   6.446   5.329  1.00  0.26           C  \n"
"ATOM    746  O   TYR A  47     -13.586   6.110   5.892  1.00  0.29           O  \n"
"ATOM    747  CB  TYR A  47     -11.851   5.623   3.045  1.00  0.24           C  \n"
"ATOM    748  CG  TYR A  47     -10.868   4.720   2.323  1.00  0.24           C  \n"
"ATOM    749  CD1 TYR A  47      -9.830   4.081   3.021  1.00  1.25           C  \n"
"ATOM    750  CD2 TYR A  47     -10.994   4.520   0.945  1.00  1.21           C  \n"
"ATOM    751  CE1 TYR A  47      -8.935   3.251   2.342  1.00  1.27           C  \n"
"ATOM    752  CE2 TYR A  47     -10.094   3.692   0.272  1.00  1.20           C  \n"
"ATOM    753  CZ  TYR A  47      -9.067   3.058   0.970  1.00  0.29           C  \n"
"ATOM    754  OH  TYR A  47      -8.181   2.239   0.301  1.00  0.34           O  \n"
"ATOM    755  H   TYR A  47     -13.186   3.805   4.566  1.00  0.24           H  \n"
"ATOM    756  HA  TYR A  47     -10.715   5.454   4.865  1.00  0.21           H  \n"
"ATOM    757  HB2 TYR A  47     -12.851   5.384   2.720  1.00  0.27           H  \n"
"ATOM    758  HB3 TYR A  47     -11.639   6.648   2.806  1.00  0.26           H  \n"
"ATOM    759  HD1 TYR A  47      -9.713   4.232   4.078  1.00  2.17           H  \n"
"ATOM    760  HD2 TYR A  47     -11.776   5.012   0.397  1.00  2.14           H  \n"
"ATOM    761  HE1 TYR A  47      -8.130   2.771   2.877  1.00  2.20           H  \n"
"ATOM    762  HE2 TYR A  47     -10.182   3.551  -0.798  1.00  2.11           H  \n"
"ATOM    763  HH  TYR A  47      -7.325   2.299   0.736  1.00  0.80           H  \n"
"ATOM    764  N   PRO A  48     -12.102   7.682   5.359  1.00  0.27           N  \n"
"ATOM    765  CA  PRO A  48     -10.858   8.134   4.685  1.00  0.25           C  \n"
"ATOM    766  C   PRO A  48      -9.620   7.409   5.219  1.00  0.22           C  \n"
"ATOM    767  O   PRO A  48      -9.455   7.234   6.406  1.00  0.30           O  \n"
"ATOM    768  CB  PRO A  48     -10.761   9.631   5.010  1.00  0.28           C  \n"
"ATOM    769  CG  PRO A  48     -11.970  10.004   5.902  1.00  0.33           C  \n"
"ATOM    770  CD  PRO A  48     -12.815   8.738   6.097  1.00  0.32           C  \n"
"ATOM    771  HA  PRO A  48     -10.933   8.008   3.624  1.00  0.25           H  \n"
"ATOM    772  HB2 PRO A  48      -9.838   9.831   5.537  1.00  0.28           H  \n"
"ATOM    773  HB3 PRO A  48     -10.794  10.207   4.098  1.00  0.29           H  \n"
"ATOM    774  HG2 PRO A  48     -11.620  10.365   6.859  1.00  0.34           H  \n"
"ATOM    775  HG3 PRO A  48     -12.563  10.764   5.417  1.00  0.35           H  \n"
"ATOM    776  HD2 PRO A  48     -12.878   8.489   7.148  1.00  0.34           H  \n"
"ATOM    777  HD3 PRO A  48     -13.802   8.877   5.683  1.00  0.35           H  \n"
"ATOM    778  N   LEU A  49      -8.744   7.000   4.338  1.00  0.20           N  \n"
"ATOM    779  CA  LEU A  49      -7.502   6.298   4.775  1.00  0.19           C  \n"
"ATOM    780  C   LEU A  49      -6.301   7.182   4.462  1.00  0.19           C  \n"
"ATOM    781  O   LEU A  49      -6.335   7.998   3.567  1.00  0.20           O  \n"
"ATOM    782  CB  LEU A  49      -7.362   4.977   3.994  1.00  0.18           C  \n"
"ATOM    783  CG  LEU A  49      -5.885   4.560   3.861  1.00  0.17           C  \n"
"ATOM    784  CD1 LEU A  49      -5.350   4.066   5.209  1.00  0.20           C  \n"
"ATOM    785  CD2 LEU A  49      -5.759   3.447   2.816  1.00  0.16           C  \n"
"ATOM    786  H   LEU A  49      -8.899   7.162   3.382  1.00  0.25           H  \n"
"ATOM    787  HA  LEU A  49      -7.545   6.095   5.834  1.00  0.20           H  \n"
"ATOM    788  HB2 LEU A  49      -7.908   4.198   4.504  1.00  0.20           H  \n"
"ATOM    789  HB3 LEU A  49      -7.773   5.116   3.007  1.00  0.19           H  \n"
"ATOM    790  HG  LEU A  49      -5.305   5.406   3.538  1.00  0.16           H  \n"
"ATOM    791 HD11 LEU A  49      -6.077   4.273   5.980  1.00  0.96           H  \n"
"ATOM    792 HD12 LEU A  49      -5.171   3.003   5.158  1.00  1.01           H  \n"
"ATOM    793 HD13 LEU A  49      -4.420   4.578   5.444  1.00  0.99           H  \n"
"ATOM    794 HD21 LEU A  49      -6.585   3.508   2.120  1.00  1.00           H  \n"
"ATOM    795 HD22 LEU A  49      -4.827   3.566   2.278  1.00  1.04           H  \n"
"ATOM    796 HD23 LEU A  49      -5.771   2.486   3.308  1.00  1.05           H  \n"
"ATOM    797  N   VAL A  50      -5.222   6.985   5.157  1.00  0.21           N  \n"
"ATOM    798  CA  VAL A  50      -4.003   7.770   4.857  1.00  0.22           C  \n"
"ATOM    799  C   VAL A  50      -2.919   6.786   4.408  1.00  0.20           C  \n"
"ATOM    800  O   VAL A  50      -2.748   5.736   4.987  1.00  0.21           O  \n"
"ATOM    801  CB  VAL A  50      -3.555   8.555   6.114  1.00  0.26           C  \n"
"ATOM    802  CG1 VAL A  50      -2.135   8.158   6.542  1.00  0.26           C  \n"
"ATOM    803  CG2 VAL A  50      -3.567  10.051   5.802  1.00  0.29           C  \n"
"ATOM    804  H   VAL A  50      -5.204   6.294   5.852  1.00  0.22           H  \n"
"ATOM    805  HA  VAL A  50      -4.212   8.463   4.054  1.00  0.23           H  \n"
"ATOM    806  HB  VAL A  50      -4.241   8.353   6.923  1.00  0.27           H  \n"
"ATOM    807 HG11 VAL A  50      -1.496   8.116   5.669  1.00  1.02           H  \n"
"ATOM    808 HG12 VAL A  50      -1.749   8.892   7.235  1.00  1.04           H  \n"
"ATOM    809 HG13 VAL A  50      -2.159   7.190   7.019  1.00  1.01           H  \n"
"ATOM    810 HG21 VAL A  50      -4.513  10.319   5.357  1.00  0.95           H  \n"
"ATOM    811 HG22 VAL A  50      -3.426  10.609   6.716  1.00  1.05           H  \n"
"ATOM    812 HG23 VAL A  50      -2.765  10.279   5.115  1.00  1.06           H  \n"
"ATOM    813  N   LEU A  51      -2.167   7.122   3.409  1.00  0.19           N  \n"
"ATOM    814  CA  LEU A  51      -1.081   6.210   2.976  1.00  0.18           C  \n"
"ATOM    815  C   LEU A  51       0.228   6.969   3.109  1.00  0.18           C  \n"
"ATOM    816  O   LEU A  51       0.745   7.517   2.155  1.00  0.20           O  \n"
"ATOM    817  CB  LEU A  51      -1.267   5.748   1.523  1.00  0.17           C  \n"
"ATOM    818  CG  LEU A  51      -0.106   4.823   1.149  1.00  0.19           C  \n"
"ATOM    819  CD1 LEU A  51      -0.195   3.543   1.973  1.00  0.21           C  \n"
"ATOM    820  CD2 LEU A  51      -0.185   4.451  -0.328  1.00  0.18           C  \n"
"ATOM    821  H   LEU A  51      -2.294   7.982   2.968  1.00  0.21           H  \n"
"ATOM    822  HA  LEU A  51      -1.059   5.348   3.629  1.00  0.17           H  \n"
"ATOM    823  HB2 LEU A  51      -2.194   5.208   1.429  1.00  0.17           H  \n"
"ATOM    824  HB3 LEU A  51      -1.277   6.600   0.866  1.00  0.18           H  \n"
"ATOM    825  HG  LEU A  51       0.832   5.319   1.350  1.00  0.24           H  \n"
"ATOM    826 HD11 LEU A  51      -1.152   3.502   2.471  1.00  1.01           H  \n"
"ATOM    827 HD12 LEU A  51      -0.093   2.690   1.317  1.00  1.01           H  \n"
"ATOM    828 HD13 LEU A  51       0.597   3.530   2.707  1.00  0.99           H  \n"
"ATOM    829 HD21 LEU A  51      -1.201   4.568  -0.675  1.00  1.05           H  \n"
"ATOM    830 HD22 LEU A  51       0.471   5.093  -0.896  1.00  1.04           H  \n"
"ATOM    831 HD23 LEU A  51       0.121   3.418  -0.450  1.00  1.02           H  \n"
"ATOM    832  N   GLU A  52       0.760   7.014   4.296  1.00  0.19           N  \n"
"ATOM    833  CA  GLU A  52       2.031   7.743   4.505  1.00  0.21           C  \n"
"ATOM    834  C   GLU A  52       3.158   6.861   3.988  1.00  0.19           C  \n"
"ATOM    835  O   GLU A  52       3.789   6.122   4.721  1.00  0.19           O  \n"
"ATOM    836  CB  GLU A  52       2.213   8.030   5.996  1.00  0.24           C  \n"
"ATOM    837  CG  GLU A  52       3.642   8.508   6.256  1.00  0.30           C  \n"
"ATOM    838  CD  GLU A  52       3.650   9.471   7.444  1.00  0.64           C  \n"
"ATOM    839  OE1 GLU A  52       2.717   9.420   8.229  1.00  1.28           O  \n"
"ATOM    840  OE2 GLU A  52       4.588  10.244   7.550  1.00  1.44           O  \n"
"ATOM    841  H   GLU A  52       0.318   6.571   5.050  1.00  0.20           H  \n"
"ATOM    842  HA  GLU A  52       2.015   8.670   3.953  1.00  0.23           H  \n"
"ATOM    843  HB2 GLU A  52       1.512   8.798   6.299  1.00  0.25           H  \n"
"ATOM    844  HB3 GLU A  52       2.025   7.130   6.562  1.00  0.24           H  \n"
"ATOM    845  HG2 GLU A  52       4.271   7.658   6.477  1.00  0.57           H  \n"
"ATOM    846  HG3 GLU A  52       4.017   9.017   5.381  1.00  0.52           H  \n"
"ATOM    847  N   TRP A  53       3.385   6.915   2.708  1.00  0.20           N  \n"
"ATOM    848  CA  TRP A  53       4.436   6.072   2.099  1.00  0.20           C  \n"
"ATOM    849  C   TRP A  53       5.813   6.694   2.321  1.00  0.24           C  \n"
"ATOM    850  O   TRP A  53       6.142   7.720   1.760  1.00  0.38           O  \n"
"ATOM    851  CB  TRP A  53       4.175   5.945   0.603  1.00  0.24           C  \n"
"ATOM    852  CG  TRP A  53       4.807   4.689   0.123  1.00  0.23           C  \n"
"ATOM    853  CD1 TRP A  53       6.084   4.326   0.376  1.00  0.25           C  \n"
"ATOM    854  CD2 TRP A  53       4.223   3.620  -0.671  1.00  0.21           C  \n"
"ATOM    855  NE1 TRP A  53       6.325   3.103  -0.214  1.00  0.26           N  \n"
"ATOM    856  CE2 TRP A  53       5.210   2.627  -0.872  1.00  0.24           C  \n"
"ATOM    857  CE3 TRP A  53       2.948   3.416  -1.234  1.00  0.21           C  \n"
"ATOM    858  CZ2 TRP A  53       4.946   1.474  -1.601  1.00  0.25           C  \n"
"ATOM    859  CZ3 TRP A  53       2.684   2.251  -1.974  1.00  0.23           C  \n"
"ATOM    860  CH2 TRP A  53       3.682   1.284  -2.156  1.00  0.25           C  \n"
"ATOM    861  H   TRP A  53       2.842   7.501   2.141  1.00  0.22           H  \n"
"ATOM    862  HA  TRP A  53       4.406   5.089   2.545  1.00  0.20           H  \n"
"ATOM    863  HB2 TRP A  53       3.111   5.911   0.421  1.00  0.28           H  \n"
"ATOM    864  HB3 TRP A  53       4.606   6.789   0.085  1.00  0.30           H  \n"
"ATOM    865  HD1 TRP A  53       6.800   4.901   0.946  1.00  0.28           H  \n"
"ATOM    866  HE1 TRP A  53       7.175   2.618  -0.182  1.00  0.29           H  \n"
"ATOM    867  HE3 TRP A  53       2.166   4.156  -1.091  1.00  0.23           H  \n"
"ATOM    868  HZ2 TRP A  53       5.715   0.731  -1.736  1.00  0.29           H  \n"
"ATOM    869  HZ3 TRP A  53       1.712   2.103  -2.412  1.00  0.25           H  \n"
"ATOM    870  HH2 TRP A  53       3.474   0.393  -2.726  1.00  0.27           H  \n"
"ATOM    871  N   ARG A  54       6.627   6.069   3.124  1.00  0.26           N  \n"
"ATOM    872  CA  ARG A  54       7.992   6.607   3.371  1.00  0.35           C  \n"
"ATOM    873  C   ARG A  54       8.988   5.823   2.515  1.00  0.49           C  \n"
"ATOM    874  O   ARG A  54       8.781   4.663   2.219  1.00  1.33           O  \n"
"ATOM    875  CB  ARG A  54       8.346   6.446   4.849  1.00  0.44           C  \n"
"ATOM    876  CG  ARG A  54       8.545   7.825   5.481  1.00  0.88           C  \n"
"ATOM    877  CD  ARG A  54       8.772   7.667   6.985  1.00  1.09           C  \n"
"ATOM    878  NE  ARG A  54      10.009   8.396   7.382  1.00  1.40           N  \n"
"ATOM    879  CZ  ARG A  54      10.254   8.632   8.637  1.00  1.87           C  \n"
"ATOM    880  NH1 ARG A  54      10.719   7.683   9.399  1.00  2.47           N  \n"
"ATOM    881  NH2 ARG A  54      10.035   9.816   9.133  1.00  2.46           N  \n"
"ATOM    882  H   ARG A  54       6.344   5.236   3.555  1.00  0.34           H  \n"
"ATOM    883  HA  ARG A  54       8.025   7.652   3.100  1.00  0.38           H  \n"
"ATOM    884  HB2 ARG A  54       7.543   5.930   5.357  1.00  0.76           H  \n"
"ATOM    885  HB3 ARG A  54       9.257   5.874   4.943  1.00  0.79           H  \n"
"ATOM    886  HG2 ARG A  54       9.402   8.307   5.032  1.00  1.47           H  \n"
"ATOM    887  HG3 ARG A  54       7.664   8.426   5.313  1.00  1.66           H  \n"
"ATOM    888  HD2 ARG A  54       7.929   8.074   7.521  1.00  1.82           H  \n"
"ATOM    889  HD3 ARG A  54       8.876   6.618   7.224  1.00  1.61           H  \n"
"ATOM    890  HE  ARG A  54      10.641   8.699   6.697  1.00  1.89           H  \n"
"ATOM    891 HH11 ARG A  54      10.887   6.774   9.016  1.00  2.73           H  \n"
"ATOM    892 HH12 ARG A  54      10.910   7.862  10.362  1.00  3.03           H  \n"
"ATOM    893 HH21 ARG A  54       9.680  10.544   8.547  1.00  2.76           H  \n"
"ATOM    894 HH22 ARG A  54      10.226   9.998  10.097  1.00  2.96           H  \n"
"ATOM    895  N   GLN A  55      10.062   6.439   2.107  1.00  0.53           N  \n"
"ATOM    896  CA  GLN A  55      11.050   5.709   1.264  1.00  0.46           C  \n"
"ATOM    897  C   GLN A  55      10.308   5.032   0.111  1.00  0.53           C  \n"
"ATOM    898  O   GLN A  55      10.193   3.826   0.056  1.00  1.30           O  \n"
"ATOM    899  CB  GLN A  55      11.759   4.650   2.111  1.00  0.55           C  \n"
"ATOM    900  CG  GLN A  55      13.251   4.974   2.186  1.00  1.05           C  \n"
"ATOM    901  CD  GLN A  55      13.542   5.750   3.472  1.00  1.22           C  \n"
"ATOM    902  OE1 GLN A  55      12.710   5.822   4.354  1.00  1.82           O  \n"
"ATOM    903  NE2 GLN A  55      14.698   6.338   3.616  1.00  1.89           N  \n"
"ATOM    904  H   GLN A  55      10.215   7.377   2.347  1.00  1.19           H  \n"
"ATOM    905  HA  GLN A  55      11.776   6.406   0.870  1.00  0.53           H  \n"
"ATOM    906  HB2 GLN A  55      11.340   4.644   3.107  1.00  0.71           H  \n"
"ATOM    907  HB3 GLN A  55      11.626   3.678   1.658  1.00  1.00           H  \n"
"ATOM    908  HG2 GLN A  55      13.820   4.055   2.181  1.00  1.76           H  \n"
"ATOM    909  HG3 GLN A  55      13.530   5.575   1.335  1.00  1.67           H  \n"
"ATOM    910 HE21 GLN A  55      15.369   6.280   2.904  1.00  2.32           H  \n"
"ATOM    911 HE22 GLN A  55      14.895   6.838   4.435  1.00  2.39           H  \n"
"ATOM    912  N   PHE A  56       9.791   5.807  -0.801  1.00  0.64           N  \n"
"ATOM    913  CA  PHE A  56       9.035   5.228  -1.949  1.00  0.57           C  \n"
"ATOM    914  C   PHE A  56      10.002   4.576  -2.944  1.00  0.71           C  \n"
"ATOM    915  O   PHE A  56      10.000   3.374  -3.124  1.00  1.62           O  \n"
"ATOM    916  CB  PHE A  56       8.267   6.356  -2.637  1.00  0.62           C  \n"
"ATOM    917  CG  PHE A  56       7.213   5.805  -3.572  1.00  0.57           C  \n"
"ATOM    918  CD1 PHE A  56       6.938   4.430  -3.629  1.00  1.37           C  \n"
"ATOM    919  CD2 PHE A  56       6.504   6.690  -4.386  1.00  1.31           C  \n"
"ATOM    920  CE1 PHE A  56       5.953   3.951  -4.507  1.00  1.40           C  \n"
"ATOM    921  CE2 PHE A  56       5.522   6.212  -5.260  1.00  1.40           C  \n"
"ATOM    922  CZ  PHE A  56       5.249   4.842  -5.323  1.00  0.79           C  \n"
"ATOM    923  H   PHE A  56       9.889   6.779  -0.725  1.00  1.28           H  \n"
"ATOM    924  HA  PHE A  56       8.339   4.490  -1.582  1.00  0.53           H  \n"
"ATOM    925  HB2 PHE A  56       7.788   6.966  -1.886  1.00  0.66           H  \n"
"ATOM    926  HB3 PHE A  56       8.959   6.965  -3.200  1.00  0.80           H  \n"
"ATOM    927  HD1 PHE A  56       7.482   3.741  -3.004  1.00  2.26           H  \n"
"ATOM    928  HD2 PHE A  56       6.705   7.752  -4.327  1.00  2.17           H  \n"
"ATOM    929  HE1 PHE A  56       5.732   2.896  -4.550  1.00  2.26           H  \n"
"ATOM    930  HE2 PHE A  56       4.978   6.900  -5.890  1.00  2.29           H  \n"
"ATOM    931  HZ  PHE A  56       4.493   4.472  -5.998  1.00  0.95           H  \n"
"ATOM    932  N   GLU A  57      10.824   5.355  -3.595  1.00  0.67           N  \n"
"ATOM    933  CA  GLU A  57      11.784   4.768  -4.576  1.00  0.65           C  \n"
"ATOM    934  C   GLU A  57      12.637   3.708  -3.882  1.00  0.58           C  \n"
"ATOM    935  O   GLU A  57      13.002   2.709  -4.467  1.00  0.58           O  \n"
"ATOM    936  CB  GLU A  57      12.703   5.861  -5.118  1.00  0.80           C  \n"
"ATOM    937  CG  GLU A  57      11.991   6.634  -6.229  1.00  1.16           C  \n"
"ATOM    938  CD  GLU A  57      12.794   7.891  -6.571  1.00  1.75           C  \n"
"ATOM    939  OE1 GLU A  57      13.812   8.110  -5.935  1.00  2.34           O  \n"
"ATOM    940  OE2 GLU A  57      12.378   8.612  -7.462  1.00  2.41           O  \n"
"ATOM    941  H   GLU A  57      10.810   6.322  -3.440  1.00  1.34           H  \n"
"ATOM    942  HA  GLU A  57      11.238   4.318  -5.392  1.00  0.66           H  \n"
"ATOM    943  HB2 GLU A  57      12.966   6.536  -4.317  1.00  1.21           H  \n"
"ATOM    944  HB3 GLU A  57      13.597   5.405  -5.514  1.00  1.06           H  \n"
"ATOM    945  HG2 GLU A  57      11.908   6.009  -7.106  1.00  1.71           H  \n"
"ATOM    946  HG3 GLU A  57      11.004   6.919  -5.896  1.00  1.62           H  \n"
"ATOM    947  N   GLN A  58      12.961   3.924  -2.638  1.00  0.58           N  \n"
"ATOM    948  CA  GLN A  58      13.786   2.942  -1.899  1.00  0.60           C  \n"
"ATOM    949  C   GLN A  58      12.982   1.655  -1.731  1.00  0.53           C  \n"
"ATOM    950  O   GLN A  58      13.524   0.569  -1.730  1.00  0.56           O  \n"
"ATOM    951  CB  GLN A  58      14.158   3.516  -0.530  1.00  0.69           C  \n"
"ATOM    952  CG  GLN A  58      15.064   4.735  -0.723  1.00  0.94           C  \n"
"ATOM    953  CD  GLN A  58      16.526   4.322  -0.542  1.00  1.56           C  \n"
"ATOM    954  OE1 GLN A  58      16.810   3.268  -0.008  1.00  2.34           O  \n"
"ATOM    955  NE2 GLN A  58      17.472   5.114  -0.966  1.00  1.94           N  \n"
"ATOM    956  H   GLN A  58      12.664   4.732  -2.195  1.00  0.61           H  \n"
"ATOM    957  HA  GLN A  58      14.680   2.741  -2.460  1.00  0.68           H  \n"
"ATOM    958  HB2 GLN A  58      13.260   3.812  -0.007  1.00  0.78           H  \n"
"ATOM    959  HB3 GLN A  58      14.682   2.768   0.046  1.00  0.82           H  \n"
"ATOM    960  HG2 GLN A  58      14.923   5.132  -1.718  1.00  1.18           H  \n"
"ATOM    961  HG3 GLN A  58      14.813   5.490   0.004  1.00  1.25           H  \n"
"ATOM    962 HE21 GLN A  58      17.243   5.964  -1.397  1.00  2.09           H  \n"
"ATOM    963 HE22 GLN A  58      18.412   4.859  -0.855  1.00  2.49           H  \n"
"ATOM    964  N   SER A  59      11.685   1.773  -1.611  1.00  0.52           N  \n"
"ATOM    965  CA  SER A  59      10.829   0.560  -1.473  1.00  0.52           C  \n"
"ATOM    966  C   SER A  59      10.318   0.172  -2.859  1.00  0.44           C  \n"
"ATOM    967  O   SER A  59       9.371  -0.576  -3.002  1.00  0.48           O  \n"
"ATOM    968  CB  SER A  59       9.639   0.859  -0.562  1.00  0.65           C  \n"
"ATOM    969  OG  SER A  59       9.861   0.266   0.709  1.00  1.39           O  \n"
"ATOM    970  H   SER A  59      11.273   2.661  -1.630  1.00  0.57           H  \n"
"ATOM    971  HA  SER A  59      11.414  -0.253  -1.061  1.00  0.57           H  \n"
"ATOM    972  HB2 SER A  59       9.530   1.923  -0.444  1.00  1.32           H  \n"
"ATOM    973  HB3 SER A  59       8.739   0.455  -1.005  1.00  1.16           H  \n"
"ATOM    974  HG  SER A  59       9.090   0.437   1.254  1.00  1.85           H  \n"
"ATOM    975  N   LYS A  60      10.954   0.675  -3.881  1.00  0.41           N  \n"
"ATOM    976  CA  LYS A  60      10.532   0.342  -5.266  1.00  0.42           C  \n"
"ATOM    977  C   LYS A  60      11.614  -0.520  -5.922  1.00  0.44           C  \n"
"ATOM    978  O   LYS A  60      11.326  -1.436  -6.666  1.00  0.55           O  \n"
"ATOM    979  CB  LYS A  60      10.356   1.636  -6.062  1.00  0.51           C  \n"
"ATOM    980  CG  LYS A  60       9.518   1.361  -7.311  1.00  1.03           C  \n"
"ATOM    981  CD  LYS A  60       9.317   2.665  -8.084  1.00  1.61           C  \n"
"ATOM    982  CE  LYS A  60       9.529   2.412  -9.575  1.00  2.36           C  \n"
"ATOM    983  NZ  LYS A  60      10.507   3.397 -10.112  1.00  3.11           N  \n"
"ATOM    984  H   LYS A  60      11.719   1.272  -3.737  1.00  0.45           H  \n"
"ATOM    985  HA  LYS A  60       9.599  -0.201  -5.242  1.00  0.45           H  \n"
"ATOM    986  HB2 LYS A  60       9.855   2.369  -5.448  1.00  0.84           H  \n"
"ATOM    987  HB3 LYS A  60      11.324   2.012  -6.356  1.00  0.92           H  \n"
"ATOM    988  HG2 LYS A  60      10.029   0.643  -7.938  1.00  1.56           H  \n"
"ATOM    989  HG3 LYS A  60       8.557   0.967  -7.020  1.00  1.36           H  \n"
"ATOM    990  HD2 LYS A  60       8.313   3.027  -7.920  1.00  2.03           H  \n"
"ATOM    991  HD3 LYS A  60      10.027   3.403  -7.741  1.00  2.04           H  \n"
"ATOM    992  HE2 LYS A  60       9.908   1.412  -9.721  1.00  2.76           H  \n"
"ATOM    993  HE3 LYS A  60       8.588   2.521 -10.093  1.00  2.69           H  \n"
"ATOM    994  HZ1 LYS A  60      10.227   4.356  -9.825  1.00  3.41           H  \n"
"ATOM    995  HZ2 LYS A  60      11.453   3.188  -9.737  1.00  3.45           H  \n"
"ATOM    996  HZ3 LYS A  60      10.522   3.336 -11.150  1.00  3.55           H  \n"
"ATOM    997  N   GLN A  61      12.860  -0.228  -5.655  1.00  0.51           N  \n"
"ATOM    998  CA  GLN A  61      13.963  -1.020  -6.264  1.00  0.62           C  \n"
"ATOM    999  C   GLN A  61      14.010  -2.425  -5.651  1.00  0.60           C  \n"
"ATOM   1000  O   GLN A  61      13.841  -3.416  -6.332  1.00  0.66           O  \n"
"ATOM   1001  CB  GLN A  61      15.297  -0.315  -6.006  1.00  0.73           C  \n"
"ATOM   1002  CG  GLN A  61      15.326   1.021  -6.751  1.00  1.14           C  \n"
"ATOM   1003  CD  GLN A  61      16.704   1.221  -7.385  1.00  1.66           C  \n"
"ATOM   1004  OE1 GLN A  61      17.499   0.303  -7.440  1.00  2.16           O  \n"
"ATOM   1005  NE2 GLN A  61      17.024   2.390  -7.868  1.00  2.39           N  \n"
"ATOM   1006  H   GLN A  61      13.070   0.519  -5.059  1.00  0.58           H  \n"
"ATOM   1007  HA  GLN A  61      13.798  -1.092  -7.320  1.00  0.68           H  \n"
"ATOM   1008  HB2 GLN A  61      15.410  -0.139  -4.945  1.00  0.81           H  \n"
"ATOM   1009  HB3 GLN A  61      16.106  -0.938  -6.356  1.00  0.88           H  \n"
"ATOM   1010  HG2 GLN A  61      14.571   1.019  -7.523  1.00  1.53           H  \n"
"ATOM   1011  HG3 GLN A  61      15.131   1.825  -6.057  1.00  1.54           H  \n"
"ATOM   1012 HE21 GLN A  61      16.383   3.131  -7.822  1.00  2.75           H  \n"
"ATOM   1013 HE22 GLN A  61      17.904   2.528  -8.276  1.00  2.92           H  \n"
"ATOM   1014  N   LEU A  62      14.264  -2.497  -4.372  1.00  0.64           N  \n"
"ATOM   1015  CA  LEU A  62      14.358  -3.820  -3.661  1.00  0.71           C  \n"
"ATOM   1016  C   LEU A  62      13.391  -4.833  -4.276  1.00  0.67           C  \n"
"ATOM   1017  O   LEU A  62      13.653  -6.019  -4.302  1.00  0.94           O  \n"
"ATOM   1018  CB  LEU A  62      13.995  -3.678  -2.170  1.00  0.78           C  \n"
"ATOM   1019  CG  LEU A  62      13.609  -2.241  -1.817  1.00  0.78           C  \n"
"ATOM   1020  CD1 LEU A  62      12.330  -1.844  -2.561  1.00  0.66           C  \n"
"ATOM   1021  CD2 LEU A  62      13.367  -2.146  -0.310  1.00  0.94           C  \n"
"ATOM   1022  H   LEU A  62      14.415  -1.673  -3.879  1.00  0.70           H  \n"
"ATOM   1023  HA  LEU A  62      15.366  -4.197  -3.745  1.00  0.80           H  \n"
"ATOM   1024  HB2 LEU A  62      13.165  -4.329  -1.946  1.00  0.78           H  \n"
"ATOM   1025  HB3 LEU A  62      14.843  -3.970  -1.571  1.00  0.89           H  \n"
"ATOM   1026  HG  LEU A  62      14.411  -1.572  -2.092  1.00  0.81           H  \n"
"ATOM   1027 HD11 LEU A  62      12.281  -2.353  -3.506  1.00  1.33           H  \n"
"ATOM   1028 HD12 LEU A  62      11.465  -2.111  -1.971  1.00  1.10           H  \n"
"ATOM   1029 HD13 LEU A  62      12.337  -0.784  -2.731  1.00  1.10           H  \n"
"ATOM   1030 HD21 LEU A  62      12.694  -2.933  -0.004  1.00  1.39           H  \n"
"ATOM   1031 HD22 LEU A  62      14.306  -2.252   0.212  1.00  1.38           H  \n"
"ATOM   1032 HD23 LEU A  62      12.930  -1.187  -0.076  1.00  1.48           H  \n"
"ATOM   1033  N   THR A  63      12.276  -4.379  -4.770  1.00  0.58           N  \n"
"ATOM   1034  CA  THR A  63      11.298  -5.309  -5.376  1.00  0.70           C  \n"
"ATOM   1035  C   THR A  63      10.933  -4.785  -6.761  1.00  0.81           C  \n"
"ATOM   1036  O   THR A  63       9.802  -4.445  -7.030  1.00  0.89           O  \n"
"ATOM   1037  CB  THR A  63      10.042  -5.450  -4.482  1.00  0.65           C  \n"
"ATOM   1038  OG1 THR A  63       8.893  -5.599  -5.300  1.00  0.72           O  \n"
"ATOM   1039  CG2 THR A  63       9.848  -4.231  -3.559  1.00  0.52           C  \n"
"ATOM   1040  H   THR A  63      12.087  -3.425  -4.752  1.00  0.65           H  \n"
"ATOM   1041  HA  THR A  63      11.761  -6.276  -5.486  1.00  0.91           H  \n"
"ATOM   1042  HB  THR A  63      10.150  -6.332  -3.870  1.00  0.82           H  \n"
"ATOM   1043  HG1 THR A  63       9.001  -6.400  -5.817  1.00  1.10           H  \n"
"ATOM   1044 HG21 THR A  63      10.697  -3.574  -3.623  1.00  1.22           H  \n"
"ATOM   1045 HG22 THR A  63       8.959  -3.696  -3.856  1.00  1.12           H  \n"
"ATOM   1046 HG23 THR A  63       9.735  -4.567  -2.537  1.00  1.06           H  \n"
"ATOM   1047  N   GLU A  64      11.921  -4.721  -7.629  1.00  0.95           N  \n"
"ATOM   1048  CA  GLU A  64      11.731  -4.227  -9.035  1.00  1.21           C  \n"
"ATOM   1049  C   GLU A  64      10.247  -4.117  -9.389  1.00  1.18           C  \n"
"ATOM   1050  O   GLU A  64       9.570  -5.108  -9.578  1.00  1.53           O  \n"
"ATOM   1051  CB  GLU A  64      12.403  -5.214  -9.993  1.00  1.55           C  \n"
"ATOM   1052  CG  GLU A  64      12.903  -4.472 -11.231  1.00  1.91           C  \n"
"ATOM   1053  CD  GLU A  64      14.052  -5.257 -11.865  1.00  2.44           C  \n"
"ATOM   1054  OE1 GLU A  64      14.291  -6.373 -11.432  1.00  3.09           O  \n"
"ATOM   1055  OE2 GLU A  64      14.675  -4.730 -12.771  1.00  2.79           O  \n"
"ATOM   1056  H   GLU A  64      12.817  -5.003  -7.344  1.00  0.95           H  \n"
"ATOM   1057  HA  GLU A  64      12.197  -3.260  -9.140  1.00  1.31           H  \n"
"ATOM   1058  HB2 GLU A  64      13.237  -5.686  -9.495  1.00  1.89           H  \n"
"ATOM   1059  HB3 GLU A  64      11.689  -5.968 -10.291  1.00  1.80           H  \n"
"ATOM   1060  HG2 GLU A  64      12.095  -4.376 -11.943  1.00  2.30           H  \n"
"ATOM   1061  HG3 GLU A  64      13.252  -3.491 -10.947  1.00  2.19           H  \n"
"ATOM   1062  N   ASN A  65       9.732  -2.920  -9.470  1.00  1.70           N  \n"
"ATOM   1063  CA  ASN A  65       8.289  -2.761  -9.802  1.00  1.68           C  \n"
"ATOM   1064  C   ASN A  65       7.456  -3.157  -8.582  1.00  0.85           C  \n"
"ATOM   1065  O   ASN A  65       6.375  -3.697  -8.706  1.00  1.09           O  \n"
"ATOM   1066  CB  ASN A  65       7.944  -3.685 -10.974  1.00  2.27           C  \n"
"ATOM   1067  CG  ASN A  65       6.828  -3.063 -11.814  1.00  2.89           C  \n"
"ATOM   1068  OD1 ASN A  65       6.854  -1.884 -12.103  1.00  3.24           O  \n"
"ATOM   1069  ND2 ASN A  65       5.844  -3.815 -12.224  1.00  3.66           N  \n"
"ATOM   1070  H   ASN A  65      10.290  -2.131  -9.307  1.00  2.39           H  \n"
"ATOM   1071  HA  ASN A  65       8.085  -1.736 -10.071  1.00  2.30           H  \n"
"ATOM   1072  HB2 ASN A  65       8.821  -3.829 -11.589  1.00  2.72           H  \n"
"ATOM   1073  HB3 ASN A  65       7.613  -4.640 -10.593  1.00  2.52           H  \n"
"ATOM   1074 HD21 ASN A  65       5.826  -4.768 -11.993  1.00  3.87           H  \n"
"ATOM   1075 HD22 ASN A  65       5.124  -3.429 -12.766  1.00  4.28           H  \n"
"ATOM   1076  N   GLY A  66       7.968  -2.928  -7.401  1.00  0.56           N  \n"
"ATOM   1077  CA  GLY A  66       7.225  -3.330  -6.177  1.00  1.20           C  \n"
"ATOM   1078  C   GLY A  66       6.279  -2.227  -5.680  1.00  0.91           C  \n"
"ATOM   1079  O   GLY A  66       5.073  -2.381  -5.677  1.00  1.26           O  \n"
"ATOM   1080  H   GLY A  66       8.861  -2.521  -7.319  1.00  0.73           H  \n"
"ATOM   1081  HA2 GLY A  66       6.652  -4.220  -6.387  1.00  1.86           H  \n"
"ATOM   1082  HA3 GLY A  66       7.945  -3.548  -5.395  1.00  1.89           H  \n"
"ATOM   1083  N   ALA A  67       6.826  -1.155  -5.185  1.00  0.39           N  \n"
"ATOM   1084  CA  ALA A  67       5.996  -0.071  -4.590  1.00  0.46           C  \n"
"ATOM   1085  C   ALA A  67       5.313   0.846  -5.615  1.00  0.34           C  \n"
"ATOM   1086  O   ALA A  67       4.352   1.513  -5.286  1.00  0.53           O  \n"
"ATOM   1087  CB  ALA A  67       6.909   0.777  -3.713  1.00  0.64           C  \n"
"ATOM   1088  H   ALA A  67       7.795  -1.087  -5.142  1.00  0.28           H  \n"
"ATOM   1089  HA  ALA A  67       5.245  -0.516  -3.971  1.00  0.76           H  \n"
"ATOM   1090  HB1 ALA A  67       7.781   1.063  -4.283  1.00  1.13           H  \n"
"ATOM   1091  HB2 ALA A  67       6.385   1.660  -3.391  1.00  1.32           H  \n"
"ATOM   1092  HB3 ALA A  67       7.213   0.202  -2.851  1.00  1.26           H  \n"
"ATOM   1093  N   GLU A  68       5.778   0.935  -6.823  1.00  0.27           N  \n"
"ATOM   1094  CA  GLU A  68       5.129   1.851  -7.769  1.00  0.38           C  \n"
"ATOM   1095  C   GLU A  68       3.751   1.292  -8.176  1.00  0.39           C  \n"
"ATOM   1096  O   GLU A  68       2.884   2.021  -8.617  1.00  0.49           O  \n"
"ATOM   1097  CB  GLU A  68       6.069   2.020  -8.971  1.00  0.51           C  \n"
"ATOM   1098  CG  GLU A  68       5.274   2.020 -10.258  1.00  1.38           C  \n"
"ATOM   1099  CD  GLU A  68       6.148   2.521 -11.410  1.00  1.57           C  \n"
"ATOM   1100  OE1 GLU A  68       6.989   3.370 -11.165  1.00  1.83           O  \n"
"ATOM   1101  OE2 GLU A  68       5.961   2.047 -12.518  1.00  2.27           O  \n"
"ATOM   1102  H   GLU A  68       6.553   0.431  -7.109  1.00  0.40           H  \n"
"ATOM   1103  HA  GLU A  68       4.997   2.803  -7.289  1.00  0.45           H  \n"
"ATOM   1104  HB2 GLU A  68       6.607   2.952  -8.879  1.00  1.06           H  \n"
"ATOM   1105  HB3 GLU A  68       6.773   1.201  -8.989  1.00  1.06           H  \n"
"ATOM   1106  HG2 GLU A  68       4.950   1.011 -10.449  1.00  2.01           H  \n"
"ATOM   1107  HG3 GLU A  68       4.418   2.664 -10.144  1.00  2.12           H  \n"
"ATOM   1108  N   SER A  69       3.544   0.011  -8.034  1.00  0.39           N  \n"
"ATOM   1109  CA  SER A  69       2.227  -0.585  -8.417  1.00  0.47           C  \n"
"ATOM   1110  C   SER A  69       1.196  -0.382  -7.297  1.00  0.37           C  \n"
"ATOM   1111  O   SER A  69       0.120   0.157  -7.510  1.00  0.35           O  \n"
"ATOM   1112  CB  SER A  69       2.405  -2.082  -8.669  1.00  0.58           C  \n"
"ATOM   1113  OG  SER A  69       2.127  -2.366 -10.033  1.00  0.90           O  \n"
"ATOM   1114  H   SER A  69       4.256  -0.563  -7.679  1.00  0.40           H  \n"
"ATOM   1115  HA  SER A  69       1.871  -0.112  -9.320  1.00  0.55           H  \n"
"ATOM   1116  HB2 SER A  69       3.420  -2.368  -8.447  1.00  0.81           H  \n"
"ATOM   1117  HB3 SER A  69       1.730  -2.635  -8.029  1.00  0.78           H  \n"
"ATOM   1118  HG  SER A  69       2.943  -2.269 -10.529  1.00  1.26           H  \n"
"ATOM   1119  N   VAL A  70       1.509  -0.818  -6.106  1.00  0.34           N  \n"
"ATOM   1120  CA  VAL A  70       0.544  -0.662  -4.984  1.00  0.27           C  \n"
"ATOM   1121  C   VAL A  70       0.107   0.793  -4.912  1.00  0.20           C  \n"
"ATOM   1122  O   VAL A  70      -1.057   1.098  -4.748  1.00  0.20           O  \n"
"ATOM   1123  CB  VAL A  70       1.215  -1.063  -3.671  1.00  0.31           C  \n"
"ATOM   1124  CG1 VAL A  70       0.288  -0.737  -2.499  1.00  0.29           C  \n"
"ATOM   1125  CG2 VAL A  70       1.504  -2.565  -3.687  1.00  0.41           C  \n"
"ATOM   1126  H   VAL A  70       2.375  -1.246  -5.951  1.00  0.38           H  \n"
"ATOM   1127  HA  VAL A  70      -0.317  -1.290  -5.158  1.00  0.28           H  \n"
"ATOM   1128  HB  VAL A  70       2.138  -0.519  -3.561  1.00  0.33           H  \n"
"ATOM   1129 HG11 VAL A  70      -0.469  -0.036  -2.819  1.00  1.06           H  \n"
"ATOM   1130 HG12 VAL A  70      -0.186  -1.644  -2.153  1.00  1.07           H  \n"
"ATOM   1131 HG13 VAL A  70       0.863  -0.303  -1.696  1.00  1.02           H  \n"
"ATOM   1132 HG21 VAL A  70       0.701  -3.081  -4.191  1.00  1.06           H  \n"
"ATOM   1133 HG22 VAL A  70       2.432  -2.747  -4.209  1.00  1.03           H  \n"
"ATOM   1134 HG23 VAL A  70       1.585  -2.927  -2.673  1.00  0.96           H  \n"
"ATOM   1135  N   LEU A  71       1.033   1.696  -5.048  1.00  0.24           N  \n"
"ATOM   1136  CA  LEU A  71       0.663   3.134  -5.002  1.00  0.23           C  \n"
"ATOM   1137  C   LEU A  71      -0.340   3.411  -6.113  1.00  0.23           C  \n"
"ATOM   1138  O   LEU A  71      -1.335   4.061  -5.909  1.00  0.23           O  \n"
"ATOM   1139  CB  LEU A  71       1.897   3.996  -5.229  1.00  0.30           C  \n"
"ATOM   1140  CG  LEU A  71       1.476   5.464  -5.305  1.00  0.35           C  \n"
"ATOM   1141  CD1 LEU A  71       1.177   5.986  -3.899  1.00  0.36           C  \n"
"ATOM   1142  CD2 LEU A  71       2.605   6.290  -5.924  1.00  0.43           C  \n"
"ATOM   1143  H   LEU A  71       1.966   1.424  -5.191  1.00  0.31           H  \n"
"ATOM   1144  HA  LEU A  71       0.223   3.368  -4.044  1.00  0.21           H  \n"
"ATOM   1145  HB2 LEU A  71       2.595   3.856  -4.416  1.00  0.30           H  \n"
"ATOM   1146  HB3 LEU A  71       2.355   3.708  -6.157  1.00  0.34           H  \n"
"ATOM   1147  HG  LEU A  71       0.588   5.549  -5.916  1.00  0.40           H  \n"
"ATOM   1148 HD11 LEU A  71       0.910   5.159  -3.258  1.00  1.03           H  \n"
"ATOM   1149 HD12 LEU A  71       2.053   6.479  -3.504  1.00  1.04           H  \n"
"ATOM   1150 HD13 LEU A  71       0.357   6.687  -3.942  1.00  1.06           H  \n"
"ATOM   1151 HD21 LEU A  71       3.189   5.665  -6.584  1.00  1.11           H  \n"
"ATOM   1152 HD22 LEU A  71       2.185   7.111  -6.485  1.00  1.14           H  \n"
"ATOM   1153 HD23 LEU A  71       3.238   6.677  -5.140  1.00  1.05           H  \n"
"ATOM   1154  N   GLN A  72      -0.083   2.914  -7.289  1.00  0.28           N  \n"
"ATOM   1155  CA  GLN A  72      -1.027   3.138  -8.419  1.00  0.30           C  \n"
"ATOM   1156  C   GLN A  72      -2.417   2.716  -7.977  1.00  0.25           C  \n"
"ATOM   1157  O   GLN A  72      -3.408   3.314  -8.334  1.00  0.25           O  \n"
"ATOM   1158  CB  GLN A  72      -0.583   2.279  -9.617  1.00  0.35           C  \n"
"ATOM   1159  CG  GLN A  72      -1.789   1.868 -10.473  1.00  1.18           C  \n"
"ATOM   1160  CD  GLN A  72      -1.304   1.317 -11.813  1.00  1.42           C  \n"
"ATOM   1161  OE1 GLN A  72      -1.069   2.064 -12.742  1.00  1.78           O  \n"
"ATOM   1162  NE2 GLN A  72      -1.144   0.029 -11.955  1.00  1.97           N  \n"
"ATOM   1163  H   GLN A  72       0.729   2.385  -7.429  1.00  0.33           H  \n"
"ATOM   1164  HA  GLN A  72      -1.035   4.183  -8.688  1.00  0.31           H  \n"
"ATOM   1165  HB2 GLN A  72       0.102   2.839 -10.221  1.00  0.83           H  \n"
"ATOM   1166  HB3 GLN A  72      -0.089   1.391  -9.253  1.00  0.78           H  \n"
"ATOM   1167  HG2 GLN A  72      -2.354   1.107  -9.953  1.00  1.81           H  \n"
"ATOM   1168  HG3 GLN A  72      -2.419   2.728 -10.645  1.00  1.80           H  \n"
"ATOM   1169 HE21 GLN A  72      -1.334  -0.574 -11.206  1.00  2.20           H  \n"
"ATOM   1170 HE22 GLN A  72      -0.834  -0.334 -12.811  1.00  2.45           H  \n"
"ATOM   1171  N   VAL A  73      -2.487   1.666  -7.230  1.00  0.23           N  \n"
"ATOM   1172  CA  VAL A  73      -3.797   1.162  -6.774  1.00  0.20           C  \n"
"ATOM   1173  C   VAL A  73      -4.352   2.055  -5.661  1.00  0.16           C  \n"
"ATOM   1174  O   VAL A  73      -5.547   2.201  -5.514  1.00  0.16           O  \n"
"ATOM   1175  CB  VAL A  73      -3.590  -0.254  -6.268  1.00  0.21           C  \n"
"ATOM   1176  CG1 VAL A  73      -4.840  -0.752  -5.547  1.00  0.20           C  \n"
"ATOM   1177  CG2 VAL A  73      -3.258  -1.151  -7.468  1.00  0.26           C  \n"
"ATOM   1178  H   VAL A  73      -1.670   1.188  -6.985  1.00  0.24           H  \n"
"ATOM   1179  HA  VAL A  73      -4.479   1.151  -7.604  1.00  0.22           H  \n"
"ATOM   1180  HB  VAL A  73      -2.769  -0.256  -5.582  1.00  0.21           H  \n"
"ATOM   1181 HG11 VAL A  73      -5.470   0.090  -5.302  1.00  1.02           H  \n"
"ATOM   1182 HG12 VAL A  73      -5.383  -1.429  -6.187  1.00  1.04           H  \n"
"ATOM   1183 HG13 VAL A  73      -4.554  -1.261  -4.642  1.00  1.05           H  \n"
"ATOM   1184 HG21 VAL A  73      -3.680  -0.717  -8.366  1.00  1.00           H  \n"
"ATOM   1185 HG22 VAL A  73      -2.183  -1.216  -7.579  1.00  1.08           H  \n"
"ATOM   1186 HG23 VAL A  73      -3.668  -2.140  -7.314  1.00  1.09           H  \n"
"ATOM   1187  N   PHE A  74      -3.501   2.649  -4.873  1.00  0.15           N  \n"
"ATOM   1188  CA  PHE A  74      -4.001   3.529  -3.773  1.00  0.14           C  \n"
"ATOM   1189  C   PHE A  74      -4.501   4.858  -4.358  1.00  0.16           C  \n"
"ATOM   1190  O   PHE A  74      -5.460   5.440  -3.887  1.00  0.18           O  \n"
"ATOM   1191  CB  PHE A  74      -2.868   3.807  -2.778  1.00  0.14           C  \n"
"ATOM   1192  CG  PHE A  74      -2.926   2.806  -1.651  1.00  0.12           C  \n"
"ATOM   1193  CD1 PHE A  74      -3.895   2.932  -0.650  1.00  0.16           C  \n"
"ATOM   1194  CD2 PHE A  74      -2.007   1.751  -1.608  1.00  0.16           C  \n"
"ATOM   1195  CE1 PHE A  74      -3.946   2.003   0.395  1.00  0.18           C  \n"
"ATOM   1196  CE2 PHE A  74      -2.058   0.822  -0.563  1.00  0.19           C  \n"
"ATOM   1197  CZ  PHE A  74      -3.027   0.949   0.439  1.00  0.19           C  \n"
"ATOM   1198  H   PHE A  74      -2.537   2.512  -5.002  1.00  0.16           H  \n"
"ATOM   1199  HA  PHE A  74      -4.814   3.036  -3.262  1.00  0.13           H  \n"
"ATOM   1200  HB2 PHE A  74      -1.915   3.724  -3.278  1.00  0.17           H  \n"
"ATOM   1201  HB3 PHE A  74      -2.979   4.803  -2.377  1.00  0.17           H  \n"
"ATOM   1202  HD1 PHE A  74      -4.602   3.748  -0.683  1.00  0.21           H  \n"
"ATOM   1203  HD2 PHE A  74      -1.260   1.654  -2.381  1.00  0.21           H  \n"
"ATOM   1204  HE1 PHE A  74      -4.694   2.098   1.167  1.00  0.24           H  \n"
"ATOM   1205  HE2 PHE A  74      -1.349   0.008  -0.529  1.00  0.26           H  \n"
"ATOM   1206  HZ  PHE A  74      -3.065   0.235   1.245  1.00  0.23           H  \n"
"ATOM   1207  N   ARG A  75      -3.859   5.334  -5.388  1.00  0.19           N  \n"
"ATOM   1208  CA  ARG A  75      -4.271   6.610  -6.018  1.00  0.23           C  \n"
"ATOM   1209  C   ARG A  75      -5.453   6.341  -6.929  1.00  0.24           C  \n"
"ATOM   1210  O   ARG A  75      -6.368   7.124  -7.030  1.00  0.33           O  \n"
"ATOM   1211  CB  ARG A  75      -3.119   7.150  -6.851  1.00  0.26           C  \n"
"ATOM   1212  CG  ARG A  75      -1.995   7.625  -5.930  1.00  0.54           C  \n"
"ATOM   1213  CD  ARG A  75      -1.790   9.130  -6.107  1.00  1.28           C  \n"
"ATOM   1214  NE  ARG A  75      -1.186   9.394  -7.445  1.00  1.38           N  \n"
"ATOM   1215  CZ  ARG A  75      -1.177  10.604  -7.930  1.00  1.76           C  \n"
"ATOM   1216  NH1 ARG A  75      -1.310  11.627  -7.134  1.00  2.43           N  \n"
"ATOM   1217  NH2 ARG A  75      -1.032  10.790  -9.212  1.00  2.43           N  \n"
"ATOM   1218  H   ARG A  75      -3.112   4.847  -5.752  1.00  0.21           H  \n"
"ATOM   1219  HA  ARG A  75      -4.539   7.316  -5.258  1.00  0.23           H  \n"
"ATOM   1220  HB2 ARG A  75      -2.755   6.364  -7.492  1.00  0.48           H  \n"
"ATOM   1221  HB3 ARG A  75      -3.466   7.973  -7.453  1.00  0.51           H  \n"
"ATOM   1222  HG2 ARG A  75      -2.259   7.415  -4.904  1.00  0.91           H  \n"
"ATOM   1223  HG3 ARG A  75      -1.081   7.107  -6.179  1.00  1.01           H  \n"
"ATOM   1224  HD2 ARG A  75      -2.741   9.634  -6.035  1.00  2.01           H  \n"
"ATOM   1225  HD3 ARG A  75      -1.130   9.496  -5.334  1.00  1.94           H  \n"
"ATOM   1226  HE  ARG A  75      -0.793   8.660  -7.960  1.00  1.94           H  \n"
"ATOM   1227 HH11 ARG A  75      -1.419  11.483  -6.150  1.00  2.67           H  \n"
"ATOM   1228 HH12 ARG A  75      -1.301  12.554  -7.505  1.00  3.11           H  \n"
"ATOM   1229 HH21 ARG A  75      -0.928  10.004  -9.821  1.00  2.68           H  \n"
"ATOM   1230 HH22 ARG A  75      -1.023  11.717  -9.585  1.00  3.12           H  \n"
"ATOM   1231  N   GLU A  76      -5.429   5.219  -7.581  1.00  0.22           N  \n"
"ATOM   1232  CA  GLU A  76      -6.544   4.838  -8.482  1.00  0.23           C  \n"
"ATOM   1233  C   GLU A  76      -7.787   4.692  -7.616  1.00  0.21           C  \n"
"ATOM   1234  O   GLU A  76      -8.839   5.219  -7.917  1.00  0.23           O  \n"
"ATOM   1235  CB  GLU A  76      -6.206   3.501  -9.129  1.00  0.24           C  \n"
"ATOM   1236  CG  GLU A  76      -5.555   3.723 -10.494  1.00  0.30           C  \n"
"ATOM   1237  CD  GLU A  76      -6.631   4.058 -11.527  1.00  0.89           C  \n"
"ATOM   1238  OE1 GLU A  76      -7.781   3.734 -11.282  1.00  1.65           O  \n"
"ATOM   1239  OE2 GLU A  76      -6.286   4.632 -12.547  1.00  1.48           O  \n"
"ATOM   1240  H   GLU A  76      -4.674   4.615  -7.461  1.00  0.25           H  \n"
"ATOM   1241  HA  GLU A  76      -6.696   5.595  -9.236  1.00  0.26           H  \n"
"ATOM   1242  HB2 GLU A  76      -5.521   2.982  -8.487  1.00  0.23           H  \n"
"ATOM   1243  HB3 GLU A  76      -7.101   2.911  -9.243  1.00  0.24           H  \n"
"ATOM   1244  HG2 GLU A  76      -4.850   4.539 -10.427  1.00  0.60           H  \n"
"ATOM   1245  HG3 GLU A  76      -5.037   2.822 -10.793  1.00  0.60           H  \n"
"ATOM   1246  N   ALA A  77      -7.653   4.005  -6.512  1.00  0.18           N  \n"
"ATOM   1247  CA  ALA A  77      -8.796   3.857  -5.591  1.00  0.17           C  \n"
"ATOM   1248  C   ALA A  77      -9.143   5.259  -5.113  1.00  0.19           C  \n"
"ATOM   1249  O   ALA A  77     -10.294   5.632  -5.003  1.00  0.20           O  \n"
"ATOM   1250  CB  ALA A  77      -8.403   2.975  -4.403  1.00  0.17           C  \n"
"ATOM   1251  H   ALA A  77      -6.794   3.616  -6.281  1.00  0.17           H  \n"
"ATOM   1252  HA  ALA A  77      -9.630   3.426  -6.117  1.00  0.18           H  \n"
"ATOM   1253  HB1 ALA A  77      -7.980   2.047  -4.765  1.00  0.99           H  \n"
"ATOM   1254  HB2 ALA A  77      -7.671   3.491  -3.799  1.00  0.97           H  \n"
"ATOM   1255  HB3 ALA A  77      -9.280   2.762  -3.809  1.00  1.00           H  \n"
"ATOM   1256  N   LYS A  78      -8.133   6.059  -4.876  1.00  0.21           N  \n"
"ATOM   1257  CA  LYS A  78      -8.377   7.464  -4.462  1.00  0.24           C  \n"
"ATOM   1258  C   LYS A  78      -9.200   8.121  -5.560  1.00  0.28           C  \n"
"ATOM   1259  O   LYS A  78      -9.990   9.016  -5.336  1.00  0.32           O  \n"
"ATOM   1260  CB  LYS A  78      -7.038   8.187  -4.372  1.00  0.26           C  \n"
"ATOM   1261  CG  LYS A  78      -7.077   9.218  -3.247  1.00  0.32           C  \n"
"ATOM   1262  CD  LYS A  78      -7.173  10.619  -3.855  1.00  0.70           C  \n"
"ATOM   1263  CE  LYS A  78      -7.216  11.663  -2.738  1.00  0.99           C  \n"
"ATOM   1264  NZ  LYS A  78      -6.353  12.821  -3.109  1.00  1.50           N  \n"
"ATOM   1265  H   LYS A  78      -7.205   5.741  -5.008  1.00  0.20           H  \n"
"ATOM   1266  HA  LYS A  78      -8.897   7.503  -3.517  1.00  0.25           H  \n"
"ATOM   1267  HB2 LYS A  78      -6.256   7.469  -4.188  1.00  0.26           H  \n"
"ATOM   1268  HB3 LYS A  78      -6.847   8.688  -5.310  1.00  0.29           H  \n"
"ATOM   1269  HG2 LYS A  78      -7.936   9.035  -2.617  1.00  0.54           H  \n"
"ATOM   1270  HG3 LYS A  78      -6.175   9.145  -2.659  1.00  0.56           H  \n"
"ATOM   1271  HD2 LYS A  78      -6.310  10.797  -4.479  1.00  1.49           H  \n"
"ATOM   1272  HD3 LYS A  78      -8.071  10.693  -4.451  1.00  1.45           H  \n"
"ATOM   1273  HE2 LYS A  78      -8.234  12.000  -2.596  1.00  1.62           H  \n"
"ATOM   1274  HE3 LYS A  78      -6.853  11.223  -1.821  1.00  1.76           H  \n"
"ATOM   1275  HZ1 LYS A  78      -5.937  12.657  -4.047  1.00  1.97           H  \n"
"ATOM   1276  HZ2 LYS A  78      -6.926  13.690  -3.132  1.00  2.06           H  \n"
"ATOM   1277  HZ3 LYS A  78      -5.592  12.925  -2.409  1.00  1.84           H  \n"
"ATOM   1278  N   ALA A  79      -8.984   7.664  -6.756  1.00  0.28           N  \n"
"ATOM   1279  CA  ALA A  79      -9.690   8.204  -7.933  1.00  0.33           C  \n"
"ATOM   1280  C   ALA A  79     -11.110   7.645  -7.972  1.00  0.32           C  \n"
"ATOM   1281  O   ALA A  79     -12.027   8.262  -8.477  1.00  0.38           O  \n"
"ATOM   1282  CB  ALA A  79      -8.920   7.757  -9.173  1.00  0.35           C  \n"
"ATOM   1283  H   ALA A  79      -8.334   6.953  -6.883  1.00  0.26           H  \n"
"ATOM   1284  HA  ALA A  79      -9.710   9.274  -7.882  1.00  0.36           H  \n"
"ATOM   1285  HB1 ALA A  79      -7.858   7.825  -8.973  1.00  1.09           H  \n"
"ATOM   1286  HB2 ALA A  79      -9.174   6.731  -9.402  1.00  1.05           H  \n"
"ATOM   1287  HB3 ALA A  79      -9.174   8.391 -10.008  1.00  1.07           H  \n"
"ATOM   1288  N   GLU A  80     -11.285   6.472  -7.440  1.00  0.28           N  \n"
"ATOM   1289  CA  GLU A  80     -12.620   5.829  -7.425  1.00  0.29           C  \n"
"ATOM   1290  C   GLU A  80     -13.585   6.626  -6.544  1.00  0.37           C  \n"
"ATOM   1291  O   GLU A  80     -14.762   6.332  -6.476  1.00  0.68           O  \n"
"ATOM   1292  CB  GLU A  80     -12.466   4.417  -6.865  1.00  0.32           C  \n"
"ATOM   1293  CG  GLU A  80     -12.076   3.469  -7.995  1.00  0.45           C  \n"
"ATOM   1294  CD  GLU A  80     -13.336   2.876  -8.627  1.00  0.67           C  \n"
"ATOM   1295  OE1 GLU A  80     -13.927   3.543  -9.460  1.00  1.40           O  \n"
"ATOM   1296  OE2 GLU A  80     -13.688   1.764  -8.269  1.00  1.30           O  \n"
"ATOM   1297  H   GLU A  80     -10.526   6.003  -7.052  1.00  0.27           H  \n"
"ATOM   1298  HA  GLU A  80     -13.000   5.776  -8.429  1.00  0.36           H  \n"
"ATOM   1299  HB2 GLU A  80     -11.691   4.415  -6.111  1.00  0.36           H  \n"
"ATOM   1300  HB3 GLU A  80     -13.393   4.092  -6.425  1.00  0.36           H  \n"
"ATOM   1301  HG2 GLU A  80     -11.518   4.013  -8.744  1.00  0.62           H  \n"
"ATOM   1302  HG3 GLU A  80     -11.466   2.678  -7.597  1.00  0.74           H  \n"
"ATOM   1303  N   GLY A  81     -13.098   7.621  -5.858  1.00  0.39           N  \n"
"ATOM   1304  CA  GLY A  81     -13.987   8.421  -4.973  1.00  0.45           C  \n"
"ATOM   1305  C   GLY A  81     -13.572   8.186  -3.522  1.00  0.39           C  \n"
"ATOM   1306  O   GLY A  81     -13.963   8.908  -2.626  1.00  0.45           O  \n"
"ATOM   1307  H   GLY A  81     -12.145   7.837  -5.915  1.00  0.59           H  \n"
"ATOM   1308  HA2 GLY A  81     -13.891   9.470  -5.215  1.00  0.54           H  \n"
"ATOM   1309  HA3 GLY A  81     -15.011   8.108  -5.108  1.00  0.53           H  \n"
"ATOM   1310  N   CYS A  82     -12.776   7.179  -3.288  1.00  0.41           N  \n"
"ATOM   1311  CA  CYS A  82     -12.322   6.888  -1.905  1.00  0.38           C  \n"
"ATOM   1312  C   CYS A  82     -11.476   8.057  -1.395  1.00  0.38           C  \n"
"ATOM   1313  O   CYS A  82     -10.977   8.854  -2.164  1.00  0.49           O  \n"
"ATOM   1314  CB  CYS A  82     -11.480   5.614  -1.920  1.00  0.39           C  \n"
"ATOM   1315  SG  CYS A  82     -12.566   4.168  -1.820  1.00  0.63           S  \n"
"ATOM   1316  H   CYS A  82     -12.471   6.613  -4.028  1.00  0.52           H  \n"
"ATOM   1317  HA  CYS A  82     -13.178   6.749  -1.262  1.00  0.42           H  \n"
"ATOM   1318  HB2 CYS A  82     -10.908   5.571  -2.835  1.00  0.43           H  \n"
"ATOM   1319  HB3 CYS A  82     -10.809   5.621  -1.079  1.00  0.46           H  \n"
"ATOM   1320  HG  CYS A  82     -12.734   3.862  -2.714  1.00  1.11           H  \n"
"ATOM   1321  N   ASP A  83     -11.316   8.173  -0.105  1.00  0.32           N  \n"
"ATOM   1322  CA  ASP A  83     -10.510   9.298   0.444  1.00  0.37           C  \n"
"ATOM   1323  C   ASP A  83      -9.188   8.769   1.009  1.00  0.36           C  \n"
"ATOM   1324  O   ASP A  83      -8.935   8.844   2.195  1.00  0.57           O  \n"
"ATOM   1325  CB  ASP A  83     -11.305   9.984   1.553  1.00  0.42           C  \n"
"ATOM   1326  CG  ASP A  83     -10.709  11.364   1.834  1.00  0.53           C  \n"
"ATOM   1327  OD1 ASP A  83      -9.782  11.437   2.624  1.00  1.11           O  \n"
"ATOM   1328  OD2 ASP A  83     -11.191  12.324   1.255  1.00  1.30           O  \n"
"ATOM   1329  H   ASP A  83     -11.732   7.528   0.503  1.00  0.31           H  \n"
"ATOM   1330  HA  ASP A  83     -10.306  10.009  -0.342  1.00  0.40           H  \n"
"ATOM   1331  HB2 ASP A  83     -12.334  10.089   1.243  1.00  0.43           H  \n"
"ATOM   1332  HB3 ASP A  83     -11.261   9.385   2.448  1.00  0.42           H  \n"
"ATOM   1333  N   ILE A  84      -8.339   8.244   0.168  1.00  0.33           N  \n"
"ATOM   1334  CA  ILE A  84      -7.028   7.720   0.652  1.00  0.31           C  \n"
"ATOM   1335  C   ILE A  84      -5.965   8.818   0.503  1.00  0.34           C  \n"
"ATOM   1336  O   ILE A  84      -5.289   8.905  -0.503  1.00  0.67           O  \n"
"ATOM   1337  CB  ILE A  84      -6.622   6.513  -0.191  1.00  0.30           C  \n"
"ATOM   1338  CG1 ILE A  84      -7.546   5.345   0.117  1.00  0.50           C  \n"
"ATOM   1339  CG2 ILE A  84      -5.182   6.114   0.131  1.00  0.28           C  \n"
"ATOM   1340  CD1 ILE A  84      -8.049   4.762  -1.198  1.00  0.34           C  \n"
"ATOM   1341  H   ILE A  84      -8.560   8.200  -0.786  1.00  0.47           H  \n"
"ATOM   1342  HA  ILE A  84      -7.114   7.418   1.691  1.00  0.30           H  \n"
"ATOM   1343  HB  ILE A  84      -6.703   6.761  -1.238  1.00  0.42           H  \n"
"ATOM   1344 HG12 ILE A  84      -7.004   4.590   0.666  1.00  0.80           H  \n"
"ATOM   1345 HG13 ILE A  84      -8.385   5.689   0.702  1.00  0.80           H  \n"
"ATOM   1346 HG21 ILE A  84      -4.696   6.913   0.673  1.00  1.00           H  \n"
"ATOM   1347 HG22 ILE A  84      -5.185   5.220   0.737  1.00  1.04           H  \n"
"ATOM   1348 HG23 ILE A  84      -4.649   5.924  -0.788  1.00  1.12           H  \n"
"ATOM   1349 HD11 ILE A  84      -7.471   5.165  -2.015  1.00  1.10           H  \n"
"ATOM   1350 HD12 ILE A  84      -7.944   3.689  -1.174  1.00  1.11           H  \n"
"ATOM   1351 HD13 ILE A  84      -9.090   5.023  -1.327  1.00  1.05           H  \n"
"ATOM   1352  N   THR A  85      -5.813   9.657   1.490  1.00  0.49           N  \n"
"ATOM   1353  CA  THR A  85      -4.796  10.748   1.400  1.00  0.50           C  \n"
"ATOM   1354  C   THR A  85      -3.430  10.156   1.047  1.00  0.47           C  \n"
"ATOM   1355  O   THR A  85      -2.721   9.661   1.897  1.00  0.60           O  \n"
"ATOM   1356  CB  THR A  85      -4.702  11.468   2.749  1.00  0.61           C  \n"
"ATOM   1357  OG1 THR A  85      -5.862  12.265   2.940  1.00  0.76           O  \n"
"ATOM   1358  CG2 THR A  85      -3.458  12.361   2.773  1.00  0.55           C  \n"
"ATOM   1359  H   THR A  85      -6.367   9.572   2.289  1.00  0.79           H  \n"
"ATOM   1360  HA  THR A  85      -5.092  11.452   0.637  1.00  0.50           H  \n"
"ATOM   1361  HB  THR A  85      -4.631  10.740   3.542  1.00  0.72           H  \n"
"ATOM   1362  HG1 THR A  85      -6.135  12.177   3.857  1.00  1.32           H  \n"
"ATOM   1363 HG21 THR A  85      -3.146  12.570   1.760  1.00  1.12           H  \n"
"ATOM   1364 HG22 THR A  85      -3.689  13.287   3.277  1.00  1.07           H  \n"
"ATOM   1365 HG23 THR A  85      -2.660  11.854   3.297  1.00  1.26           H  \n"
"ATOM   1366  N   ILE A  86      -3.051  10.211  -0.200  1.00  0.41           N  \n"
"ATOM   1367  CA  ILE A  86      -1.727   9.654  -0.602  1.00  0.40           C  \n"
"ATOM   1368  C   ILE A  86      -0.610  10.583  -0.118  1.00  0.44           C  \n"
"ATOM   1369  O   ILE A  86      -0.489  11.706  -0.564  1.00  0.59           O  \n"
"ATOM   1370  CB  ILE A  86      -1.665   9.540  -2.126  1.00  0.38           C  \n"
"ATOM   1371  CG1 ILE A  86      -2.821   8.668  -2.620  1.00  0.74           C  \n"
"ATOM   1372  CG2 ILE A  86      -0.331   8.915  -2.540  1.00  0.93           C  \n"
"ATOM   1373  CD1 ILE A  86      -2.613   7.223  -2.166  1.00  0.32           C  \n"
"ATOM   1374  H   ILE A  86      -3.635  10.620  -0.872  1.00  0.45           H  \n"
"ATOM   1375  HA  ILE A  86      -1.599   8.676  -0.161  1.00  0.43           H  \n"
"ATOM   1376  HB  ILE A  86      -1.746  10.525  -2.561  1.00  0.74           H  \n"
"ATOM   1377 HG12 ILE A  86      -3.749   9.042  -2.213  1.00  1.39           H  \n"
"ATOM   1378 HG13 ILE A  86      -2.861   8.703  -3.698  1.00  1.38           H  \n"
"ATOM   1379 HG21 ILE A  86       0.449   9.269  -1.883  1.00  1.48           H  \n"
"ATOM   1380 HG22 ILE A  86      -0.397   7.840  -2.474  1.00  1.48           H  \n"
"ATOM   1381 HG23 ILE A  86      -0.102   9.200  -3.556  1.00  1.49           H  \n"
"ATOM   1382 HD11 ILE A  86      -2.100   7.212  -1.216  1.00  1.03           H  \n"
"ATOM   1383 HD12 ILE A  86      -3.573   6.740  -2.063  1.00  1.11           H  \n"
"ATOM   1384 HD13 ILE A  86      -2.023   6.696  -2.901  1.00  1.06           H  \n"
"ATOM   1385  N   ILE A  87       0.212  10.123   0.786  1.00  0.39           N  \n"
"ATOM   1386  CA  ILE A  87       1.322  10.982   1.287  1.00  0.44           C  \n"
"ATOM   1387  C   ILE A  87       2.659  10.368   0.860  1.00  0.44           C  \n"
"ATOM   1388  O   ILE A  87       3.132   9.413   1.442  1.00  0.55           O  \n"
"ATOM   1389  CB  ILE A  87       1.247  11.073   2.813  1.00  0.46           C  \n"
"ATOM   1390  CG1 ILE A  87       0.091  11.995   3.208  1.00  0.57           C  \n"
"ATOM   1391  CG2 ILE A  87       2.556  11.640   3.362  1.00  0.55           C  \n"
"ATOM   1392  CD1 ILE A  87      -0.237  11.800   4.689  1.00  0.61           C  \n"
"ATOM   1393  H   ILE A  87       0.104   9.210   1.132  1.00  0.41           H  \n"
"ATOM   1394  HA  ILE A  87       1.230  11.971   0.862  1.00  0.49           H  \n"
"ATOM   1395  HB  ILE A  87       1.080  10.089   3.224  1.00  0.37           H  \n"
"ATOM   1396 HG12 ILE A  87       0.376  13.023   3.034  1.00  0.71           H  \n"
"ATOM   1397 HG13 ILE A  87      -0.779  11.757   2.614  1.00  0.68           H  \n"
"ATOM   1398 HG21 ILE A  87       3.038  12.233   2.599  1.00  1.17           H  \n"
"ATOM   1399 HG22 ILE A  87       2.346  12.260   4.221  1.00  1.25           H  \n"
"ATOM   1400 HG23 ILE A  87       3.206  10.829   3.653  1.00  1.03           H  \n"
"ATOM   1401 HD11 ILE A  87       0.679  11.687   5.249  1.00  1.21           H  \n"
"ATOM   1402 HD12 ILE A  87      -0.779  12.660   5.054  1.00  1.12           H  \n"
"ATOM   1403 HD13 ILE A  87      -0.845  10.915   4.809  1.00  1.29           H  \n"
"ATOM   1404  N   LEU A  88       3.259  10.902  -0.170  1.00  0.50           N  \n"
"ATOM   1405  CA  LEU A  88       4.552  10.348  -0.662  1.00  0.52           C  \n"
"ATOM   1406  C   LEU A  88       5.728  11.146  -0.093  1.00  0.56           C  \n"
"ATOM   1407  O   LEU A  88       5.984  12.263  -0.495  1.00  0.80           O  \n"
"ATOM   1408  CB  LEU A  88       4.558  10.413  -2.173  1.00  0.59           C  \n"
"ATOM   1409  CG  LEU A  88       3.653   9.297  -2.669  1.00  0.82           C  \n"
"ATOM   1410  CD1 LEU A  88       2.691   9.851  -3.697  1.00  0.94           C  \n"
"ATOM   1411  CD2 LEU A  88       4.496   8.193  -3.286  1.00  1.57           C  \n"
"ATOM   1412  H   LEU A  88       2.850  11.663  -0.631  1.00  0.63           H  \n"
"ATOM   1413  HA  LEU A  88       4.634   9.313  -0.376  1.00  0.49           H  \n"
"ATOM   1414  HB2 LEU A  88       4.181  11.371  -2.501  1.00  0.76           H  \n"
"ATOM   1415  HB3 LEU A  88       5.559  10.262  -2.546  1.00  0.68           H  \n"
"ATOM   1416  HG  LEU A  88       3.092   8.898  -1.837  1.00  1.63           H  \n"
"ATOM   1417 HD11 LEU A  88       3.141  10.700  -4.183  1.00  1.44           H  \n"
"ATOM   1418 HD12 LEU A  88       2.466   9.089  -4.426  1.00  1.46           H  \n"
"ATOM   1419 HD13 LEU A  88       1.788  10.157  -3.198  1.00  1.55           H  \n"
"ATOM   1420 HD21 LEU A  88       5.534   8.356  -3.037  1.00  1.91           H  \n"
"ATOM   1421 HD22 LEU A  88       4.179   7.238  -2.894  1.00  2.31           H  \n"
"ATOM   1422 HD23 LEU A  88       4.375   8.200  -4.359  1.00  2.02           H  \n"
"ATOM   1423  N   SER A  89       6.445  10.581   0.841  1.00  0.55           N  \n"
"ATOM   1424  CA  SER A  89       7.604  11.308   1.435  1.00  0.62           C  \n"
"ATOM   1425  C   SER A  89       8.908  10.659   0.968  1.00  0.85           C  \n"
"ATOM   1426  O   SER A  89       8.935   9.445   0.852  1.00  1.41           O  \n"
"ATOM   1427  CB  SER A  89       7.520  11.241   2.961  1.00  0.87           C  \n"
"ATOM   1428  OG  SER A  89       7.246  12.538   3.473  1.00  1.64           O  \n"
"ATOM   1429  OXT SER A  89       9.859  11.388   0.735  1.00  1.52           O  \n"
"ATOM   1430  H   SER A  89       6.222   9.680   1.152  1.00  0.66           H  \n"
"ATOM   1431  HA  SER A  89       7.582  12.340   1.118  1.00  0.74           H  \n"
"ATOM   1432  HB2 SER A  89       6.729  10.570   3.251  1.00  1.30           H  \n"
"ATOM   1433  HB3 SER A  89       8.461  10.879   3.356  1.00  1.41           H  \n"
"ATOM   1434  HG  SER A  89       6.663  12.440   4.229  1.00  2.01           H  \n"
"TER    1435      SER A  89                                                      \n"
"MASTER       97    1    0    4    3    0    0    6 1434    1    0    7          \n"
"END                                                                             \n";


static const std::string GROSTRING = "BARSTAR\n"
" 1434\n"
"    1LYS      N    1  -0.865   0.577   0.837\n"
"    1LYS     CA    2  -0.754   0.519   0.916\n"
"    1LYS      C    3  -0.621   0.562   0.856\n"
"    1LYS      O    4  -0.616   0.647   0.769\n"
"    1LYS     CB    5  -0.764   0.367   0.916\n"
"    1LYS     CG    6  -0.775   0.318   1.060\n"
"    1LYS     CD    7  -0.916   0.347   1.113\n"
"    1LYS     CE    8  -0.914   0.474   1.196\n"
"    1LYS     NZ    9  -0.950   0.442   1.337\n"
"    1LYS     H1   10  -0.841   0.674   0.811\n"
"    1LYS     H2   11  -0.881   0.520   0.751\n"
"    1LYS     H3   12  -0.952   0.577   0.894\n"
"    1LYS     HA   13  -0.760   0.554   1.018\n"
"    1LYS    HB2   14  -0.852   0.336   0.860\n"
"    1LYS    HB3   15  -0.676   0.325   0.871\n"
"    1LYS    HG2   16  -0.756   0.212   1.064\n"
"    1LYS    HG3   17  -0.702   0.370   1.121\n"
"    1LYS    HD2   18  -0.983   0.359   1.029\n"
"    1LYS    HD3   19  -0.949   0.264   1.173\n"
"    1LYS    HE2   20  -0.816   0.519   1.193\n"
"    1LYS    HE3   21  -0.987   0.544   1.157\n"
"    1LYS    HZ1   22  -0.939   0.339   1.353\n"
"    1LYS    HZ2   23  -0.886   0.493   1.402\n"
"    1LYS    HZ3   24  -1.048   0.469   1.356\n"
"    2LYS      N   25  -0.513   0.507   0.903\n"
"    2LYS     CA   26  -0.381   0.549   0.849\n"
"    2LYS      C   27  -0.293   0.428   0.817\n"
"    2LYS      O   28  -0.304   0.322   0.876\n"
"    2LYS     CB   29  -0.314   0.638   0.953\n"
"    2LYS     CG   30  -0.162   0.613   0.960\n"
"    2LYS     CD   31  -0.097   0.722   1.045\n"
"    2LYS     CE   32   0.012   0.793   0.963\n"
"    2LYS     NZ   33   0.106   0.863   1.055\n"
"    2LYS      H   34  -0.518   0.440   0.974\n"
"    2LYS     HA   35  -0.397   0.605   0.759\n"
"    2LYS    HB2   36  -0.331   0.741   0.927\n"
"    2LYS    HB3   37  -0.358   0.618   1.050\n"
"    2LYS    HG2   38  -0.144   0.517   1.005\n"
"    2LYS    HG3   39  -0.121   0.616   0.861\n"
"    2LYS    HD2   40  -0.172   0.794   1.076\n"
"    2LYS    HD3   41  -0.052   0.678   1.133\n"
"    2LYS    HE2   42   0.066   0.720   0.905\n"
"    2LYS    HE3   43  -0.034   0.865   0.897\n"
"    2LYS    HZ1   44   0.054   0.896   1.139\n"
"    2LYS    HZ2   45   0.181   0.797   1.084\n"
"    2LYS    HZ3   46   0.148   0.944   1.006\n"
"    3ALA      N   47  -0.204   0.447   0.725\n"
"    3ALA     CA   48  -0.109   0.340   0.685\n"
"    3ALA      C   49   0.032   0.401   0.675\n"
"    3ALA      O   50   0.047   0.521   0.659\n"
"    3ALA     CB   51  -0.149   0.283   0.549\n"
"    3ALA      H   52  -0.199   0.535   0.683\n"
"    3ALA     HA   53  -0.109   0.262   0.759\n"
"    3ALA    HB1   54  -0.226   0.346   0.505\n"
"    3ALA    HB2   55  -0.063   0.281   0.483\n"
"    3ALA    HB3   56  -0.187   0.183   0.561\n"
"    4VAL      N   57   0.134   0.321   0.686\n"
"    4VAL     CA   58   0.273   0.377   0.678\n"
"    4VAL      C   59   0.364   0.277   0.607\n"
"    4VAL      O   60   0.384   0.167   0.654\n"
"    4VAL     CB   61   0.325   0.402   0.819\n"
"    4VAL    CG1   62   0.462   0.471   0.812\n"
"    4VAL    CG2   63   0.226   0.491   0.895\n"
"    4VAL      H   64   0.121   0.226   0.700\n"
"    4VAL     HA   65   0.271   0.470   0.623\n"
"    4VAL     HB   66   0.335   0.308   0.871\n"
"    4VAL   HG11   67   0.455   0.557   0.747\n"
"    4VAL   HG12   68   0.491   0.503   0.911\n"
"    4VAL   HG13   69   0.535   0.401   0.773\n"
"    4VAL   HG21   70   0.178   0.559   0.825\n"
"    4VAL   HG22   71   0.151   0.430   0.942\n"
"    4VAL   HG23   72   0.279   0.549   0.969\n"
"    5ILE      N   73   0.421   0.315   0.496\n"
"    5ILE     CA   74   0.512   0.221   0.424\n"
"    5ILE      C   75   0.657   0.257   0.455\n"
"    5ILE      O   76   0.718   0.339   0.389\n"
"    5ILE     CB   77   0.488   0.230   0.274\n"
"    5ILE    CG1   78   0.336   0.223   0.248\n"
"    5ILE    CG2   79   0.562   0.114   0.206\n"
"    5ILE    CD1   80   0.303   0.125   0.135\n"
"    5ILE      H   81   0.404   0.405   0.460\n"
"    5ILE     HA   82   0.492   0.120   0.458\n"
"    5ILE     HB   83   0.527   0.324   0.237\n"
"    5ILE   HG12   84   0.286   0.191   0.338\n"
"    5ILE   HG13   85   0.301   0.321   0.221\n"
"    5ILE   HG21   86   0.658   0.101   0.253\n"
"    5ILE   HG22   87   0.504   0.024   0.216\n"
"    5ILE   HG23   88   0.576   0.137   0.101\n"
"    5ILE   HD11   89   0.378   0.133   0.057\n"
"    5ILE   HD12   90   0.304   0.024   0.174\n"
"    5ILE   HD13   91   0.206   0.147   0.094\n"
"    6ASN      N   92   0.713   0.195   0.555\n"
"    6ASN     CA   93   0.854   0.223   0.590\n"
"    6ASN      C   94   0.947   0.140   0.501\n"
"    6ASN      O   95   0.961   0.021   0.519\n"
"    6ASN     CB   96   0.876   0.186   0.737\n"
"    6ASN     CG   97   0.807   0.289   0.826\n"
"    6ASN    OD1   98   0.753   0.387   0.778\n"
"    6ASN    ND2   99   0.805   0.271   0.956\n"
"    6ASN      H  100   0.663   0.129   0.606\n"
"    6ASN     HA  101   0.875   0.328   0.576\n"
"    6ASN    HB2  102   0.834   0.088   0.756\n"
"    6ASN    HB3  103   0.981   0.185   0.759\n"
"    6ASN   HD21  104   0.848   0.192   0.995\n"
"    6ASN   HD22  105   0.761   0.337   1.014\n"
"    7GLY      N  106   1.008   0.202   0.403\n"
"    7GLY     CA  107   1.098   0.126   0.311\n"
"    7GLY      C  108   1.218   0.072   0.388\n"
"    7GLY      O  109   1.258  -0.041   0.369\n"
"    7GLY      H  110   0.994   0.298   0.390\n"
"    7GLY    HA2  111   1.043   0.044   0.269\n"
"    7GLY    HA3  112   1.132   0.191   0.233\n"
"    8GLU      N  113   1.277   0.151   0.474\n"
"    8GLU     CA  114   1.395   0.102   0.550\n"
"    8GLU      C  115   1.366  -0.039   0.602\n"
"    8GLU      O  116   1.456  -0.117   0.626\n"
"    8GLU     CB  117   1.421   0.195   0.670\n"
"    8GLU     CG  118   1.406   0.341   0.626\n"
"    8GLU     CD  119   1.466   0.432   0.733\n"
"    8GLU    OE1  120   1.423   0.423   0.846\n"
"    8GLU    OE2  121   1.554   0.510   0.699\n"
"    8GLU      H  122   1.243   0.242   0.487\n"
"    8GLU     HA  123   1.481   0.100   0.486\n"
"    8GLU    HB2  124   1.349   0.174   0.748\n"
"    8GLU    HB3  125   1.521   0.178   0.707\n"
"    8GLU    HG2  126   1.459   0.356   0.532\n"
"    8GLU    HG3  127   1.302   0.364   0.613\n"
"    9GLN      N  128   1.241  -0.072   0.619\n"
"    9GLN     CA  129   1.205  -0.207   0.670\n"
"    9GLN      C  130   1.174  -0.300   0.552\n"
"    9GLN      O  131   1.221  -0.412   0.547\n"
"    9GLN     CB  132   1.081  -0.194   0.758\n"
"    9GLN     CG  133   1.103  -0.082   0.860\n"
"    9GLN     CD  134   1.179  -0.137   0.980\n"
"    9GLN    OE1  135   1.298  -0.116   0.993\n"
"    9GLN    NE2  136   1.115  -0.206   1.071\n"
"    9GLN      H  137   1.170  -0.007   0.600\n"
"    9GLN     HA  138   1.286  -0.247   0.728\n"
"    9GLN    HB2  139   0.996  -0.169   0.696\n"
"    9GLN    HB3  140   1.063  -0.287   0.809\n"
"    9GLN    HG2  141   1.160  -0.002   0.814\n"
"    9GLN    HG3  142   1.007  -0.044   0.892\n"
"    9GLN   HE21  143   1.019  -0.223   1.061\n"
"    9GLN   HE22  144   1.163  -0.241   1.148\n"
"   10ILE      N  145   1.095  -0.255   0.459\n"
"   10ILE     CA  146   1.060  -0.341   0.342\n"
"   10ILE      C  147   1.183  -0.417   0.293\n"
"   10ILE      O  148   1.289  -0.362   0.276\n"
"   10ILE     CB  149   1.006  -0.255   0.228\n"
"   10ILE    CG1  150   0.868  -0.200   0.266\n"
"   10ILE    CG2  151   0.993  -0.340   0.102\n"
"   10ILE    CD1  152   0.769  -0.316   0.271\n"
"   10ILE      H  153   1.058  -0.165   0.466\n"
"   10ILE     HA  154   0.984  -0.411   0.372\n"
"   10ILE     HB  155   1.074  -0.172   0.209\n"
"   10ILE   HG12  156   0.873  -0.152   0.362\n"
"   10ILE   HG13  157   0.836  -0.130   0.191\n"
"   10ILE   HG21  158   0.979  -0.444   0.130\n"
"   10ILE   HG22  159   0.908  -0.307   0.044\n"
"   10ILE   HG23  160   1.083  -0.331   0.043\n"
"   10ILE   HD11  161   0.765  -0.365   0.175\n"
"   10ILE   HD12  162   0.800  -0.386   0.347\n"
"   10ILE   HD13  163   0.671  -0.277   0.297\n"
"   11ARG      N  164   1.167  -0.544   0.269\n"
"   11ARG     CA  165   1.279  -0.626   0.220\n"
"   11ARG      C  166   1.242  -0.683   0.083\n"
"   11ARG      O  167   1.325  -0.737   0.012\n"
"   11ARG     CB  168   1.304  -0.740   0.318\n"
"   11ARG     CG  169   1.368  -0.684   0.446\n"
"   11ARG     CD  170   1.510  -0.738   0.459\n"
"   11ARG     NE  171   1.549  -0.740   0.603\n"
"   11ARG     CZ  172   1.654  -0.807   0.642\n"
"   11ARG    NH1  173   1.688  -0.917   0.581\n"
"   11ARG    NH2  174   1.726  -0.762   0.741\n"
"   11ARG      H  175   1.080  -0.586   0.283\n"
"   11ARG     HA  176   1.368  -0.565   0.212\n"
"   11ARG    HB2  177   1.209  -0.787   0.343\n"
"   11ARG    HB3  178   1.369  -0.812   0.274\n"
"   11ARG    HG2  179   1.370  -0.576   0.441\n"
"   11ARG    HG3  180   1.310  -0.715   0.532\n"
"   11ARG    HD2  181   1.516  -0.837   0.418\n"
"   11ARG    HD3  182   1.578  -0.673   0.405\n"
"   11ARG     HE  183   1.495  -0.692   0.669\n"
"   11ARG   HH11  184   1.633  -0.951   0.506\n"
"   11ARG   HH12  185   1.769  -0.968   0.612\n"
"   11ARG   HH21  186   1.700  -0.677   0.787\n"
"   11ARG   HH22  187   1.807  -0.813   0.771\n"
"   12SER      N  188   1.117  -0.673   0.046\n"
"   12SER     CA  189   1.073  -0.726  -0.086\n"
"   12SER      C  190   0.927  -0.687  -0.110\n"
"   12SER      O  191   0.862  -0.629  -0.024\n"
"   12SER     CB  192   1.086  -0.878  -0.086\n"
"   12SER     OG  193   1.128  -0.922   0.042\n"
"   12SER      H  194   1.052  -0.629   0.105\n"
"   12SER     HA  195   1.135  -0.684  -0.164\n"
"   12SER    HB2  196   0.991  -0.923  -0.110\n"
"   12SER    HB3  197   1.158  -0.908  -0.161\n"
"   12SER     HG  198   1.128  -1.018   0.042\n"
"   13ILE      N  199   0.874  -0.719  -0.225\n"
"   13ILE     CA  200   0.732  -0.683  -0.252\n"
"   13ILE      C  201   0.645  -0.745  -0.144\n"
"   13ILE      O  202   0.558  -0.680  -0.089\n"
"   13ILE     CB  203   0.691  -0.737  -0.389\n"
"   13ILE    CG1  204   0.557  -0.675  -0.431\n"
"   13ILE    CG2  205   0.675  -0.889  -0.381\n"
"   13ILE    CD1  206   0.556  -0.525  -0.401\n"
"   13ILE      H  207   0.927  -0.766  -0.292\n"
"   13ILE     HA  208   0.722  -0.576  -0.250\n"
"   13ILE     HB  209   0.767  -0.713  -0.462\n"
"   13ILE   HG12  210   0.542  -0.690  -0.537\n"
"   13ILE   HG13  211   0.477  -0.723  -0.377\n"
"   13ILE   HG21  212   0.767  -0.933  -0.346\n"
"   13ILE   HG22  213   0.595  -0.913  -0.313\n"
"   13ILE   HG23  214   0.652  -0.928  -0.479\n"
"   13ILE   HD11  215   0.658  -0.487  -0.403\n"
"   13ILE   HD12  216   0.498  -0.473  -0.475\n"
"   13ILE   HD13  217   0.513  -0.508  -0.303\n"
"   14SER      N  218   0.667  -0.869  -0.111\n"
"   14SER     CA  219   0.585  -0.933  -0.005\n"
"   14SER      C  220   0.586  -0.842   0.118\n"
"   14SER      O  221   0.484  -0.816   0.178\n"
"   14SER     CB  222   0.645  -1.069   0.031\n"
"   14SER     OG  223   0.548  -1.147   0.100\n"
"   14SER      H  224   0.738  -0.919  -0.156\n"
"   14SER     HA  225   0.484  -0.946  -0.040\n"
"   14SER    HB2  226   0.675  -1.120  -0.059\n"
"   14SER    HB3  227   0.732  -1.054   0.094\n"
"   14SER     HG  228   0.531  -1.226   0.047\n"
"   15ASP      N  229   0.701  -0.793   0.154\n"
"   15ASP     CA  230   0.710  -0.702   0.271\n"
"   15ASP      C  231   0.619  -0.582   0.248\n"
"   15ASP      O  232   0.547  -0.539   0.335\n"
"   15ASP     CB  233   0.854  -0.654   0.287\n"
"   15ASP     CG  234   0.906  -0.694   0.425\n"
"   15ASP    OD1  235   0.848  -0.784   0.484\n"
"   15ASP    OD2  236   1.002  -0.633   0.470\n"
"   15ASP      H  237   0.781  -0.814   0.104\n"
"   15ASP     HA  238   0.679  -0.755   0.359\n"
"   15ASP    HB2  239   0.915  -0.699   0.211\n"
"   15ASP    HB3  240   0.856  -0.547   0.277\n"
"   16LEU      N  241   0.621  -0.528   0.129\n"
"   16LEU     CA  242   0.535  -0.411   0.098\n"
"   16LEU      C  243   0.390  -0.446   0.130\n"
"   16LEU      O  244   0.323  -0.380   0.207\n"
"   16LEU     CB  245   0.547  -0.378  -0.051\n"
"   16LEU     CG  246   0.480  -0.244  -0.078\n"
"   16LEU    CD1  247   0.534  -0.139   0.019\n"
"   16LEU    CD2  248   0.511  -0.201  -0.222\n"
"   16LEU      H  249   0.679  -0.566   0.059\n"
"   16LEU     HA  250   0.565  -0.326   0.157\n"
"   16LEU    HB2  251   0.651  -0.373  -0.078\n"
"   16LEU    HB3  252   0.498  -0.455  -0.109\n"
"   16LEU     HG  253   0.373  -0.253  -0.066\n"
"   16LEU   HD11  254   0.633  -0.167   0.051\n"
"   16LEU   HD12  255   0.538  -0.043  -0.031\n"
"   16LEU   HD13  256   0.469  -0.132   0.105\n"
"   16LEU   HD21  257   0.574  -0.275  -0.268\n"
"   16LEU   HD22  258   0.419  -0.193  -0.278\n"
"   16LEU   HD23  259   0.562  -0.106  -0.221\n"
"   17HIS      N  260   0.341  -0.551   0.070\n"
"   17HIS     CA  261   0.202  -0.594   0.094\n"
"   17HIS      C  262   0.187  -0.636   0.241\n"
"   17HIS      O  263   0.079  -0.643   0.294\n"
"   17HIS     CB  264   0.171  -0.712   0.002\n"
"   17HIS     CG  265   0.199  -0.672  -0.140\n"
"   17HIS    ND1  266   0.129  -0.570  -0.203\n"
"   17HIS    CD2  267   0.289  -0.718  -0.232\n"
"   17HIS    CE1  268   0.178  -0.559  -0.328\n"
"   17HIS    NE2  269   0.276  -0.646  -0.351\n"
"   17HIS      H  270   0.397  -0.602   0.009\n"
"   17HIS     HA  271   0.134  -0.513   0.073\n"
"   17HIS    HB2  272   0.234  -0.796   0.029\n"
"   17HIS    HB3  273   0.068  -0.740   0.012\n"
"   17HIS    HD1  274   0.058  -0.516  -0.163\n"
"   17HIS    HD2  275   0.361  -0.798  -0.216\n"
"   17HIS    HE1  276   0.142  -0.487  -0.400\n"
"   18GLN      N  277   0.297  -0.664   0.306\n"
"   18GLN     CA  278   0.290  -0.705   0.447\n"
"   18GLN      C  279   0.250  -0.584   0.532\n"
"   18GLN      O  280   0.154  -0.589   0.607\n"
"   18GLN     CB  281   0.428  -0.755   0.493\n"
"   18GLN     CG  282   0.409  -0.865   0.598\n"
"   18GLN     CD  283   0.546  -0.914   0.645\n"
"   18GLN    OE1  284   0.639  -0.836   0.656\n"
"   18GLN    NE2  285   0.563  -1.040   0.675\n"
"   18GLN      H  286   0.383  -0.657   0.261\n"
"   18GLN     HA  287   0.218  -0.783   0.458\n"
"   18GLN    HB2  288   0.481  -0.795   0.408\n"
"   18GLN    HB3  289   0.484  -0.674   0.536\n"
"   18GLN    HG2  290   0.354  -0.826   0.681\n"
"   18GLN    HG3  291   0.355  -0.948   0.554\n"
"   18GLN   HE21  292   0.488  -1.102   0.666\n"
"   18GLN   HE22  293   0.650  -1.072   0.706\n"
"   19THR      N  294   0.323  -0.476   0.522\n"
"   19THR     CA  295   0.288  -0.357   0.602\n"
"   19THR      C  296   0.152  -0.306   0.554\n"
"   19THR      O  297   0.068  -0.269   0.633\n"
"   19THR     CB  298   0.398  -0.249   0.586\n"
"   19THR    OG1  299   0.459  -0.228   0.712\n"
"   19THR    CG2  300   0.337  -0.116   0.540\n"
"   19THR      H  301   0.400  -0.474   0.462\n"
"   19THR     HA  302   0.281  -0.386   0.705\n"
"   19THR     HB  303   0.471  -0.282   0.514\n"
"   19THR    HG1  304   0.501  -0.141   0.710\n"
"   19THR   HG21  305   0.247  -0.097   0.597\n"
"   19THR   HG22  306   0.408  -0.037   0.556\n"
"   19THR   HG23  307   0.312  -0.123   0.435\n"
"   20LEU      N  308   0.129  -0.306   0.426\n"
"   20LEU     CA  309  -0.002  -0.259   0.375\n"
"   20LEU      C  310  -0.110  -0.347   0.437\n"
"   20LEU      O  311  -0.218  -0.304   0.468\n"
"   20LEU     CB  312  -0.005  -0.274   0.223\n"
"   20LEU     CG  313   0.088  -0.170   0.159\n"
"   20LEU    CD1  314   0.082  -0.185   0.007\n"
"   20LEU    CD2  315   0.043  -0.029   0.198\n"
"   20LEU      H  316   0.196  -0.337   0.363\n"
"   20LEU     HA  317  -0.018  -0.156   0.403\n"
"   20LEU    HB2  318   0.028  -0.373   0.196\n"
"   20LEU    HB3  319  -0.105  -0.259   0.188\n"
"   20LEU     HG  320   0.189  -0.187   0.193\n"
"   20LEU   HD11  321   0.085  -0.290  -0.019\n"
"   20LEU   HD12  322  -0.009  -0.141  -0.030\n"
"   20LEU   HD13  323   0.167  -0.135  -0.037\n"
"   20LEU   HD21  324  -0.044  -0.035   0.261\n"
"   20LEU   HD22  325   0.123   0.020   0.252\n"
"   20LEU   HD23  326   0.020   0.028   0.109\n"
"   21LYS      N  327  -0.079  -0.472   0.453\n"
"   21LYS     CA  328  -0.176  -0.568   0.512\n"
"   21LYS      C  329  -0.201  -0.532   0.659\n"
"   21LYS      O  330  -0.312  -0.536   0.706\n"
"   21LYS     CB  331  -0.117  -0.709   0.503\n"
"   21LYS     CG  332  -0.217  -0.810   0.559\n"
"   21LYS     CD  333  -0.141  -0.923   0.629\n"
"   21LYS     CE  334  -0.241  -1.026   0.684\n"
"   21LYS     NZ  335  -0.173  -1.110   0.786\n"
"   21LYS      H  336   0.008  -0.502   0.426\n"
"   21LYS     HA  337  -0.269  -0.564   0.458\n"
"   21LYS    HB2  338  -0.096  -0.732   0.400\n"
"   21LYS    HB3  339  -0.026  -0.713   0.561\n"
"   21LYS    HG2  340  -0.283  -0.761   0.630\n"
"   21LYS    HG3  341  -0.276  -0.851   0.478\n"
"   21LYS    HD2  342  -0.075  -0.971   0.558\n"
"   21LYS    HD3  343  -0.083  -0.882   0.711\n"
"   21LYS    HE2  344  -0.324  -0.974   0.729\n"
"   21LYS    HE3  345  -0.276  -1.088   0.603\n"
"   21LYS    HZ1  346  -0.110  -1.051   0.843\n"
"   21LYS    HZ2  347  -0.245  -1.154   0.847\n"
"   21LYS    HZ3  348  -0.118  -1.184   0.739\n"
"   22LYS      N  349  -0.099  -0.498   0.732\n"
"   22LYS     CA  350  -0.120  -0.463   0.874\n"
"   22LYS      C  351  -0.201  -0.333   0.882\n"
"   22LYS      O  352  -0.307  -0.328   0.939\n"
"   22LYS     CB  353   0.014  -0.444   0.943\n"
"   22LYS     CG  354   0.015  -0.528   1.072\n"
"   22LYS     CD  355   0.155  -0.534   1.130\n"
"   22LYS     CE  356   0.149  -0.603   1.267\n"
"   22LYS     NZ  357   0.283  -0.660   1.300\n"
"   22LYS      H  358  -0.009  -0.495   0.694\n"
"   22LYS     HA  359  -0.175  -0.542   0.922\n"
"   22LYS    HB2  360   0.093  -0.477   0.877\n"
"   22LYS    HB3  361   0.028  -0.340   0.967\n"
"   22LYS    HG2  362  -0.052  -0.483   1.144\n"
"   22LYS    HG3  363  -0.018  -0.628   1.049\n"
"   22LYS    HD2  364   0.219  -0.590   1.064\n"
"   22LYS    HD3  365   0.194  -0.434   1.142\n"
"   22LYS    HE2  366   0.121  -0.532   1.343\n"
"   22LYS    HE3  367   0.076  -0.683   1.264\n"
"   22LYS    HZ1  368   0.356  -0.589   1.283\n"
"   22LYS    HZ2  369   0.284  -0.689   1.400\n"
"   22LYS    HZ3  370   0.301  -0.743   1.240\n"
"   23GLU      N  371  -0.149  -0.230   0.822\n"
"   23GLU     CA  372  -0.220  -0.100   0.821\n"
"   23GLU      C  373  -0.362  -0.122   0.772\n"
"   23GLU      O  374  -0.459  -0.107   0.844\n"
"   23GLU     CB  375  -0.145  -0.008   0.725\n"
"   23GLU     CG  376  -0.001   0.010   0.772\n"
"   23GLU     CD  377   0.003   0.106   0.891\n"
"   23GLU    OE1  378  -0.103   0.136   0.944\n"
"   23GLU    OE2  379   0.112   0.147   0.928\n"
"   23GLU      H  380  -0.065  -0.239   0.776\n"
"   23GLU     HA  381  -0.220  -0.058   0.920\n"
"   23GLU    HB2  382  -0.145  -0.053   0.626\n"
"   23GLU    HB3  383  -0.194   0.088   0.722\n"
"   23GLU    HG2  384   0.039  -0.086   0.802\n"
"   23GLU    HG3  385   0.059   0.050   0.692\n"
"   24LEU      N  386  -0.374  -0.160   0.648\n"
"   24LEU     CA  387  -0.507  -0.186   0.587\n"
"   24LEU      C  388  -0.577  -0.300   0.662\n"
"   24LEU      O  389  -0.695  -0.321   0.647\n"
"   24LEU     CB  390  -0.485  -0.228   0.442\n"
"   24LEU     CG  391  -0.415  -0.115   0.366\n"
"   24LEU    CD1  392  -0.312  -0.175   0.270\n"
"   24LEU    CD2  393  -0.518  -0.035   0.286\n"
"   24LEU      H  394  -0.294  -0.172   0.594\n"
"   24LEU     HA  395  -0.567  -0.097   0.591\n"
"   24LEU    HB2  396  -0.422  -0.316   0.439\n"
"   24LEU    HB3  397  -0.580  -0.249   0.396\n"
"   24LEU     HG  398  -0.365  -0.050   0.436\n"
"   24LEU   HD11  399  -0.310  -0.282   0.283\n"
"   24LEU   HD12  400  -0.339  -0.151   0.168\n"
"   24LEU   HD13  401  -0.214  -0.134   0.292\n"
"   24LEU   HD21  402  -0.592   0.005   0.354\n"
"   24LEU   HD22  403  -0.469   0.046   0.234\n"
"   24LEU   HD23  404  -0.567  -0.100   0.215\n"
"   25ALA      N  405  -0.504  -0.374   0.742\n"
"   25ALA     CA  406  -0.567  -0.486   0.816\n"
"   25ALA      C  407  -0.637  -0.580   0.717\n"
"   25ALA      O  408  -0.750  -0.619   0.737\n"
"   25ALA     CB  409  -0.667  -0.429   0.915\n"
"   25ALA      H  410  -0.409  -0.356   0.752\n"
"   25ALA     HA  411  -0.490  -0.541   0.869\n"
"   25ALA    HB1  412  -0.627  -0.337   0.956\n"
"   25ALA    HB2  413  -0.760  -0.409   0.865\n"
"   25ALA    HB3  414  -0.683  -0.500   0.995\n"
"   26LEU      N  415  -0.569  -0.615   0.611\n"
"   26LEU     CA  416  -0.629  -0.706   0.510\n"
"   26LEU      C  417  -0.644  -0.847   0.569\n"
"   26LEU      O  418  -0.580  -0.879   0.667\n"
"   26LEU     CB  419  -0.537  -0.712   0.387\n"
"   26LEU     CG  420  -0.495  -0.570   0.348\n"
"   26LEU    CD1  421  -0.395  -0.575   0.234\n"
"   26LEU    CD2  422  -0.619  -0.491   0.304\n"
"   26LEU      H  423  -0.478  -0.582   0.599\n"
"   26LEU     HA  424  -0.726  -0.669   0.480\n"
"   26LEU    HB2  425  -0.449  -0.770   0.411\n"
"   26LEU    HB3  426  -0.589  -0.757   0.305\n"
"   26LEU     HG  427  -0.449  -0.521   0.432\n"
"   26LEU   HD11  428  -0.401  -0.671   0.186\n"
"   26LEU   HD12  429  -0.418  -0.498   0.162\n"
"   26LEU   HD13  430  -0.296  -0.560   0.273\n"
"   26LEU   HD21  431  -0.666  -0.541   0.221\n"
"   26LEU   HD22  432  -0.688  -0.484   0.387\n"
"   26LEU   HD23  433  -0.589  -0.391   0.274\n"
"   27PRO      N  434  -0.728  -0.926   0.508\n"
"   27PRO     CA  435  -0.753  -1.064   0.553\n"
"   27PRO      C  436  -0.622  -1.144   0.555\n"
"   27PRO      O  437  -0.516  -1.093   0.523\n"
"   27PRO     CB  438  -0.849  -1.123   0.449\n"
"   27PRO     CG  439  -0.888  -1.009   0.351\n"
"   27PRO     CD  440  -0.805  -0.885   0.389\n"
"   27PRO     HA  441  -0.799  -1.065   0.650\n"
"   27PRO    HB2  442  -0.800  -1.203   0.395\n"
"   27PRO    HB3  443  -0.937  -1.161   0.498\n"
"   27PRO    HG2  444  -0.866  -1.039   0.250\n"
"   27PRO    HG3  445  -0.993  -0.987   0.361\n"
"   27PRO    HD2  446  -0.739  -0.859   0.308\n"
"   27PRO    HD3  447  -0.870  -0.803   0.414\n"
"   28GLU      N  448  -0.629  -1.268   0.593\n"
"   28GLU     CA  449  -0.506  -1.352   0.597\n"
"   28GLU      C  450  -0.473  -1.400   0.456\n"
"   28GLU      O  451  -0.362  -1.441   0.427\n"
"   28GLU     CB  452  -0.530  -1.473   0.687\n"
"   28GLU     CG  453  -0.556  -1.427   0.831\n"
"   28GLU     CD  454  -0.524  -1.541   0.928\n"
"   28GLU    OE1  455  -0.438  -1.621   0.895\n"
"   28GLU    OE2  456  -0.586  -1.545   1.033\n"
"   28GLU      H  457  -0.715  -1.307   0.618\n"
"   28GLU     HA  458  -0.424  -1.293   0.636\n"
"   28GLU    HB2  459  -0.615  -1.528   0.651\n"
"   28GLU    HB3  460  -0.442  -1.537   0.685\n"
"   28GLU    HG2  461  -0.493  -1.342   0.853\n"
"   28GLU    HG3  462  -0.660  -1.399   0.841\n"
"   29TYR      N  463  -0.569  -1.395   0.367\n"
"   29TYR     CA  464  -0.543  -1.441   0.228\n"
"   29TYR      C  465  -0.502  -1.322   0.141\n"
"   29TYR      O  466  -0.500  -1.331   0.020\n"
"   29TYR     CB  467  -0.669  -1.506   0.170\n"
"   29TYR     CG  468  -0.790  -1.425   0.209\n"
"   29TYR    CD1  469  -0.830  -1.317   0.129\n"
"   29TYR    CD2  470  -0.863  -1.458   0.324\n"
"   29TYR    CE1  471  -0.943  -1.242   0.164\n"
"   29TYR    CE2  472  -0.976  -1.383   0.359\n"
"   29TYR     CZ  473  -1.016  -1.275   0.279\n"
"   29TYR     OH  474  -1.127  -1.201   0.314\n"
"   29TYR      H  475  -0.657  -1.362   0.392\n"
"   29TYR     HA  476  -0.462  -1.513   0.229\n"
"   29TYR    HB2  477  -0.661  -1.510   0.063\n"
"   29TYR    HB3  478  -0.678  -1.606   0.210\n"
"   29TYR    HD1  479  -0.774  -1.292   0.040\n"
"   29TYR    HD2  480  -0.832  -1.541   0.385\n"
"   29TYR    HE1  481  -0.974  -1.159   0.103\n"
"   29TYR    HE2  482  -1.032  -1.408   0.448\n"
"   29TYR     HH  483  -1.194  -1.262   0.345\n"
"   30TYR      N  484  -0.469  -1.210   0.202\n"
"   30TYR     CA  485  -0.428  -1.090   0.122\n"
"   30TYR      C  486  -0.342  -1.137   0.004\n"
"   30TYR      O  487  -0.228  -1.176   0.019\n"
"   30TYR     CB  488  -0.346  -0.996   0.212\n"
"   30TYR     CG  489  -0.301  -0.874   0.134\n"
"   30TYR    CD1  490  -0.375  -0.829   0.024\n"
"   30TYR    CD2  491  -0.183  -0.807   0.171\n"
"   30TYR    CE1  492  -0.332  -0.716  -0.048\n"
"   30TYR    CE2  493  -0.140  -0.694   0.100\n"
"   30TYR     CZ  494  -0.214  -0.649  -0.010\n"
"   30TYR     OH  495  -0.172  -0.539  -0.081\n"
"   30TYR      H  496  -0.472  -1.206   0.300\n"
"   30TYR     HA  497  -0.515  -1.039   0.086\n"
"   30TYR    HB2  498  -0.407  -0.964   0.295\n"
"   30TYR    HB3  499  -0.260  -1.048   0.250\n"
"   30TYR    HD1  500  -0.465  -0.880  -0.004\n"
"   30TYR    HD2  501  -0.127  -0.841   0.256\n"
"   30TYR    HE1  502  -0.389  -0.681  -0.132\n"
"   30TYR    HE2  503  -0.048  -0.642   0.128\n"
"   30TYR     HH  504  -0.098  -0.500  -0.035\n"
"   31GLY      N  505  -0.397  -1.134  -0.115\n"
"   31GLY     CA  506  -0.322  -1.180  -0.236\n"
"   31GLY      C  507  -0.200  -1.089  -0.261\n"
"   31GLY      O  508  -0.121  -1.115  -0.350\n"
"   31GLY      H  509  -0.490  -1.103  -0.125\n"
"   31GLY    HA2  510  -0.288  -1.281  -0.220\n"
"   31GLY    HA3  511  -0.387  -1.177  -0.322\n"
"   32GLU      N  512  -0.187  -0.984  -0.185\n"
"   32GLU     CA  513  -0.073  -0.888  -0.201\n"
"   32GLU      C  514  -0.053  -0.842  -0.347\n"
"   32GLU      O  515   0.038  -0.767  -0.376\n"
"   32GLU     CB  516   0.058  -0.949  -0.147\n"
"   32GLU     CG  517   0.074  -1.095  -0.191\n"
"   32GLU     CD  518   0.205  -1.151  -0.136\n"
"   32GLU    OE1  519   0.304  -1.080  -0.141\n"
"   32GLU    OE2  520   0.204  -1.263  -0.089\n"
"   32GLU      H  521  -0.254  -0.966  -0.116\n"
"   32GLU     HA  522  -0.095  -0.800  -0.142\n"
"   32GLU    HB2  523   0.142  -0.892  -0.184\n"
"   32GLU    HB3  524   0.058  -0.945  -0.039\n"
"   32GLU    HG2  525  -0.008  -1.153  -0.154\n"
"   32GLU    HG3  526   0.076  -1.100  -0.299\n"
"   33ASN      N  527  -0.137  -0.882  -0.439\n"
"   33ASN     CA  528  -0.120  -0.834  -0.579\n"
"   33ASN      C  529  -0.189  -0.698  -0.593\n"
"   33ASN      O  530  -0.242  -0.644  -0.497\n"
"   33ASN     CB  531  -0.181  -0.932  -0.681\n"
"   33ASN     CG  532  -0.242  -1.053  -0.610\n"
"   33ASN    OD1  533  -0.172  -1.146  -0.575\n"
"   33ASN    ND2  534  -0.370  -1.056  -0.586\n"
"   33ASN      H  535  -0.213  -0.938  -0.416\n"
"   33ASN     HA  536  -0.015  -0.822  -0.600\n"
"   33ASN    HB2  537  -0.258  -0.882  -0.737\n"
"   33ASN    HB3  538  -0.104  -0.966  -0.748\n"
"   33ASN   HD21  539  -0.427  -0.981  -0.614\n"
"   33ASN   HD22  540  -0.410  -1.133  -0.541\n"
"   34LEU      N  541  -0.192  -0.643  -0.711\n"
"   34LEU     CA  542  -0.261  -0.512  -0.730\n"
"   34LEU      C  543  -0.411  -0.539  -0.733\n"
"   34LEU      O  544  -0.491  -0.462  -0.685\n"
"   34LEU     CB  545  -0.220  -0.454  -0.865\n"
"   34LEU     CG  546  -0.075  -0.407  -0.861\n"
"   34LEU    CD1  547  -0.036  -0.350  -0.997\n"
"   34LEU    CD2  548  -0.059  -0.299  -0.754\n"
"   34LEU      H  549  -0.150  -0.689  -0.787\n"
"   34LEU     HA  550  -0.236  -0.444  -0.651\n"
"   34LEU    HB2  551  -0.232  -0.530  -0.941\n"
"   34LEU    HB3  552  -0.285  -0.371  -0.888\n"
"   34LEU     HG  553  -0.011  -0.491  -0.837\n"
"   34LEU   HD11  554  -0.106  -0.385  -1.072\n"
"   34LEU   HD12  555  -0.038  -0.242  -0.993\n"
"   34LEU   HD13  556   0.064  -0.384  -1.023\n"
"   34LEU   HD21  557  -0.152  -0.287  -0.700\n"
"   34LEU   HD22  558   0.019  -0.327  -0.685\n"
"   34LEU   HD23  559  -0.033  -0.205  -0.801\n"
"   35ASP      N  560  -0.447  -0.649  -0.791\n"
"   35ASP     CA  561  -0.590  -0.689  -0.802\n"
"   35ASP      C  562  -0.647  -0.717  -0.663\n"
"   35ASP      O  563  -0.761  -0.689  -0.635\n"
"   35ASP     CB  564  -0.598  -0.817  -0.883\n"
"   35ASP     CG  565  -0.568  -0.786  -1.030\n"
"   35ASP    OD1  566  -0.634  -0.700  -1.085\n"
"   35ASP    OD2  567  -0.480  -0.851  -1.086\n"
"   35ASP      H  568  -0.378  -0.707  -0.829\n"
"   35ASP     HA  569  -0.646  -0.611  -0.850\n"
"   35ASP    HB2  570  -0.524  -0.887  -0.845\n"
"   35ASP    HB3  571  -0.696  -0.859  -0.874\n"
"   36ALA      N  572  -0.568  -0.774  -0.577\n"
"   36ALA     CA  573  -0.618  -0.806  -0.440\n"
"   36ALA      C  574  -0.612  -0.680  -0.356\n"
"   36ALA      O  575  -0.711  -0.635  -0.302\n"
"   36ALA     CB  576  -0.531  -0.913  -0.375\n"
"   36ALA      H  577  -0.475  -0.796  -0.602\n"
"   36ALA     HA  578  -0.720  -0.841  -0.446\n"
"   36ALA    HB1  579  -0.427  -0.888  -0.389\n"
"   36ALA    HB2  580  -0.553  -0.916  -0.269\n"
"   36ALA    HB3  581  -0.552  -1.008  -0.420\n"
"   37LEU      N  582  -0.497  -0.622  -0.348\n"
"   37LEU     CA  583  -0.482  -0.497  -0.270\n"
"   37LEU      C  584  -0.599  -0.406  -0.306\n"
"   37LEU      O  585  -0.671  -0.354  -0.222\n"
"   37LEU     CB  586  -0.350  -0.430  -0.310\n"
"   37LEU     CG  587  -0.354  -0.282  -0.272\n"
"   37LEU    CD1  588  -0.356  -0.267  -0.120\n"
"   37LEU    CD2  589  -0.230  -0.212  -0.329\n"
"   37LEU      H  590  -0.420  -0.660  -0.395\n"
"   37LEU     HA  591  -0.483  -0.518  -0.164\n"
"   37LEU    HB2  592  -0.269  -0.479  -0.259\n"
"   37LEU    HB3  593  -0.336  -0.440  -0.416\n"
"   37LEU     HG  594  -0.443  -0.237  -0.314\n"
"   37LEU   HD11  595  -0.321  -0.358  -0.075\n"
"   37LEU   HD12  596  -0.291  -0.185  -0.091\n"
"   37LEU   HD13  597  -0.456  -0.246  -0.087\n"
"   37LEU   HD21  598  -0.150  -0.283  -0.340\n"
"   37LEU   HD22  599  -0.254  -0.169  -0.425\n"
"   37LEU   HD23  600  -0.199  -0.133  -0.262\n"
"   38TRP      N  601  -0.617  -0.388  -0.433\n"
"   38TRP     CA  602  -0.728  -0.305  -0.482\n"
"   38TRP      C  603  -0.858  -0.361  -0.430\n"
"   38TRP      O  604  -0.934  -0.295  -0.364\n"
"   38TRP     CB  605  -0.732  -0.309  -0.634\n"
"   38TRP     CG  606  -0.846  -0.227  -0.680\n"
"   38TRP    CD1  607  -0.971  -0.272  -0.696\n"
"   38TRP    CD2  608  -0.848  -0.086  -0.713\n"
"   38TRP    NE1  609  -1.051  -0.167  -0.739\n"
"   38TRP    CE2  610  -0.979  -0.050  -0.751\n"
"   38TRP    CE3  611  -0.749   0.013  -0.714\n"
"   38TRP    CZ2  612  -1.010   0.080  -0.789\n"
"   38TRP    CZ3  613  -0.779   0.143  -0.751\n"
"   38TRP    CH2  614  -0.909   0.178  -0.789\n"
"   38TRP      H  615  -0.558  -0.432  -0.497\n"
"   38TRP     HA  616  -0.715  -0.204  -0.448\n"
"   38TRP    HB2  617  -0.640  -0.271  -0.675\n"
"   38TRP    HB3  618  -0.746  -0.411  -0.666\n"
"   38TRP    HD1  619  -1.003  -0.373  -0.679\n"
"   38TRP    HE1  620  -1.147  -0.173  -0.758\n"
"   38TRP    HE3  621  -0.649  -0.013  -0.686\n"
"   38TRP    HZ2  622  -1.111   0.105  -0.818\n"
"   38TRP    HZ3  623  -0.700   0.217  -0.749\n"
"   38TRP    HH2  624  -0.932   0.279  -0.817\n"
"   39ASP      N  625  -0.882  -0.485  -0.460\n"
"   39ASP     CA  626  -1.006  -0.550  -0.413\n"
"   39ASP      C  627  -1.028  -0.512  -0.267\n"
"   39ASP      O  628  -1.139  -0.509  -0.218\n"
"   39ASP     CB  629  -0.993  -0.702  -0.425\n"
"   39ASP     CG  630  -1.061  -0.749  -0.554\n"
"   39ASP    OD1  631  -1.005  -0.729  -0.660\n"
"   39ASP    OD2  632  -1.169  -0.804  -0.544\n"
"   39ASP      H  633  -0.816  -0.535  -0.513\n"
"   39ASP     HA  634  -1.089  -0.516  -0.473\n"
"   39ASP    HB2  635  -0.888  -0.729  -0.428\n"
"   39ASP    HB3  636  -1.040  -0.749  -0.341\n"
"   40CYS      N  637  -0.922  -0.481  -0.198\n"
"   40CYS     CA  638  -0.935  -0.441  -0.056\n"
"   40CYS      C  639  -0.980  -0.295  -0.047\n"
"   40CYS      O  640  -1.074  -0.262   0.022\n"
"   40CYS     CB  641  -0.800  -0.458   0.013\n"
"   40CYS     SG  642  -0.733  -0.622  -0.024\n"
"   40CYS      H  643  -0.833  -0.483  -0.239\n"
"   40CYS     HA  644  -1.008  -0.504  -0.007\n"
"   40CYS    HB2  645  -0.732  -0.382  -0.023\n"
"   40CYS    HB3  646  -0.813  -0.447   0.119\n"
"   40CYS     HG  647  -0.772  -0.684   0.038\n"
"   41LEU      N  648  -0.912  -0.206  -0.114\n"
"   41LEU     CA  649  -0.950  -0.062  -0.108\n"
"   41LEU      C  650  -1.094  -0.042  -0.155\n"
"   41LEU      O  651  -1.173   0.025  -0.091\n"
"   41LEU     CB  652  -0.856   0.017  -0.198\n"
"   41LEU     CG  653  -0.712  -0.029  -0.178\n"
"   41LEU    CD1  654  -0.619   0.062  -0.257\n"
"   41LEU    CD2  655  -0.676  -0.022  -0.029\n"
"   41LEU      H  656  -0.835  -0.232  -0.169\n"
"   41LEU     HA  657  -0.939  -0.028  -0.006\n"
"   41LEU    HB2  658  -0.885   0.002  -0.301\n"
"   41LEU    HB3  659  -0.864   0.122  -0.174\n"
"   41LEU     HG  660  -0.700  -0.130  -0.213\n"
"   41LEU   HD11  661  -0.677   0.141  -0.303\n"
"   41LEU   HD12  662  -0.545   0.105  -0.190\n"
"   41LEU   HD13  663  -0.570   0.005  -0.333\n"
"   41LEU   HD21  664  -0.758   0.023   0.026\n"
"   41LEU   HD22  665  -0.659  -0.122   0.008\n"
"   41LEU   HD23  666  -0.587   0.038  -0.016\n"
"   42THR      N  667  -1.128  -0.097  -0.268\n"
"   42THR     CA  668  -1.265  -0.079  -0.323\n"
"   42THR      C  669  -1.367  -0.166  -0.248\n"
"   42THR      O  670  -1.483  -0.170  -0.284\n"
"   42THR     CB  671  -1.265  -0.117  -0.471\n"
"   42THR    OG1  672  -1.187  -0.235  -0.489\n"
"   42THR    CG2  673  -1.205  -0.003  -0.553\n"
"   42THR      H  674  -1.063  -0.148  -0.318\n"
"   42THR     HA  675  -1.293   0.024  -0.313\n"
"   42THR     HB  676  -1.366  -0.136  -0.503\n"
"   42THR    HG1  677  -1.241  -0.299  -0.536\n"
"   42THR   HG21  678  -1.265   0.086  -0.538\n"
"   42THR   HG22  679  -1.104   0.016  -0.520\n"
"   42THR   HG23  680  -1.206  -0.029  -0.657\n"
"   43GLY      N  681  -1.326  -0.236  -0.145\n"
"   43GLY     CA  682  -1.426  -0.321  -0.073\n"
"   43GLY      C  683  -1.363  -0.390   0.048\n"
"   43GLY      O  684  -1.361  -0.511   0.057\n"
"   43GLY      H  685  -1.232  -0.233  -0.116\n"
"   43GLY    HA2  686  -1.508  -0.259  -0.040\n"
"   43GLY    HA3  687  -1.464  -0.396  -0.140\n"
"   44TRP      N  688  -1.312  -0.315   0.142\n"
"   44TRP     CA  689  -1.252  -0.377   0.263\n"
"   44TRP      C  690  -1.194  -0.269   0.354\n"
"   44TRP      O  691  -1.242  -0.247   0.464\n"
"   44TRP     CB  692  -1.140  -0.472   0.220\n"
"   44TRP     CG  693  -1.081  -0.536   0.341\n"
"   44TRP    CD1  694  -0.974  -0.489   0.408\n"
"   44TRP    CD2  695  -1.123  -0.657   0.411\n"
"   44TRP    NE1  696  -0.947  -0.574   0.515\n"
"   44TRP    CE2  697  -1.037  -0.679   0.520\n"
"   44TRP    CE3  698  -1.227  -0.749   0.389\n"
"   44TRP    CZ2  699  -1.053  -0.788   0.606\n"
"   44TRP    CZ3  700  -1.244  -0.859   0.475\n"
"   44TRP    CH2  701  -1.157  -0.878   0.583\n"
"   44TRP      H  702  -1.315  -0.218   0.134\n"
"   44TRP     HA  703  -1.327  -0.433   0.317\n"
"   44TRP    HB2  704  -1.180  -0.548   0.155\n"
"   44TRP    HB3  705  -1.064  -0.416   0.168\n"
"   44TRP    HD1  706  -0.918  -0.400   0.383\n"
"   44TRP    HE1  707  -0.874  -0.562   0.579\n"
"   44TRP    HE3  708  -1.295  -0.735   0.306\n"
"   44TRP    HZ2  709  -0.985  -0.802   0.689\n"
"   44TRP    HZ3  710  -1.324  -0.929   0.458\n"
"   44TRP    HH2  711  -1.170  -0.963   0.649\n"
"   45VAL      N  712  -1.092  -0.202   0.309\n"
"   45VAL     CA  713  -1.030  -0.095   0.391\n"
"   45VAL      C  714  -1.135   0.011   0.425\n"
"   45VAL      O  715  -1.226   0.036   0.349\n"
"   45VAL     CB  716  -0.916  -0.030   0.312\n"
"   45VAL    CG1  717  -0.844   0.071   0.402\n"
"   45VAL    CG2  718  -0.818  -0.138   0.266\n"
"   45VAL      H  719  -1.056  -0.222   0.221\n"
"   45VAL     HA  720  -0.992  -0.138   0.482\n"
"   45VAL     HB  721  -0.957   0.021   0.226\n"
"   45VAL   HG11  722  -0.820   0.024   0.496\n"
"   45VAL   HG12  723  -0.752   0.102   0.353\n"
"   45VAL   HG13  724  -0.907   0.157   0.418\n"
"   45VAL   HG21  725  -0.873  -0.221   0.223\n"
"   45VAL   HG22  726  -0.752  -0.096   0.192\n"
"   45VAL   HG23  727  -0.760  -0.172   0.350\n"
"   46GLU      N  728  -1.122   0.075   0.538\n"
"   46GLU     CA  729  -1.220   0.181   0.576\n"
"   46GLU      C  730  -1.157   0.318   0.550\n"
"   46GLU      O  731  -1.044   0.343   0.588\n"
"   46GLU     CB  732  -1.260   0.169   0.723\n"
"   46GLU     CG  733  -1.158   0.085   0.799\n"
"   46GLU     CD  734  -1.211   0.054   0.939\n"
"   46GLU    OE1  735  -1.309  -0.017   0.949\n"
"   46GLU    OE2  736  -1.152   0.104   1.035\n"
"   46GLU      H  737  -1.046   0.054   0.598\n"
"   46GLU     HA  738  -1.308   0.171   0.514\n"
"   46GLU    HB2  739  -1.265   0.267   0.767\n"
"   46GLU    HB3  740  -1.357   0.122   0.730\n"
"   46GLU    HG2  741  -1.140  -0.008   0.746\n"
"   46GLU    HG3  742  -1.065   0.140   0.807\n"
"   47TYR      N  743  -1.229   0.405   0.486\n"
"   47TYR     CA  744  -1.174   0.540   0.456\n"
"   47TYR      C  745  -1.256   0.645   0.533\n"
"   47TYR      O  746  -1.359   0.611   0.589\n"
"   47TYR     CB  747  -1.185   0.562   0.305\n"
"   47TYR     CG  748  -1.087   0.472   0.232\n"
"   47TYR    CD1  749  -0.983   0.408   0.302\n"
"   47TYR    CD2  750  -1.099   0.452   0.094\n"
"   47TYR    CE1  751  -0.893   0.325   0.234\n"
"   47TYR    CE2  752  -1.009   0.369   0.027\n"
"   47TYR     CZ  753  -0.907   0.306   0.097\n"
"   47TYR     OH  754  -0.818   0.224   0.030\n"
"   47TYR      H  755  -1.319   0.380   0.457\n"
"   47TYR     HA  756  -1.071   0.545   0.486\n"
"   47TYR    HB2  757  -1.285   0.538   0.272\n"
"   47TYR    HB3  758  -1.164   0.665   0.281\n"
"   47TYR    HD1  759  -0.971   0.423   0.408\n"
"   47TYR    HD2  760  -1.178   0.501   0.040\n"
"   47TYR    HE1  761  -0.813   0.277   0.288\n"
"   47TYR    HE2  762  -1.018   0.355  -0.080\n"
"   47TYR     HH  763  -0.733   0.230   0.074\n"
"   48PRO      N  764  -1.210   0.768   0.536\n"
"   48PRO     CA  765  -1.086   0.813   0.468\n"
"   48PRO      C  766  -0.962   0.741   0.522\n"
"   48PRO      O  767  -0.946   0.723   0.641\n"
"   48PRO     CB  768  -1.076   0.963   0.501\n"
"   48PRO     CG  769  -1.197   1.000   0.590\n"
"   48PRO     CD  770  -1.281   0.874   0.610\n"
"   48PRO     HA  771  -1.093   0.801   0.362\n"
"   48PRO    HB2  772  -0.984   0.983   0.554\n"
"   48PRO    HB3  773  -1.079   1.021   0.410\n"
"   48PRO    HG2  774  -1.162   1.036   0.686\n"
"   48PRO    HG3  775  -1.256   1.076   0.542\n"
"   48PRO    HD2  776  -1.288   0.849   0.715\n"
"   48PRO    HD3  777  -1.380   0.888   0.568\n"
"   49LEU      N  778  -0.874   0.700   0.434\n"
"   49LEU     CA  779  -0.750   0.630   0.477\n"
"   49LEU      C  780  -0.630   0.718   0.446\n"
"   49LEU      O  781  -0.633   0.800   0.357\n"
"   49LEU     CB  782  -0.736   0.498   0.399\n"
"   49LEU     CG  783  -0.589   0.456   0.386\n"
"   49LEU    CD1  784  -0.535   0.407   0.521\n"
"   49LEU    CD2  785  -0.576   0.345   0.282\n"
"   49LEU      H  786  -0.890   0.716   0.338\n"
"   49LEU     HA  787  -0.754   0.609   0.583\n"
"   49LEU    HB2  788  -0.791   0.420   0.450\n"
"   49LEU    HB3  789  -0.777   0.512   0.301\n"
"   49LEU     HG  790  -0.530   0.541   0.354\n"
"   49LEU   HD11  791  -0.608   0.427   0.598\n"
"   49LEU   HD12  792  -0.517   0.300   0.516\n"
"   49LEU   HD13  793  -0.442   0.458   0.544\n"
"   49LEU   HD21  794  -0.659   0.351   0.212\n"
"   49LEU   HD22  795  -0.483   0.357   0.228\n"
"   49LEU   HD23  796  -0.577   0.249   0.331\n"
"   50VAL      N  797  -0.522   0.698   0.516\n"
"   50VAL     CA  798  -0.400   0.777   0.486\n"
"   50VAL      C  799  -0.292   0.679   0.441\n"
"   50VAL      O  800  -0.275   0.574   0.499\n"
"   50VAL     CB  801  -0.356   0.855   0.611\n"
"   50VAL    CG1  802  -0.213   0.816   0.654\n"
"   50VAL    CG2  803  -0.357   1.005   0.580\n"
"   50VAL      H  804  -0.520   0.629   0.585\n"
"   50VAL     HA  805  -0.421   0.846   0.405\n"
"   50VAL     HB  806  -0.424   0.835   0.692\n"
"   50VAL   HG11  807  -0.150   0.812   0.567\n"
"   50VAL   HG12  808  -0.175   0.889   0.724\n"
"   50VAL   HG13  809  -0.216   0.719   0.702\n"
"   50VAL   HG21  810  -0.451   1.032   0.536\n"
"   50VAL   HG22  811  -0.343   1.061   0.672\n"
"   50VAL   HG23  812  -0.276   1.028   0.512\n"
"   51LEU      N  813  -0.217   0.712   0.341\n"
"   51LEU     CA  814  -0.108   0.621   0.298\n"
"   51LEU      C  815   0.023   0.697   0.311\n"
"   51LEU      O  816   0.075   0.752   0.215\n"
"   51LEU     CB  817  -0.127   0.575   0.152\n"
"   51LEU     CG  818  -0.011   0.482   0.115\n"
"   51LEU    CD1  819  -0.020   0.354   0.197\n"
"   51LEU    CD2  820  -0.019   0.445  -0.033\n"
"   51LEU      H  821  -0.229   0.798   0.297\n"
"   51LEU     HA  822  -0.106   0.535   0.363\n"
"   51LEU    HB2  823  -0.219   0.521   0.143\n"
"   51LEU    HB3  824  -0.128   0.660   0.087\n"
"   51LEU     HG  825   0.083   0.532   0.135\n"
"   51LEU   HD11  826  -0.115   0.350   0.247\n"
"   51LEU   HD12  827  -0.009   0.269   0.132\n"
"   51LEU   HD13  828   0.060   0.353   0.271\n"
"   51LEU   HD21  829  -0.120   0.457  -0.068\n"
"   51LEU   HD22  830   0.047   0.509  -0.090\n"
"   51LEU   HD23  831   0.012   0.342  -0.045\n"
"   52GLU      N  832   0.076   0.701   0.430\n"
"   52GLU     CA  833   0.203   0.774   0.451\n"
"   52GLU      C  834   0.316   0.686   0.399\n"
"   52GLU      O  835   0.379   0.612   0.472\n"
"   52GLU     CB  836   0.221   0.803   0.600\n"
"   52GLU     CG  837   0.364   0.851   0.626\n"
"   52GLU     CD  838   0.365   0.947   0.744\n"
"   52GLU    OE1  839   0.272   0.942   0.823\n"
"   52GLU    OE2  840   0.459   1.024   0.755\n"
"   52GLU      H  841   0.032   0.657   0.505\n"
"   52GLU     HA  842   0.201   0.867   0.395\n"
"   52GLU    HB2  843   0.151   0.880   0.630\n"
"   52GLU    HB3  844   0.203   0.713   0.656\n"
"   52GLU    HG2  845   0.427   0.766   0.648\n"
"   52GLU    HG3  846   0.402   0.902   0.538\n"
"   53TRP      N  847   0.338   0.692   0.271\n"
"   53TRP     CA  848   0.444   0.607   0.210\n"
"   53TRP      C  849   0.581   0.669   0.232\n"
"   53TRP      O  850   0.614   0.772   0.176\n"
"   53TRP     CB  851   0.417   0.595   0.060\n"
"   53TRP     CG  852   0.481   0.469   0.012\n"
"   53TRP    CD1  853   0.608   0.433   0.038\n"
"   53TRP    CD2  854   0.422   0.362  -0.067\n"
"   53TRP    NE1  855   0.632   0.310  -0.021\n"
"   53TRP    CE2  856   0.521   0.263  -0.087\n"
"   53TRP    CE3  857   0.295   0.342  -0.123\n"
"   53TRP    CZ2  858   0.495   0.147  -0.160\n"
"   53TRP    CZ3  859   0.268   0.225  -0.197\n"
"   53TRP    CH2  860   0.368   0.128  -0.216\n"
"   53TRP      H  861   0.284   0.750   0.214\n"
"   53TRP     HA  862   0.441   0.509   0.255\n"
"   53TRP    HB2  863   0.311   0.591   0.042\n"
"   53TRP    HB3  864   0.461   0.679   0.009\n"
"   53TRP    HD1  865   0.680   0.490   0.095\n"
"   53TRP    HE1  866   0.717   0.262  -0.018\n"
"   53TRP    HE3  867   0.217   0.416  -0.109\n"
"   53TRP    HZ2  868   0.572   0.073  -0.174\n"
"   53TRP    HZ3  869   0.171   0.210  -0.241\n"
"   53TRP    HH2  870   0.347   0.039  -0.273\n"
"   54ARG      N  871   0.663   0.607   0.312\n"
"   54ARG     CA  872   0.799   0.661   0.337\n"
"   54ARG      C  873   0.899   0.582   0.252\n"
"   54ARG      O  874   0.878   0.466   0.222\n"
"   54ARG     CB  875   0.835   0.645   0.485\n"
"   54ARG     CG  876   0.854   0.783   0.548\n"
"   54ARG     CD  877   0.877   0.767   0.698\n"
"   54ARG     NE  878   1.001   0.840   0.738\n"
"   54ARG     CZ  879   1.025   0.863   0.864\n"
"   54ARG    NH1  880   1.072   0.768   0.940\n"
"   54ARG    NH2  881   1.003   0.982   0.913\n"
"   54ARG      H  882   0.634   0.524   0.356\n"
"   54ARG     HA  883   0.803   0.765   0.310\n"
"   54ARG    HB2  884   0.754   0.593   0.536\n"
"   54ARG    HB3  885   0.926   0.587   0.494\n"
"   54ARG    HG2  886   0.940   0.831   0.503\n"
"   54ARG    HG3  887   0.766   0.843   0.531\n"
"   54ARG    HD2  888   0.793   0.807   0.752\n"
"   54ARG    HD3  889   0.888   0.662   0.722\n"
"   54ARG     HE  890   1.064   0.870   0.670\n"
"   54ARG   HH11  891   1.089   0.677   0.902\n"
"   54ARG   HH12  892   1.091   0.786   1.036\n"
"   54ARG   HH21  893   0.968   1.054   0.855\n"
"   54ARG   HH22  894   1.023   1.000   1.010\n"
"   55GLN      N  895   1.006   0.644   0.211\n"
"   55GLN     CA  896   1.105   0.571   0.126\n"
"   55GLN      C  897   1.031   0.503   0.011\n"
"   55GLN      O  898   1.019   0.383   0.006\n"
"   55GLN     CB  899   1.176   0.465   0.211\n"
"   55GLN     CG  900   1.325   0.497   0.219\n"
"   55GLN     CD  901   1.354   0.575   0.347\n"
"   55GLN    OE1  902   1.271   0.582   0.435\n"
"   55GLN    NE2  903   1.470   0.634   0.362\n"
"   55GLN      H  904   1.021   0.738   0.235\n"
"   55GLN     HA  905   1.178   0.641   0.087\n"
"   55GLN    HB2  906   1.134   0.464   0.311\n"
"   55GLN    HB3  907   1.163   0.368   0.166\n"
"   55GLN    HG2  908   1.382   0.405   0.218\n"
"   55GLN    HG3  909   1.353   0.558   0.133\n"
"   55GLN   HE21  910   1.537   0.628   0.290\n"
"   55GLN   HE22  911   1.490   0.684   0.444\n"
"   56PHE      N  912   0.979   0.581  -0.080\n"
"   56PHE     CA  913   0.904   0.523  -0.195\n"
"   56PHE      C  914   1.000   0.458  -0.294\n"
"   56PHE      O  915   1.000   0.337  -0.312\n"
"   56PHE     CB  916   0.827   0.636  -0.264\n"
"   56PHE     CG  917   0.721   0.581  -0.357\n"
"   56PHE    CD1  918   0.694   0.443  -0.363\n"
"   56PHE    CD2  919   0.650   0.669  -0.439\n"
"   56PHE    CE1  920   0.595   0.395  -0.451\n"
"   56PHE    CE2  921   0.552   0.621  -0.526\n"
"   56PHE     CZ  922   0.525   0.484  -0.532\n"
"   56PHE      H  923   0.989   0.678  -0.072\n"
"   56PHE     HA  924   0.834   0.449  -0.158\n"
"   56PHE    HB2  925   0.779   0.697  -0.189\n"
"   56PHE    HB3  926   0.896   0.697  -0.320\n"
"   56PHE    HD1  927   0.748   0.374  -0.300\n"
"   56PHE    HD2  928   0.670   0.775  -0.433\n"
"   56PHE    HE1  929   0.573   0.290  -0.455\n"
"   56PHE    HE2  930   0.498   0.690  -0.589\n"
"   56PHE     HZ  931   0.449   0.447  -0.600\n"
"   57GLU      N  932   1.082   0.535  -0.359\n"
"   57GLU     CA  933   1.178   0.477  -0.458\n"
"   57GLU      C  934   1.264   0.371  -0.388\n"
"   57GLU      O  935   1.300   0.271  -0.447\n"
"   57GLU     CB  936   1.270   0.586  -0.512\n"
"   57GLU     CG  937   1.199   0.663  -0.623\n"
"   57GLU     CD  938   1.279   0.789  -0.657\n"
"   57GLU    OE1  939   1.381   0.811  -0.594\n"
"   57GLU    OE2  940   1.238   0.861  -0.746\n"
"   57GLU      H  941   1.081   0.632  -0.344\n"
"   57GLU     HA  942   1.124   0.432  -0.539\n"
"   57GLU    HB2  943   1.297   0.654  -0.432\n"
"   57GLU    HB3  944   1.360   0.540  -0.551\n"
"   57GLU    HG2  945   1.191   0.601  -0.711\n"
"   57GLU    HG3  946   1.100   0.692  -0.590\n"
"   58GLN      N  947   1.296   0.392  -0.264\n"
"   58GLN     CA  948   1.379   0.294  -0.190\n"
"   58GLN      C  949   1.298   0.166  -0.173\n"
"   58GLN      O  950   1.352   0.057  -0.173\n"
"   58GLN     CB  951   1.416   0.352  -0.053\n"
"   58GLN     CG  952   1.506   0.474  -0.072\n"
"   58GLN     CD  953   1.653   0.432  -0.054\n"
"   58GLN    OE1  954   1.681   0.327  -0.001\n"
"   58GLN    NE2  955   1.747   0.511  -0.097\n"
"   58GLN      H  956   1.266   0.473  -0.220\n"
"   58GLN     HA  957   1.468   0.274  -0.246\n"
"   58GLN    HB2  958   1.326   0.381  -0.001\n"
"   58GLN    HB3  959   1.468   0.277   0.005\n"
"   58GLN    HG2  960   1.492   0.513  -0.172\n"
"   58GLN    HG3  961   1.481   0.549   0.000\n"
"   58GLN   HE21  962   1.724   0.596  -0.140\n"
"   58GLN   HE22  963   1.841   0.486  -0.086\n"
"   59SER      N  964   1.168   0.177  -0.161\n"
"   59SER     CA  965   1.083   0.056  -0.147\n"
"   59SER      C  966   1.032   0.017  -0.286\n"
"   59SER      O  967   0.937  -0.058  -0.300\n"
"   59SER     CB  968   0.964   0.086  -0.056\n"
"   59SER     OG  969   0.986   0.027   0.071\n"
"   59SER      H  970   1.127   0.266  -0.163\n"
"   59SER     HA  971   1.141  -0.025  -0.106\n"
"   59SER    HB2  972   0.953   0.192  -0.044\n"
"   59SER    HB3  973   0.874   0.045  -0.101\n"
"   59SER     HG  974   0.909   0.044   0.125\n"
"   60LYS      N  975   1.095   0.068  -0.388\n"
"   60LYS     CA  976   1.053   0.034  -0.527\n"
"   60LYS      C  977   1.161  -0.052  -0.592\n"
"   60LYS      O  978   1.133  -0.144  -0.667\n"
"   60LYS     CB  979   1.036   0.164  -0.606\n"
"   60LYS     CG  980   0.952   0.136  -0.731\n"
"   60LYS     CD  981   0.932   0.266  -0.808\n"
"   60LYS     CE  982   0.953   0.241  -0.957\n"
"   60LYS     NZ  983   1.051   0.340  -1.011\n"
"   60LYS      H  984   1.172   0.127  -0.374\n"
"   60LYS     HA  985   0.960  -0.020  -0.524\n"
"   60LYS    HB2  986   0.985   0.237  -0.545\n"
"   60LYS    HB3  987   1.132   0.201  -0.636\n"
"   60LYS    HG2  988   1.003   0.064  -0.794\n"
"   60LYS    HG3  989   0.856   0.097  -0.702\n"
"   60LYS    HD2  990   0.831   0.303  -0.792\n"
"   60LYS    HD3  991   1.003   0.340  -0.774\n"
"   60LYS    HE2  992   0.991   0.141  -0.972\n"
"   60LYS    HE3  993   0.859   0.252  -1.009\n"
"   60LYS    HZ1  994   1.023   0.436  -0.983\n"
"   60LYS    HZ2  995   1.145   0.319  -0.974\n"
"   60LYS    HZ3  996   1.052   0.334  -1.115\n"
"   61GLN      N  997   1.286  -0.023  -0.566\n"
"   61GLN     CA  998   1.396  -0.102  -0.626\n"
"   61GLN      C  999   1.401  -0.243  -0.565\n"
"   61GLN      O 1000   1.384  -0.342  -0.633\n"
"   61GLN     CB 1001   1.530  -0.032  -0.601\n"
"   61GLN     CG 1002   1.533   0.102  -0.675\n"
"   61GLN     CD 1003   1.670   0.122  -0.738\n"
"   61GLN    OE1 1004   1.750   0.030  -0.744\n"
"   61GLN    NE2 1005   1.702   0.239  -0.787\n"
"   61GLN      H 1006   1.307   0.052  -0.506\n"
"   61GLN     HA 1007   1.380  -0.109  -0.732\n"
"   61GLN    HB2 1008   1.541  -0.014  -0.495\n"
"   61GLN    HB3 1009   1.611  -0.094  -0.636\n"
"   61GLN    HG2 1010   1.457   0.102  -0.752\n"
"   61GLN    HG3 1011   1.513   0.183  -0.606\n"
"   61GLN   HE21 1012   1.638   0.313  -0.782\n"
"   61GLN   HE22 1013   1.790   0.253  -0.828\n"
"   62LEU      N 1014   1.426  -0.250  -0.437\n"
"   62LEU     CA 1015   1.436  -0.382  -0.366\n"
"   62LEU      C 1016   1.339  -0.483  -0.428\n"
"   62LEU      O 1017   1.365  -0.602  -0.430\n"
"   62LEU     CB 1018   1.400  -0.368  -0.217\n"
"   62LEU     CG 1019   1.361  -0.224  -0.182\n"
"   62LEU    CD1 1020   1.233  -0.184  -0.256\n"
"   62LEU    CD2 1021   1.337  -0.215  -0.031\n"
"   62LEU      H 1022   1.441  -0.167  -0.388\n"
"   62LEU     HA 1023   1.537  -0.420  -0.375\n"
"   62LEU    HB2 1024   1.316  -0.433  -0.195\n"
"   62LEU    HB3 1025   1.484  -0.397  -0.157\n"
"   62LEU     HG 1026   1.441  -0.157  -0.209\n"
"   62LEU   HD11 1027   1.228  -0.235  -0.351\n"
"   62LEU   HD12 1028   1.146  -0.211  -0.197\n"
"   62LEU   HD13 1029   1.234  -0.078  -0.273\n"
"   62LEU   HD21 1030   1.269  -0.293  -0.000\n"
"   62LEU   HD22 1031   1.431  -0.225   0.021\n"
"   62LEU   HD23 1032   1.293  -0.119  -0.008\n"
"   63THR      N 1033   1.228  -0.438  -0.477\n"
"   63THR     CA 1034   1.130  -0.531  -0.538\n"
"   63THR      C 1035   1.093  -0.479  -0.676\n"
"   63THR      O 1036   0.980  -0.444  -0.703\n"
"   63THR     CB 1037   1.004  -0.545  -0.448\n"
"   63THR    OG1 1038   0.889  -0.560  -0.530\n"
"   63THR    CG2 1039   0.985  -0.423  -0.356\n"
"   63THR      H 1040   1.209  -0.343  -0.475\n"
"   63THR     HA 1041   1.176  -0.628  -0.549\n"
"   63THR     HB 1042   1.015  -0.633  -0.387\n"
"   63THR    HG1 1043   0.900  -0.640  -0.582\n"
"   63THR   HG21 1044   1.070  -0.357  -0.362\n"
"   63THR   HG22 1045   0.896  -0.370  -0.386\n"
"   63THR   HG23 1046   0.974  -0.457  -0.254\n"
"   64GLU      N 1047   1.192  -0.472  -0.763\n"
"   64GLU     CA 1048   1.173  -0.423  -0.904\n"
"   64GLU      C 1049   1.025  -0.412  -0.939\n"
"   64GLU      O 1050   0.957  -0.511  -0.958\n"
"   64GLU     CB 1051   1.240  -0.521  -0.999\n"
"   64GLU     CG 1052   1.290  -0.447  -1.123\n"
"   64GLU     CD 1053   1.405  -0.526  -1.186\n"
"   64GLU    OE1 1054   1.429  -0.637  -1.143\n"
"   64GLU    OE2 1055   1.467  -0.473  -1.277\n"
"   64GLU      H 1056   1.282  -0.500  -0.734\n"
"   64GLU     HA 1057   1.220  -0.326  -0.914\n"
"   64GLU    HB2 1058   1.324  -0.569  -0.950\n"
"   64GLU    HB3 1059   1.169  -0.597  -1.029\n"
"   64GLU    HG2 1060   1.209  -0.438  -1.194\n"
"   64GLU    HG3 1061   1.325  -0.349  -1.095\n"
"   65ASN      N 1062   0.973  -0.292  -0.947\n"
"   65ASN     CA 1063   0.829  -0.276  -0.980\n"
"   65ASN      C 1064   0.746  -0.316  -0.858\n"
"   65ASN      O 1065   0.637  -0.370  -0.871\n"
"   65ASN     CB 1066   0.794  -0.368  -1.097\n"
"   65ASN     CG 1067   0.683  -0.306  -1.181\n"
"   65ASN    OD1 1068   0.685  -0.188  -1.210\n"
"   65ASN    ND2 1069   0.584  -0.382  -1.222\n"
"   65ASN      H 1070   1.029  -0.213  -0.931\n"
"   65ASN     HA 1071   0.808  -0.174  -1.007\n"
"   65ASN    HB2 1072   0.882  -0.383  -1.159\n"
"   65ASN    HB3 1073   0.761  -0.464  -1.059\n"
"   65ASN   HD21 1074   0.583  -0.477  -1.199\n"
"   65ASN   HD22 1075   0.512  -0.343  -1.277\n"
"   66GLY      N 1076   0.797  -0.293  -0.740\n"
"   66GLY     CA 1077   0.723  -0.333  -0.618\n"
"   66GLY      C 1078   0.628  -0.223  -0.568\n"
"   66GLY      O 1079   0.507  -0.238  -0.568\n"
"   66GLY      H 1080   0.886  -0.252  -0.732\n"
"   66GLY    HA2 1081   0.665  -0.422  -0.639\n"
"   66GLY    HA3 1082   0.794  -0.355  -0.539\n"
"   67ALA      N 1083   0.683  -0.116  -0.518\n"
"   67ALA     CA 1084   0.600  -0.007  -0.459\n"
"   67ALA      C 1085   0.531   0.085  -0.562\n"
"   67ALA      O 1086   0.435   0.151  -0.529\n"
"   67ALA     CB 1087   0.691   0.078  -0.371\n"
"   67ALA      H 1088   0.780  -0.109  -0.514\n"
"   67ALA     HA 1089   0.525  -0.052  -0.397\n"
"   67ALA    HB1 1090   0.778   0.106  -0.428\n"
"   67ALA    HB2 1091   0.638   0.166  -0.339\n"
"   67ALA    HB3 1092   0.721   0.020  -0.285\n"
"   68GLU      N 1093   0.578   0.094  -0.682\n"
"   68GLU     CA 1094   0.513   0.185  -0.777\n"
"   68GLU      C 1095   0.375   0.129  -0.818\n"
"   68GLU      O 1096   0.288   0.202  -0.862\n"
"   68GLU     CB 1097   0.607   0.202  -0.897\n"
"   68GLU     CG 1098   0.527   0.202  -1.026\n"
"   68GLU     CD 1099   0.615   0.252  -1.141\n"
"   68GLU    OE1 1100   0.699   0.337  -1.117\n"
"   68GLU    OE2 1101   0.596   0.205  -1.252\n"
"   68GLU      H 1102   0.655   0.043  -0.711\n"
"   68GLU     HA 1103   0.500   0.280  -0.729\n"
"   68GLU    HB2 1104   0.661   0.295  -0.888\n"
"   68GLU    HB3 1105   0.677   0.120  -0.899\n"
"   68GLU    HG2 1106   0.495   0.101  -1.045\n"
"   68GLU    HG3 1107   0.442   0.266  -1.014\n"
"   69SER      N 1108   0.354   0.001  -0.803\n"
"   69SER     CA 1109   0.223  -0.058  -0.842\n"
"   69SER      C 1110   0.120  -0.038  -0.730\n"
"   69SER      O 1111   0.012   0.016  -0.751\n"
"   69SER     CB 1112   0.241  -0.208  -0.867\n"
"   69SER     OG 1113   0.213  -0.237  -1.003\n"
"   69SER      H 1114   0.426  -0.056  -0.768\n"
"   69SER     HA 1115   0.187  -0.011  -0.932\n"
"   69SER    HB2 1116   0.342  -0.237  -0.845\n"
"   69SER    HB3 1117   0.173  -0.264  -0.803\n"
"   69SER     HG 1118   0.294  -0.227  -1.053\n"
"   70VAL      N 1119   0.151  -0.082  -0.611\n"
"   70VAL     CA 1120   0.054  -0.066  -0.498\n"
"   70VAL      C 1121   0.011   0.079  -0.491\n"
"   70VAL      O 1122  -0.106   0.110  -0.475\n"
"   70VAL     CB 1123   0.122  -0.106  -0.367\n"
"   70VAL    CG1 1124   0.029  -0.074  -0.250\n"
"   70VAL    CG2 1125   0.150  -0.257  -0.369\n"
"   70VAL      H 1126   0.237  -0.125  -0.595\n"
"   70VAL     HA 1127  -0.032  -0.129  -0.516\n"
"   70VAL     HB 1128   0.214  -0.052  -0.356\n"
"   70VAL   HG11 1129  -0.047  -0.004  -0.282\n"
"   70VAL   HG12 1130  -0.019  -0.164  -0.215\n"
"   70VAL   HG13 1131   0.086  -0.030  -0.170\n"
"   70VAL   HG21 1132   0.070  -0.308  -0.419\n"
"   70VAL   HG22 1133   0.243  -0.275  -0.421\n"
"   70VAL   HG23 1134   0.159  -0.293  -0.267\n"
"   71LEU      N 1135   0.103   0.170  -0.505\n"
"   71LEU     CA 1136   0.066   0.313  -0.500\n"
"   71LEU      C 1137  -0.034   0.341  -0.611\n"
"   71LEU      O 1138  -0.133   0.406  -0.591\n"
"   71LEU     CB 1139   0.190   0.400  -0.523\n"
"   71LEU     CG 1140   0.148   0.546  -0.530\n"
"   71LEU    CD1 1141   0.118   0.599  -0.390\n"
"   71LEU    CD2 1142   0.261   0.629  -0.592\n"
"   71LEU      H 1143   0.197   0.142  -0.519\n"
"   71LEU     HA 1144   0.022   0.337  -0.404\n"
"   71LEU    HB2 1145   0.259   0.386  -0.442\n"
"   71LEU    HB3 1146   0.235   0.371  -0.616\n"
"   71LEU     HG 1147   0.059   0.555  -0.592\n"
"   71LEU   HD11 1148   0.091   0.516  -0.326\n"
"   71LEU   HD12 1149   0.205   0.648  -0.350\n"
"   71LEU   HD13 1150   0.036   0.669  -0.394\n"
"   71LEU   HD21 1151   0.319   0.567  -0.658\n"
"   71LEU   HD22 1152   0.219   0.711  -0.649\n"
"   71LEU   HD23 1153   0.324   0.668  -0.514\n"
"   72GLN      N 1154  -0.008   0.291  -0.729\n"
"   72GLN     CA 1155  -0.103   0.314  -0.842\n"
"   72GLN      C 1156  -0.242   0.272  -0.798\n"
"   72GLN      O 1157  -0.341   0.331  -0.833\n"
"   72GLN     CB 1158  -0.058   0.228  -0.962\n"
"   72GLN     CG 1159  -0.179   0.187  -1.047\n"
"   72GLN     CD 1160  -0.130   0.132  -1.181\n"
"   72GLN    OE1 1161  -0.107   0.206  -1.274\n"
"   72GLN    NE2 1162  -0.114   0.003  -1.196\n"
"   72GLN      H 1163   0.073   0.238  -0.743\n"
"   72GLN     HA 1164  -0.104   0.418  -0.869\n"
"   72GLN    HB2 1165   0.010   0.284  -1.022\n"
"   72GLN    HB3 1166  -0.009   0.139  -0.925\n"
"   72GLN    HG2 1167  -0.235   0.111  -0.995\n"
"   72GLN    HG3 1168  -0.242   0.273  -1.064\n"
"   72GLN   HE21 1169  -0.133  -0.057  -1.121\n"
"   72GLN   HE22 1170  -0.083  -0.033  -1.281\n"
"   73VAL      N 1171  -0.249   0.167  -0.723\n"
"   73VAL     CA 1172  -0.380   0.116  -0.677\n"
"   73VAL      C 1173  -0.435   0.206  -0.566\n"
"   73VAL      O 1174  -0.555   0.220  -0.551\n"
"   73VAL     CB 1175  -0.359  -0.025  -0.627\n"
"   73VAL    CG1 1176  -0.484  -0.075  -0.555\n"
"   73VAL    CG2 1177  -0.326  -0.115  -0.747\n"
"   73VAL      H 1178  -0.167   0.119  -0.698\n"
"   73VAL     HA 1179  -0.448   0.115  -0.760\n"
"   73VAL     HB 1180  -0.277  -0.026  -0.558\n"
"   73VAL   HG11 1181  -0.547   0.009  -0.530\n"
"   73VAL   HG12 1182  -0.538  -0.143  -0.619\n"
"   73VAL   HG13 1183  -0.455  -0.126  -0.464\n"
"   73VAL   HG21 1184  -0.368  -0.072  -0.837\n"
"   73VAL   HG22 1185  -0.218  -0.122  -0.758\n"
"   73VAL   HG23 1186  -0.367  -0.214  -0.731\n"
"   74PHE      N 1187  -0.350   0.265  -0.487\n"
"   74PHE     CA 1188  -0.400   0.353  -0.377\n"
"   74PHE      C 1189  -0.450   0.486  -0.436\n"
"   74PHE      O 1190  -0.546   0.544  -0.389\n"
"   74PHE     CB 1191  -0.287   0.381  -0.278\n"
"   74PHE     CG 1192  -0.293   0.281  -0.165\n"
"   74PHE    CD1 1193  -0.389   0.293  -0.065\n"
"   74PHE    CD2 1194  -0.201   0.175  -0.161\n"
"   74PHE    CE1 1195  -0.395   0.200   0.040\n"
"   74PHE    CE2 1196  -0.206   0.082  -0.056\n"
"   74PHE     CZ 1197  -0.303   0.095   0.044\n"
"   74PHE      H 1198  -0.254   0.251  -0.500\n"
"   74PHE     HA 1199  -0.481   0.304  -0.326\n"
"   74PHE    HB2 1200  -0.191   0.372  -0.328\n"
"   74PHE    HB3 1201  -0.298   0.480  -0.238\n"
"   74PHE    HD1 1202  -0.460   0.375  -0.068\n"
"   74PHE    HD2 1203  -0.126   0.165  -0.238\n"
"   74PHE    HE1 1204  -0.469   0.210   0.117\n"
"   74PHE    HE2 1205  -0.135   0.001  -0.053\n"
"   74PHE     HZ 1206  -0.306   0.023   0.124\n"
"   75ARG      N 1207  -0.386   0.533  -0.539\n"
"   75ARG     CA 1208  -0.427   0.661  -0.602\n"
"   75ARG      C 1209  -0.545   0.634  -0.693\n"
"   75ARG      O 1210  -0.637   0.712  -0.703\n"
"   75ARG     CB 1211  -0.312   0.715  -0.685\n"
"   75ARG     CG 1212  -0.199   0.762  -0.593\n"
"   75ARG     CD 1213  -0.179   0.913  -0.611\n"
"   75ARG     NE 1214  -0.119   0.939  -0.744\n"
"   75ARG     CZ 1215  -0.118   1.060  -0.793\n"
"   75ARG    NH1 1216  -0.131   1.163  -0.713\n"
"   75ARG    NH2 1217  -0.103   1.079  -0.921\n"
"   75ARG      H 1218  -0.311   0.485  -0.575\n"
"   75ARG     HA 1219  -0.454   0.732  -0.526\n"
"   75ARG    HB2 1220  -0.275   0.636  -0.749\n"
"   75ARG    HB3 1221  -0.347   0.797  -0.745\n"
"   75ARG    HG2 1222  -0.226   0.742  -0.490\n"
"   75ARG    HG3 1223  -0.108   0.711  -0.618\n"
"   75ARG    HD2 1224  -0.274   0.963  -0.604\n"
"   75ARG    HD3 1225  -0.113   0.950  -0.533\n"
"   75ARG     HE 1226  -0.079   0.866  -0.796\n"
"   75ARG   HH11 1227  -0.142   1.148  -0.615\n"
"   75ARG   HH12 1228  -0.130   1.255  -0.751\n"
"   75ARG   HH21 1229  -0.093   1.000  -0.982\n"
"   75ARG   HH22 1230  -0.102   1.172  -0.959\n"
"   76GLU      N 1231  -0.543   0.522  -0.758\n"
"   76GLU     CA 1232  -0.654   0.484  -0.848\n"
"   76GLU      C 1233  -0.779   0.469  -0.762\n"
"   76GLU      O 1234  -0.884   0.522  -0.792\n"
"   76GLU     CB 1235  -0.621   0.350  -0.913\n"
"   76GLU     CG 1236  -0.555   0.372  -1.049\n"
"   76GLU     CD 1237  -0.663   0.406  -1.153\n"
"   76GLU    OE1 1238  -0.778   0.373  -1.128\n"
"   76GLU    OE2 1239  -0.629   0.463  -1.255\n"
"   76GLU      H 1240  -0.467   0.461  -0.746\n"
"   76GLU     HA 1241  -0.670   0.559  -0.924\n"
"   76GLU    HB2 1242  -0.552   0.298  -0.849\n"
"   76GLU    HB3 1243  -0.710   0.291  -0.924\n"
"   76GLU    HG2 1244  -0.485   0.454  -1.043\n"
"   76GLU    HG3 1245  -0.504   0.282  -1.079\n"
"   77ALA      N 1246  -0.765   0.400  -0.651\n"
"   77ALA     CA 1247  -0.880   0.386  -0.559\n"
"   77ALA      C 1248  -0.914   0.526  -0.511\n"
"   77ALA      O 1249  -1.029   0.563  -0.500\n"
"   77ALA     CB 1250  -0.840   0.298  -0.440\n"
"   77ALA      H 1251  -0.679   0.362  -0.628\n"
"   77ALA     HA 1252  -0.963   0.343  -0.612\n"
"   77ALA    HB1 1253  -0.798   0.205  -0.477\n"
"   77ALA    HB2 1254  -0.767   0.349  -0.380\n"
"   77ALA    HB3 1255  -0.928   0.276  -0.381\n"
"   78LYS      N 1256  -0.813   0.606  -0.488\n"
"   78LYS     CA 1257  -0.838   0.746  -0.446\n"
"   78LYS      C 1258  -0.920   0.812  -0.556\n"
"   78LYS      O 1259  -0.999   0.902  -0.534\n"
"   78LYS     CB 1260  -0.704   0.819  -0.437\n"
"   78LYS     CG 1261  -0.708   0.922  -0.325\n"
"   78LYS     CD 1262  -0.717   1.062  -0.386\n"
"   78LYS     CE 1263  -0.722   1.166  -0.274\n"
"   78LYS     NZ 1264  -0.635   1.282  -0.311\n"
"   78LYS      H 1265  -0.720   0.574  -0.501\n"
"   78LYS     HA 1266  -0.890   0.750  -0.352\n"
"   78LYS    HB2 1267  -0.626   0.747  -0.419\n"
"   78LYS    HB3 1268  -0.685   0.869  -0.531\n"
"   78LYS    HG2 1269  -0.794   0.904  -0.262\n"
"   78LYS    HG3 1270  -0.618   0.914  -0.266\n"
"   78LYS    HD2 1271  -0.631   1.080  -0.448\n"
"   78LYS    HD3 1272  -0.807   1.069  -0.445\n"
"   78LYS    HE2 1273  -0.823   1.200  -0.260\n"
"   78LYS    HE3 1274  -0.685   1.122  -0.182\n"
"   78LYS    HZ1 1275  -0.594   1.266  -0.405\n"
"   78LYS    HZ2 1276  -0.693   1.369  -0.313\n"
"   78LYS    HZ3 1277  -0.559   1.293  -0.241\n"
"   79ALA      N 1278  -0.898   0.766  -0.676\n"
"   79ALA     CA 1279  -0.969   0.820  -0.793\n"
"   79ALA      C 1280  -1.111   0.765  -0.797\n"
"   79ALA      O 1281  -1.203   0.826  -0.848\n"
"   79ALA     CB 1282  -0.892   0.776  -0.917\n"
"   79ALA      H 1283  -0.833   0.695  -0.688\n"
"   79ALA     HA 1284  -0.971   0.927  -0.788\n"
"   79ALA    HB1 1285  -0.786   0.783  -0.897\n"
"   79ALA    HB2 1286  -0.917   0.673  -0.940\n"
"   79ALA    HB3 1287  -0.917   0.839  -1.001\n"
"   80GLU      N 1288  -1.128   0.647  -0.744\n"
"   80GLU     CA 1289  -1.262   0.583  -0.743\n"
"   80GLU      C 1290  -1.359   0.663  -0.654\n"
"   80GLU      O 1291  -1.476   0.633  -0.648\n"
"   80GLU     CB 1292  -1.247   0.442  -0.687\n"
"   80GLU     CG 1293  -1.208   0.347  -0.799\n"
"   80GLU     CD 1294  -1.334   0.288  -0.863\n"
"   80GLU    OE1 1295  -1.393   0.354  -0.946\n"
"   80GLU    OE2 1296  -1.369   0.176  -0.827\n"
"   80GLU      H 1297  -1.053   0.600  -0.705\n"
"   80GLU     HA 1298  -1.300   0.578  -0.843\n"
"   80GLU    HB2 1299  -1.169   0.442  -0.611\n"
"   80GLU    HB3 1300  -1.339   0.409  -0.642\n"
"   80GLU    HG2 1301  -1.152   0.401  -0.874\n"
"   80GLU    HG3 1302  -1.147   0.268  -0.760\n"
"   81GLY      N 1303  -1.310   0.762  -0.586\n"
"   81GLY     CA 1304  -1.399   0.842  -0.497\n"
"   81GLY      C 1305  -1.357   0.819  -0.352\n"
"   81GLY      O 1306  -1.396   0.891  -0.263\n"
"   81GLY      H 1307  -1.214   0.784  -0.591\n"
"   81GLY    HA2 1308  -1.389   0.947  -0.521\n"
"   81GLY    HA3 1309  -1.501   0.811  -0.511\n"
"   82CYS      N 1310  -1.278   0.718  -0.329\n"
"   82CYS     CA 1311  -1.232   0.689  -0.191\n"
"   82CYS      C 1312  -1.148   0.806  -0.140\n"
"   82CYS      O 1313  -1.098   0.885  -0.216\n"
"   82CYS     CB 1314  -1.148   0.561  -0.192\n"
"   82CYS     SG 1315  -1.257   0.417  -0.182\n"
"   82CYS      H 1316  -1.247   0.661  -0.403\n"
"   82CYS     HA 1317  -1.318   0.675  -0.126\n"
"   82CYS    HB2 1318  -1.091   0.557  -0.283\n"
"   82CYS    HB3 1319  -1.081   0.562  -0.108\n"
"   82CYS     HG 1320  -1.273   0.386  -0.271\n"
"   83ASP      N 1321  -1.132   0.817  -0.010\n"
"   83ASP     CA 1322  -1.051   0.930   0.044\n"
"   83ASP      C 1323  -0.919   0.877   0.101\n"
"   83ASP      O 1324  -0.893   0.884   0.220\n"
"   83ASP     CB 1325  -1.130   0.998   0.155\n"
"   83ASP     CG 1326  -1.071   1.136   0.183\n"
"   83ASP    OD1 1327  -0.978   1.144   0.262\n"
"   83ASP    OD2 1328  -1.119   1.232   0.125\n"
"   83ASP      H 1329  -1.173   0.753   0.050\n"
"   83ASP     HA 1330  -1.031   1.001  -0.034\n"
"   83ASP    HB2 1331  -1.233   1.009   0.124\n"
"   83ASP    HB3 1332  -1.126   0.938   0.245\n"
"   84ILE      N 1333  -0.834   0.824   0.017\n"
"   84ILE     CA 1334  -0.703   0.772   0.065\n"
"   84ILE      C 1335  -0.596   0.882   0.050\n"
"   84ILE      O 1336  -0.529   0.891  -0.050\n"
"   84ILE     CB 1337  -0.662   0.651  -0.019\n"
"   84ILE    CG1 1338  -0.755   0.535   0.012\n"
"   84ILE    CG2 1339  -0.518   0.611   0.013\n"
"   84ILE    CD1 1340  -0.805   0.476  -0.120\n"
"   84ILE      H 1341  -0.856   0.820  -0.079\n"
"   84ILE     HA 1342  -0.711   0.742   0.169\n"
"   84ILE     HB 1343  -0.670   0.676  -0.124\n"
"   84ILE   HG12 1344  -0.700   0.459   0.067\n"
"   84ILE   HG13 1345  -0.839   0.569   0.070\n"
"   84ILE   HG21 1346  -0.470   0.691   0.067\n"
"   84ILE   HG22 1347  -0.518   0.522   0.074\n"
"   84ILE   HG23 1348  -0.465   0.592  -0.079\n"
"   84ILE   HD11 1349  -0.747   0.516  -0.201\n"
"   84ILE   HD12 1350  -0.794   0.369  -0.117\n"
"   84ILE   HD13 1351  -0.909   0.502  -0.133\n"
"   85THR      N 1352  -0.581   0.966   0.149\n"
"   85THR     CA 1353  -0.480   1.075   0.140\n"
"   85THR      C 1354  -0.343   1.016   0.105\n"
"   85THR      O 1355  -0.272   0.966   0.190\n"
"   85THR     CB 1356  -0.470   1.147   0.275\n"
"   85THR    OG1 1357  -0.586   1.227   0.294\n"
"   85THR    CG2 1358  -0.346   1.236   0.277\n"
"   85THR      H 1359  -0.637   0.957   0.229\n"
"   85THR     HA 1360  -0.509   1.145   0.064\n"
"   85THR     HB 1361  -0.463   1.074   0.354\n"
"   85THR    HG1 1362  -0.613   1.218   0.386\n"
"   85THR   HG21 1363  -0.315   1.257   0.176\n"
"   85THR   HG22 1364  -0.369   1.329   0.328\n"
"   85THR   HG23 1365  -0.266   1.185   0.330\n"
"   86ILE      N 1366  -0.305   1.021  -0.020\n"
"   86ILE     CA 1367  -0.173   0.965  -0.060\n"
"   86ILE      C 1368  -0.061   1.058  -0.012\n"
"   86ILE      O 1369  -0.049   1.171  -0.056\n"
"   86ILE     CB 1370  -0.167   0.954  -0.213\n"
"   86ILE    CG1 1371  -0.282   0.867  -0.262\n"
"   86ILE    CG2 1372  -0.033   0.891  -0.254\n"
"   86ILE    CD1 1373  -0.261   0.722  -0.217\n"
"   86ILE      H 1374  -0.363   1.062  -0.087\n"
"   86ILE     HA 1375  -0.160   0.868  -0.016\n"
"   86ILE     HB 1376  -0.175   1.053  -0.256\n"
"   86ILE   HG12 1377  -0.375   0.904  -0.221\n"
"   86ILE   HG13 1378  -0.286   0.870  -0.370\n"
"   86ILE   HG21 1379   0.045   0.927  -0.188\n"
"   86ILE   HG22 1380  -0.040   0.784  -0.247\n"
"   86ILE   HG23 1381  -0.010   0.920  -0.356\n"
"   86ILE   HD11 1382  -0.210   0.721  -0.122\n"
"   86ILE   HD12 1383  -0.357   0.674  -0.206\n"
"   86ILE   HD13 1384  -0.202   0.670  -0.290\n"
"   87ILE      N 1385   0.021   1.012   0.079\n"
"   87ILE     CA 1386   0.132   1.098   0.129\n"
"   87ILE      C 1387   0.266   1.037   0.086\n"
"   87ILE      O 1388   0.313   0.941   0.144\n"
"   87ILE     CB 1389   0.125   1.107   0.281\n"
"   87ILE    CG1 1390   0.009   1.199   0.321\n"
"   87ILE    CG2 1391   0.256   1.164   0.336\n"
"   87ILE    CD1 1392  -0.024   1.180   0.469\n"
"   87ILE      H 1393   0.010   0.921   0.113\n"
"   87ILE     HA 1394   0.123   1.197   0.086\n"
"   87ILE     HB 1395   0.108   1.009   0.322\n"
"   87ILE   HG12 1396   0.038   1.302   0.303\n"
"   87ILE   HG13 1397  -0.078   1.176   0.261\n"
"   87ILE   HG21 1398   0.304   1.223   0.260\n"
"   87ILE   HG22 1399   0.235   1.226   0.422\n"
"   87ILE   HG23 1400   0.321   1.083   0.365\n"
"   87ILE   HD11 1401   0.068   1.169   0.525\n"
"   87ILE   HD12 1402  -0.078   1.266   0.505\n"
"   87ILE   HD13 1403  -0.084   1.092   0.481\n"
"   88LEU      N 1404   0.326   1.090  -0.017\n"
"   88LEU     CA 1405   0.455   1.035  -0.066\n"
"   88LEU      C 1406   0.573   1.115  -0.009\n"
"   88LEU      O 1407   0.598   1.226  -0.049\n"
"   88LEU     CB 1408   0.456   1.041  -0.217\n"
"   88LEU     CG 1409   0.365   0.930  -0.267\n"
"   88LEU    CD1 1410   0.269   0.985  -0.370\n"
"   88LEU    CD2 1411   0.450   0.819  -0.329\n"
"   88LEU      H 1412   0.285   1.166  -0.063\n"
"   88LEU     HA 1413   0.463   0.931  -0.038\n"
"   88LEU    HB2 1414   0.418   1.137  -0.250\n"
"   88LEU    HB3 1415   0.556   1.026  -0.255\n"
"   88LEU     HG 1416   0.309   0.890  -0.184\n"
"   88LEU   HD11 1417   0.314   1.070  -0.418\n"
"   88LEU   HD12 1418   0.247   0.909  -0.443\n"
"   88LEU   HD13 1419   0.179   1.016  -0.320\n"
"   88LEU   HD21 1420   0.553   0.836  -0.304\n"
"   88LEU   HD22 1421   0.418   0.724  -0.289\n"
"   88LEU   HD23 1422   0.438   0.820  -0.436\n"
"   89SER      N 1423   0.645   1.058   0.084\n"
"   89SER     CA 1424   0.760   1.131   0.144\n"
"   89SER      C 1425   0.891   1.066   0.097\n"
"   89SER      O 1426   0.893   0.945   0.085\n"
"   89SER     CB 1427   0.752   1.124   0.296\n"
"   89SER     OG 1428   0.725   1.254   0.347\n"
"   89SER    OXT 1429   0.986   1.139   0.073\n"
"   89SER      H 1430   0.622   0.968   0.115\n"
"   89SER     HA 1431   0.758   1.234   0.112\n"
"   89SER    HB2 1432   0.673   1.057   0.325\n"
"   89SER    HB3 1433   0.846   1.088   0.336\n"
"   89SER     HG 1434   0.666   1.244   0.423\n"
"   0.10000   0.10000   0.10000\n";


